/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_ARBADVANCEDDLG_H__157C7A00_7D84_11D2_B907_004005A3C9E9__INCLUDED_)
#define AFX_ARBADVANCEDDLG_H__157C7A00_7D84_11D2_B907_004005A3C9E9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ARBAdvancedDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CARBAdvancedDlg dialog

class CARBAdvancedDlg : public CDialog
{
// Construction
public:
	long MaxSamples;
	int SamplePtr;
	long SampleValues[10];
	int DacPtr;
	double DacRates[8];
	BOOL OnInitDialog();
	long SamplesFixed;
	long FilterFixed;
	long DacFixed;
	int Filter;
	double DACRate;
	double Samples;
	CARBAdvancedDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CARBAdvancedDlg)
	enum { IDD = IDD_ARBADVANCEDDLG };
	CComboBox	m_NDPCombo;
	CComboBox	m_FilterCombo;
	CComboBox	m_DACCombo;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CARBAdvancedDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CARBAdvancedDlg)
	afx_msg void OnSelchangeSamplescombo();
	afx_msg void OnSelchangeFiltercombo();
	afx_msg void OnSelchangeDacratecombo();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ARBADVANCEDDLG_H__157C7A00_7D84_11D2_B907_004005A3C9E9__INCLUDED_)
