// AcquireScansDlg.cpp : implementation file
//
/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "stdafx.h"
#include "Buda.h"
#include "AcquireScansDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAcquireScansDlg dialog


CAcquireScansDlg::CAcquireScansDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAcquireScansDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAcquireScansDlg)
	m_NumScans = 0;
	m_NumSpectra = 0;
	m_DisplaySpectra = FALSE;
	//}}AFX_DATA_INIT
}


void CAcquireScansDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAcquireScansDlg)
	DDX_Control(pDX, IDOK, m_Okbtn);
	DDX_Control(pDX, IDCANCEL, m_Cancelbtn);
	DDX_Control(pDX, IDC_DISPSPEC_CHK, m_DispCheckbtn);
	DDX_Control(pDX, IDC_NUMSPECSTATIC, m_NumSpecStatic);
	DDX_Control(pDX, IDC_SPECTRA, m_ShowSpec);
	DDX_Control(pDX, IDC_SPEC500, m_Spec500);
	DDX_Control(pDX, IDC_SPEC50, m_Spec50);
	DDX_Control(pDX, IDC_SPEC5, m_Spec5);
	DDX_Control(pDX, IDC_SPEC200, m_Spec200);
	DDX_Control(pDX, IDC_SPEC20, m_Spec20);
	DDX_Control(pDX, IDC_SPEC100, m_Spec100);
	DDX_Control(pDX, IDC_SPEC10, m_Spec10);
	DDX_Control(pDX, IDC_SPEC1, m_Spec1);
	DDX_Text(pDX, IDC_SCANS, m_NumScans);
	DDV_MinMaxLong(pDX, m_NumScans, 1, 10000);
	DDX_Text(pDX, IDC_SPECTRA, m_NumSpectra);
	DDV_MinMaxLong(pDX, m_NumSpectra, 1, 10000);
	DDX_Check(pDX, IDC_DISPSPEC_CHK, m_DisplaySpectra);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAcquireScansDlg, CDialog)
	//{{AFX_MSG_MAP(CAcquireScansDlg)
	ON_BN_CLICKED(IDC_SCAN1, OnScan1)
	ON_BN_CLICKED(IDC_SCAN10, OnScan10)
	ON_BN_CLICKED(IDC_SCAN100, OnScan100)
	ON_BN_CLICKED(IDC_SCAN20, OnScan20)
	ON_BN_CLICKED(IDC_SCAN200, OnScan200)
	ON_BN_CLICKED(IDC_SCAN5, OnScan5)
	ON_BN_CLICKED(IDC_SCAN50, OnScan50)
	ON_BN_CLICKED(IDC_SCAN500, OnScan500)
	ON_EN_KILLFOCUS(IDC_SCANS, OnKillfocusScans)
	ON_BN_CLICKED(IDC_SPEC1, OnSpec1)
	ON_BN_CLICKED(IDC_SPEC10, OnSpec10)
	ON_BN_CLICKED(IDC_SPEC100, OnSpec100)
	ON_BN_CLICKED(IDC_SPEC20, OnSpec20)
	ON_BN_CLICKED(IDC_SPEC200, OnSpec200)
	ON_BN_CLICKED(IDC_SPEC5, OnSpec5)
	ON_BN_CLICKED(IDC_SPEC50, OnSpec50)
	ON_BN_CLICKED(IDC_SPEC500, OnSpec500)
	ON_EN_KILLFOCUS(IDC_SPECTRA, OnKillfocusSpectra)
	ON_BN_CLICKED(IDC_DISPSPEC_CHK, OnDispspecChk)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAcquireScansDlg message handlers

void CAcquireScansDlg::OnScan1() 
{
	m_NumScans = 1;
	UpdateData(FALSE);
}

void CAcquireScansDlg::OnScan10() 
{
	m_NumScans = 10;
	UpdateData(FALSE);
}

void CAcquireScansDlg::OnScan100() 
{
	m_NumScans = 100;
	UpdateData(FALSE);
}

void CAcquireScansDlg::OnScan20() 
{
	m_NumScans = 20;
	UpdateData(FALSE);
}

void CAcquireScansDlg::OnScan200() 
{
	m_NumScans = 200;
	UpdateData(FALSE);
}

void CAcquireScansDlg::OnScan5() 
{
	m_NumScans = 5;
	UpdateData(FALSE);
}

void CAcquireScansDlg::OnScan50() 
{
	m_NumScans = 50;
	UpdateData(FALSE);
}

void CAcquireScansDlg::OnScan500() 
{
	m_NumScans = 500;
	UpdateData(FALSE);
}

void CAcquireScansDlg::OnKillfocusScans() 
{
	UpdateData(TRUE);
}

void CAcquireScansDlg::OnSpec1() 
{
	m_NumSpectra = 1;
	UpdateData(FALSE);
}

void CAcquireScansDlg::OnSpec10() 
{
	m_NumSpectra = 10;
	UpdateData(FALSE);
}

void CAcquireScansDlg::OnSpec100() 
{
	m_NumSpectra = 100;
	UpdateData(FALSE);
}

void CAcquireScansDlg::OnSpec20() 
{
	m_NumSpectra = 20;
	UpdateData(FALSE);
}

void CAcquireScansDlg::OnSpec200() 
{
	m_NumSpectra = 200;
	UpdateData(FALSE);
}

void CAcquireScansDlg::OnSpec5() 
{
	m_NumSpectra = 5;
	UpdateData(FALSE);
}

void CAcquireScansDlg::OnSpec50() 
{
	m_NumSpectra = 50;
	UpdateData(FALSE);
}

void CAcquireScansDlg::OnSpec500() 
{
	m_NumSpectra = 500;
	UpdateData(FALSE);
}

void CAcquireScansDlg::OnKillfocusSpectra() 
{
	// TODO: Add your control notification handler code here
	
}

void CAcquireScansDlg::OnOK() 
{
	CDialog::OnOK();
}

void CAcquireScansDlg::OnDispspecChk() 
{
	m_DisplaySpectra = 	m_DisplaySpectra;
}

BOOL CAcquireScansDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_NumScans = 1;
	m_NumSpectra = 1;
	m_DisplaySpectra = TRUE;
	UpdateData(FALSE);

	CRect TallWindow,ShortWindow;
	GetWindowRect(&TallWindow);
	int InitialHeight = TallWindow.Height();
	int ShortHeight = InitialHeight-80;
	int delta = InitialHeight-ShortHeight;
	ShortWindow = CRect(TallWindow.left, TallWindow.top, TallWindow.right, TallWindow.bottom-delta);
	
	CRect OkTall, OkShort, CancelTall, CancelShort;
	m_Okbtn.GetWindowRect(&OkTall);
	m_Cancelbtn.GetWindowRect(&CancelTall);
	OkShort = CRect(OkTall.left-TallWindow.left, (OkTall.top-TallWindow.top-OkTall.Height())-delta, 
		OkTall.right-TallWindow.left, (OkTall.bottom-TallWindow.top-OkTall.Height())-delta);
	OkTall = CRect(OkTall.left-TallWindow.left, (OkTall.top-TallWindow.top-OkTall.Height()), 
		OkTall.right-TallWindow.left, (OkTall.bottom-TallWindow.top-OkTall.Height()));
	CancelShort = CRect(CancelTall.left-TallWindow.left, (CancelTall.top-TallWindow.top-CancelTall.Height())-delta, 
		CancelTall.right-TallWindow.left, (CancelTall.bottom-TallWindow.top-CancelTall.Height())-delta);
	CancelTall = CRect(CancelTall.left-TallWindow.left, (CancelTall.top-TallWindow.top-CancelTall.Height()), 
		CancelTall.right-TallWindow.left, (CancelTall.bottom-TallWindow.top-CancelTall.Height()));

	if(pDoc->PS.ScanMode != PROFILE) {
		// make all spectra buttons invisible.
		m_Spec1.ShowWindow(SW_HIDE);
		m_Spec10.ShowWindow(SW_HIDE);
		m_Spec100.ShowWindow(SW_HIDE);
		m_Spec20.ShowWindow(SW_HIDE);
		m_Spec200.ShowWindow(SW_HIDE);
		m_Spec5.ShowWindow(SW_HIDE);
		m_Spec50.ShowWindow(SW_HIDE);
		m_Spec500.ShowWindow(SW_HIDE);
		m_ShowSpec.ShowWindow(SW_HIDE);
		m_DispCheckbtn.ShowWindow(SW_HIDE);
		m_NumSpecStatic.ShowWindow(SW_HIDE);
		// move the ok and cancel buttons up
		m_Okbtn.MoveWindow(&OkShort,TRUE);
		m_Cancelbtn.MoveWindow(CancelShort,TRUE);
		// resize the dlg window
		MoveWindow(ShortWindow);
	} else {
		// make all spectra buttons visible.
		m_Spec1.ShowWindow(SW_SHOW);
		m_Spec10.ShowWindow(SW_SHOW);
		m_Spec100.ShowWindow(SW_SHOW);
		m_Spec20.ShowWindow(SW_SHOW);
		m_Spec200.ShowWindow(SW_SHOW);
		m_Spec5.ShowWindow(SW_SHOW);
		m_Spec50.ShowWindow(SW_SHOW);
		m_Spec500.ShowWindow(SW_SHOW);
		m_ShowSpec.ShowWindow(SW_SHOW);
		m_DispCheckbtn.ShowWindow(SW_SHOW);
		m_NumSpecStatic.ShowWindow(SW_SHOW);
		// move the ok and cancel buttons down
		m_Okbtn.MoveWindow(OkTall);
		m_Cancelbtn.MoveWindow(CancelTall);
		// resize the dlg window
		MoveWindow(TallWindow);
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAcquireScansDlg::OnClose() 
{
	return;	// must use ok or cancel
}
