/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_ACQUIRESCANSDLG_H__2374F1C0_C70B_11D2_B907_004005A3C9E9__INCLUDED_)
#define AFX_ACQUIRESCANSDLG_H__2374F1C0_C70B_11D2_B907_004005A3C9E9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// AcquireScansDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CAcquireScansDlg dialog

class CAcquireScansDlg : public CDialog
{
// Construction
public:
	CBudaDoc* pDoc;
	CAcquireScansDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CAcquireScansDlg)
	enum { IDD = IDD_ACQUIRE };
	CButton	m_Okbtn;
	CButton	m_Cancelbtn;
	CButton	m_DispCheckbtn;
	CStatic	m_NumSpecStatic;
	CEdit	m_ShowSpec;
	CButton	m_Spec500;
	CButton	m_Spec50;
	CButton	m_Spec5;
	CButton	m_Spec200;
	CButton	m_Spec20;
	CButton	m_Spec100;
	CButton	m_Spec10;
	CButton	m_Spec1;
	long	m_NumScans;
	long	m_NumSpectra;
	BOOL	m_DisplaySpectra;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAcquireScansDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CAcquireScansDlg)
	afx_msg void OnScan1();
	afx_msg void OnScan10();
	afx_msg void OnScan100();
	afx_msg void OnScan20();
	afx_msg void OnScan200();
	afx_msg void OnScan5();
	afx_msg void OnScan50();
	afx_msg void OnScan500();
	afx_msg void OnKillfocusScans();
	afx_msg void OnSpec1();
	afx_msg void OnSpec10();
	afx_msg void OnSpec100();
	afx_msg void OnSpec20();
	afx_msg void OnSpec200();
	afx_msg void OnSpec5();
	afx_msg void OnSpec50();
	afx_msg void OnSpec500();
	afx_msg void OnKillfocusSpectra();
	virtual void OnOK();
	afx_msg void OnDispspecChk();
	virtual BOOL OnInitDialog();
	afx_msg void OnClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ACQUIRESCANSDLG_H__2374F1C0_C70B_11D2_B907_004005A3C9E9__INCLUDED_)
