// AddARBWindowDlg.cpp : implementation file
//
/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "stdafx.h"
#include "Buda.h"
#include "AddARBWindowDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAddARBWindowDlg dialog


CAddARBWindowDlg::CAddARBWindowDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAddARBWindowDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAddARBWindowDlg)
	m_Amplitude = 100.0;
	m_CenterMass = 0.0;
	m_DeltaMass = 0.0;
	m_HiMass = 0.0;
	m_LowMass = 0.0;
	//}}AFX_DATA_INIT
}


void CAddARBWindowDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddARBWindowDlg)
	DDX_Text(pDX, IDC_AMPLITUDE, m_Amplitude);
	DDX_Text(pDX, IDC_CENTERMASS, m_CenterMass);
	DDX_Text(pDX, IDC_DELTAMASS, m_DeltaMass);
	DDX_Text(pDX, IDC_HIMASS, m_HiMass);
	DDX_Text(pDX, IDC_LOWMASS, m_LowMass);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddARBWindowDlg, CDialog)
	//{{AFX_MSG_MAP(CAddARBWindowDlg)
	ON_EN_KILLFOCUS(IDC_CENTERMASS, OnChangeCentermass)
	ON_EN_KILLFOCUS(IDC_LOWMASS, OnChangeLowmass)
	ON_EN_KILLFOCUS(IDC_HIMASS, OnChangeHimass)
	ON_EN_KILLFOCUS(IDC_DELTAMASS, OnChangeDeltamass)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddARBWindowDlg message handlers

void CAddARBWindowDlg::OnChangeCentermass() 
{
	UpdateData(TRUE);
	m_HiMass = m_CenterMass+m_DeltaMass;
	m_LowMass = m_CenterMass-m_DeltaMass;
	UpdateData(FALSE);
}

void CAddARBWindowDlg::OnChangeLowmass() 
{
	UpdateData(TRUE);
	m_CenterMass = (m_HiMass+m_LowMass)/2;
	m_DeltaMass = (m_HiMass-m_LowMass)/2;
	UpdateData(FALSE);
}

void CAddARBWindowDlg::OnChangeHimass() 
{
	UpdateData(TRUE);
	m_CenterMass = (m_HiMass+m_LowMass)/2;
	m_DeltaMass = (m_HiMass-m_LowMass)/2;
	UpdateData(FALSE);
}

void CAddARBWindowDlg::OnChangeDeltamass() 
{
	UpdateData(TRUE);
	m_HiMass = m_CenterMass+m_DeltaMass;
	m_LowMass = m_CenterMass-m_DeltaMass;
	UpdateData(FALSE);
}
