/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_ADDPEAKDLG_H__26478AA2_A6B1_11D1_9106_44455354616F__INCLUDED_)
#define AFX_ADDPEAKDLG_H__26478AA2_A6B1_11D1_9106_44455354616F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// AddPeakDlg.h : header file
//
#include "BudaDoc.h"

struct CalibrantData {
	double mass;
	CString str;
};

/////////////////////////////////////////////////////////////////////////////
// CAddPeakDlg dialog

class CAddPeakDlg : public CDialog
{
// Construction
public:
	void UpdateCalibrantList();
	CString path;
	int OpenCBTFile();
	CString CalibrntFileName;
	int ParseCalibrantLine(CString*);
	CBudaDoc* PDoc;
	CFont m_font;
	void SetListBoxFont();
	BOOL IsOK;
	int MIindex;
	CString Description;
	long NumCalibrants;
	//double calbrntmass[MAX_CALIBRANT_LIST];
	struct CalibrantData Calibrant[MAX_CALIBRANT_LIST];
	struct FITableElement* FITable;
	struct PS * PS;
	BOOL OnInitDialog();
	CAddPeakDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CAddPeakDlg)
	enum { IDD = IDD_ADD_PEAK };
	CButton	m_OpenCalFileBtn;
	CListBox	m_PeakList;
	CListBox	m_CalFileList;
	double	m_ExactMass;
	CString	m_CalFileName;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAddPeakDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CAddPeakDlg)
	afx_msg void OnApply();
	afx_msg void OnCancel();
	afx_msg void OnSelchangePeakList();
	afx_msg void OnAddToCalFile();
	afx_msg void OnCalSortMitable();
	afx_msg void OnOpenCalfile();
	afx_msg void OnSelchangeCalfileList();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ADDPEAKDLG_H__26478AA2_A6B1_11D1_9106_44455354616F__INCLUDED_)
