// AddToCalbrntFileDlg.cpp : implementation file
//
/*

  AddToCalibrntFileDlg.cpp is the code that controls the CAddToCalbrntFileDlg Class
This class allows the user to add custom mass peaks with a description to the 
current Calibrant file.

*/
/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "BudaMaster.h"
#include "BudaDoc.h"
#include "AddToCalbrntFileDlg.h"
#include "AddPeakDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAddToCalbrntFileDlg dialog


CAddToCalbrntFileDlg::CAddToCalbrntFileDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAddToCalbrntFileDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAddToCalbrntFileDlg)
	m_Description = _T("");
	m_ExactMass = 0.0;
	//}}AFX_DATA_INIT
}


void CAddToCalbrntFileDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddToCalbrntFileDlg)
	DDX_Text(pDX, IDC_DESCRIPTION, m_Description);
	DDV_MaxChars(pDX, m_Description, 64);
	DDX_Text(pDX, IDC_EXACT_MASS, m_ExactMass);
	DDV_MinMaxDouble(pDX, m_ExactMass, 0., 99999.);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddToCalbrntFileDlg, CDialog)
	//{{AFX_MSG_MAP(CAddToCalbrntFileDlg)
	ON_EN_KILLFOCUS(IDC_EXACT_MASS, OnKillfocusExactMass)
	ON_EN_KILLFOCUS(IDC_DESCRIPTION, OnKillfocusDescription)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddToCalbrntFileDlg message handlers

void CAddToCalbrntFileDlg::OnOK() 
{
	int i = CheckDescription();

	if (i) {
		IsOK = TRUE;	
		AddOK = TRUE;
		CDialog::OnOK();
	}
}

void CAddToCalbrntFileDlg::OnCancel() 
{
	IsOK = FALSE;
	AddOK = FALSE;
	CDialog::OnCancel();
}

void CAddToCalbrntFileDlg::OnKillfocusExactMass() 
{
	//CString temp;
	//temp = (CString)m_ExactMass;
	//BOOL	HasDecimal = FALSE;

	/*
	//see where deciaml point is
	for (int i=0;i<temp->GetLength();i++) {
		if (temp[i] == ".") {
			HasDecimal = TRUE;
			break;
		}
	}
	*/


}

void CAddToCalbrntFileDlg::OnKillfocusDescription() 
{
	int i = CheckDescription();
	i=i;
}


int CAddToCalbrntFileDlg::CheckDescription()
{
	UpdateData(TRUE);
	int k = m_Description.GetLength();
	if (k < 1) {
		MessageBox("Please enter a description","Invalid Description");
		return 0;
	}
	
	return 1;
}
