// AdjustDacInitDlg.cpp : implementation file
//
/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "stdafx.h"
#include "Buda.h"
#include "AdjustDacInitDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAdjustDacInitDlg dialog


CAdjustDacInitDlg::CAdjustDacInitDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAdjustDacInitDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAdjustDacInitDlg)
	//}}AFX_DATA_INIT
	int i;
	for(i=0; i<24; i++) {
		m_Dac[i].Name = _T("");
		m_Dac[i].Value = 0.0;
		m_Dac[i].Eventnum = -1;
	}

}

void CAdjustDacInitDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAdjustDacInitDlg)
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_DACEDIT1, m_Dac[0].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL1, m_Dac[1-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL1, m_Dac[1-1].Name);
	DDX_Text(pDX, IDC_DACEDIT1, m_Dac[1-1].Value);

	DDX_Control(pDX, IDC_DACEDIT2, m_Dac[2-1].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL2, m_Dac[2-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL2, m_Dac[2-1].Name);
	DDX_Text(pDX, IDC_DACEDIT2, m_Dac[2-1].Value);

	DDX_Control(pDX, IDC_DACEDIT3, m_Dac[3-1].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL3, m_Dac[3-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL3, m_Dac[3-1].Name);
	DDX_Text(pDX, IDC_DACEDIT3, m_Dac[3-1].Value);

	DDX_Control(pDX, IDC_DACEDIT4, m_Dac[4-1].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL4, m_Dac[4-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL4, m_Dac[4-1].Name);
	DDX_Text(pDX, IDC_DACEDIT4, m_Dac[4-1].Value);

	DDX_Control(pDX, IDC_DACEDIT5, m_Dac[5-1].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL5, m_Dac[5-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL5, m_Dac[5-1].Name);
	DDX_Text(pDX, IDC_DACEDIT5, m_Dac[5-1].Value);

	DDX_Control(pDX, IDC_DACEDIT6, m_Dac[6-1].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL6, m_Dac[6-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL6, m_Dac[6-1].Name);
	DDX_Text(pDX, IDC_DACEDIT6, m_Dac[6-1].Value);

	DDX_Control(pDX, IDC_DACEDIT7, m_Dac[7-1].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL7, m_Dac[7-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL7, m_Dac[7-1].Name);
	DDX_Text(pDX, IDC_DACEDIT7, m_Dac[7-1].Value);

	DDX_Control(pDX, IDC_DACEDIT8, m_Dac[8-1].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL8, m_Dac[8-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL8, m_Dac[8-1].Name);
	DDX_Text(pDX, IDC_DACEDIT8, m_Dac[8-1].Value);

	DDX_Control(pDX, IDC_DACEDIT9, m_Dac[9-1].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL9, m_Dac[9-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL9, m_Dac[9-1].Name);
	DDX_Text(pDX, IDC_DACEDIT9, m_Dac[9-1].Value);

	DDX_Control(pDX, IDC_DACEDIT10, m_Dac[10-1].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL10, m_Dac[10-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL10, m_Dac[10-1].Name);
	DDX_Text(pDX, IDC_DACEDIT10, m_Dac[10-1].Value);

	DDX_Control(pDX, IDC_DACEDIT11, m_Dac[11-1].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL11, m_Dac[11-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL11, m_Dac[11-1].Name);
	DDX_Text(pDX, IDC_DACEDIT11, m_Dac[11-1].Value);

	DDX_Control(pDX, IDC_DACEDIT12, m_Dac[12-1].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL12, m_Dac[12-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL12, m_Dac[12-1].Name);
	DDX_Text(pDX, IDC_DACEDIT12, m_Dac[12-1].Value);

	DDX_Control(pDX, IDC_DACEDIT13, m_Dac[13-1].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL13, m_Dac[13-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL13, m_Dac[13-1].Name);
	DDX_Text(pDX, IDC_DACEDIT13, m_Dac[13-1].Value);

	DDX_Control(pDX, IDC_DACEDIT14, m_Dac[14-1].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL14, m_Dac[14-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL14, m_Dac[14-1].Name);
	DDX_Text(pDX, IDC_DACEDIT14, m_Dac[14-1].Value);

	DDX_Control(pDX, IDC_DACEDIT15, m_Dac[15-1].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL15, m_Dac[15-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL15, m_Dac[15-1].Name);
	DDX_Text(pDX, IDC_DACEDIT15, m_Dac[15-1].Value);

	DDX_Control(pDX, IDC_DACEDIT16, m_Dac[16-1].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL16, m_Dac[16-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL16, m_Dac[16-1].Name);
	DDX_Text(pDX, IDC_DACEDIT16, m_Dac[16-1].Value);

	DDX_Control(pDX, IDC_DACEDIT17, m_Dac[17-1].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL17, m_Dac[17-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL17, m_Dac[17-1].Name);
	DDX_Text(pDX, IDC_DACEDIT17, m_Dac[17-1].Value);

	DDX_Control(pDX, IDC_DACEDIT18, m_Dac[18-1].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL18, m_Dac[18-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL18, m_Dac[18-1].Name);
	DDX_Text(pDX, IDC_DACEDIT18, m_Dac[18-1].Value);

	DDX_Control(pDX, IDC_DACEDIT19, m_Dac[19-1].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL19, m_Dac[19-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL19, m_Dac[19-1].Name);
	DDX_Text(pDX, IDC_DACEDIT19, m_Dac[19-1].Value);

	DDX_Control(pDX, IDC_DACEDIT20, m_Dac[20-1].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL20, m_Dac[20-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL20, m_Dac[20-1].Name);
	DDX_Text(pDX, IDC_DACEDIT20, m_Dac[20-1].Value);

	DDX_Control(pDX, IDC_DACEDIT21, m_Dac[21-1].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL21, m_Dac[21-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL21, m_Dac[21-1].Name);
	DDX_Text(pDX, IDC_DACEDIT21, m_Dac[21-1].Value);

	DDX_Control(pDX, IDC_DACEDIT22, m_Dac[22-1].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL22, m_Dac[22-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL22, m_Dac[22-1].Name);
	DDX_Text(pDX, IDC_DACEDIT22, m_Dac[22-1].Value);

	DDX_Control(pDX, IDC_DACEDIT23, m_Dac[23-1].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL23, m_Dac[23-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL23, m_Dac[23-1].Name);
	DDX_Text(pDX, IDC_DACEDIT23, m_Dac[23-1].Value);

	DDX_Control(pDX, IDC_DACEDIT24, m_Dac[24-1].Edit);
	DDX_Control(pDX, IDC_DACCHANNEL24, m_Dac[24-1].Ctrl);
	DDX_Text(pDX, IDC_DACCHANNEL24, m_Dac[24-1].Name);
	DDX_Text(pDX, IDC_DACEDIT24, m_Dac[24-1].Value);

}


BEGIN_MESSAGE_MAP(CAdjustDacInitDlg, CDialog)
	//{{AFX_MSG_MAP(CAdjustDacInitDlg)
	ON_WM_CLOSE()
	ON_EN_KILLFOCUS(IDC_DACEDIT1, OnKillfocusDacedit1)
	ON_EN_KILLFOCUS(IDC_DACEDIT10, OnKillfocusDacedit10)
	ON_EN_KILLFOCUS(IDC_DACEDIT11, OnKillfocusDacedit11)
	ON_EN_KILLFOCUS(IDC_DACEDIT12, OnKillfocusDacedit12)
	ON_EN_KILLFOCUS(IDC_DACEDIT13, OnKillfocusDacedit13)
	ON_EN_KILLFOCUS(IDC_DACEDIT14, OnKillfocusDacedit14)
	ON_EN_KILLFOCUS(IDC_DACEDIT15, OnKillfocusDacedit15)
	ON_EN_KILLFOCUS(IDC_DACEDIT16, OnKillfocusDacedit16)
	ON_EN_KILLFOCUS(IDC_DACEDIT17, OnKillfocusDacedit17)
	ON_EN_KILLFOCUS(IDC_DACEDIT18, OnKillfocusDacedit18)
	ON_EN_KILLFOCUS(IDC_DACEDIT19, OnKillfocusDacedit19)
	ON_EN_KILLFOCUS(IDC_DACEDIT2, OnKillfocusDacedit2)
	ON_EN_KILLFOCUS(IDC_DACEDIT20, OnKillfocusDacedit20)
	ON_EN_KILLFOCUS(IDC_DACEDIT21, OnKillfocusDacedit21)
	ON_EN_KILLFOCUS(IDC_DACEDIT22, OnKillfocusDacedit22)
	ON_EN_KILLFOCUS(IDC_DACEDIT24, OnKillfocusDacedit24)
	ON_EN_KILLFOCUS(IDC_DACEDIT23, OnKillfocusDacedit23)
	ON_EN_KILLFOCUS(IDC_DACEDIT3, OnKillfocusDacedit3)
	ON_EN_KILLFOCUS(IDC_DACEDIT4, OnKillfocusDacedit4)
	ON_EN_KILLFOCUS(IDC_DACEDIT5, OnKillfocusDacedit5)
	ON_EN_KILLFOCUS(IDC_DACEDIT6, OnKillfocusDacedit6)
	ON_EN_KILLFOCUS(IDC_DACEDIT7, OnKillfocusDacedit7)
	ON_EN_KILLFOCUS(IDC_DACEDIT8, OnKillfocusDacedit8)
	ON_EN_KILLFOCUS(IDC_DACEDIT9, OnKillfocusDacedit9)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAdjustDacInitDlg message handlers

BOOL CAdjustDacInitDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// if the DAC is one that isn't used make invisible it's string
	// and it's edit control.  Otherwise, make visible
	int i;
	CString str = "";
	for(i=0; i<24; i++) {
		if(pDoc->sys->DacAvailable[i]) {
			m_Dac[i].Ctrl.ShowWindow(SW_SHOW);
			m_Dac[i].Edit.ShowWindow(SW_SHOW);
			m_Dac[i].Name = pDoc->sys->ChannelNames[16+i];
			m_Dac[i].Ctrl.SetWindowText(m_Dac[i].Name);
			GetDacInitValue(i);
			str.Format("%1.3f",m_Dac[i].Value);
			m_Dac[i].Edit.SetWindowText(str);
		} else {
			m_Dac[i].Ctrl.ShowWindow(SW_HIDE);
			m_Dac[i].Edit.ShowWindow(SW_HIDE);
		}
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAdjustDacInitDlg::OnClose() 
{
	// do not allow OnClose().  Must use either ok or cancel
	return;	
}

void CAdjustDacInitDlg::OnOK() 
{
	// copy initialization values back to GenPS.	
	int i;
	for(i=0; i<24; i++) {
		pPS->GenPS[m_Dac[i].Eventnum].Value = float(m_Dac[i].Value);
	}
	CDialog::OnOK();
}

void CAdjustDacInitDlg::OnCancel() 
{
	// do nothing	
	CDialog::OnCancel();
}

void CAdjustDacInitDlg::GetDacInitValue(int dacnum)
{
	// search through genps for dac = dacnum and type = dacinit.
	// get the value from there, store the eventnum for the dac.
	int i;
	for(i = 0; i<pPS->NumEvents; i++) {
		if(pPS->GenPS[i].Channel == dacnum + 16 && pPS->GenPS[i].Type == DAC_INIT) {
			m_Dac[dacnum].Eventnum = i;
			m_Dac[dacnum].Value = pPS->GenPS[i].Value;
		}
	}
}

void CAdjustDacInitDlg::OnKillfocusDacedit1() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(0);	
}

void CAdjustDacInitDlg::OnKillfocusDacedit10() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(9);	
}

void CAdjustDacInitDlg::OnKillfocusDacedit11() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(10);	
}

void CAdjustDacInitDlg::OnKillfocusDacedit12() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(11);	
}

void CAdjustDacInitDlg::OnKillfocusDacedit13() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(12);		
}

void CAdjustDacInitDlg::OnKillfocusDacedit14() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(13);	
}

void CAdjustDacInitDlg::OnKillFocus(int dacnum)
{
	CString str;
	double value;
	m_Dac[dacnum].Edit.GetWindowText(str);
	sscanf(str,"%lf",&(value));

	// check to see if value is valid for this dac if not, reset.
	if(value > pDoc->sys->dac[dacnum].MaxValue) {
		str.Format("This DAC is limited to %1.4f Volts.\nReseting value.",pDoc->sys->dac[dacnum].MaxValue);
		MessageBox(str,"Over Voltage!");
		value = m_Dac[dacnum].Value;
	}
	if( value < pDoc->sys->dac[dacnum].MinValue) {
		str.Format("This DAC is limited to %1.4f Volts.\nReseting value.",pDoc->sys->dac[dacnum].MinValue);
		MessageBox(str,"Under Voltage!");
		value = m_Dac[dacnum].Value;
	}
	m_Dac[dacnum].Value = value;
	str.Format("%1.3f",m_Dac[dacnum].Value);
	m_Dac[dacnum].Edit.SetWindowText(str);
}

void CAdjustDacInitDlg::OnKillfocusDacedit15() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(14);	
}

void CAdjustDacInitDlg::OnKillfocusDacedit16() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(15);	
}

void CAdjustDacInitDlg::OnKillfocusDacedit17() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(16);	
}

void CAdjustDacInitDlg::OnKillfocusDacedit18() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(17);	
}

void CAdjustDacInitDlg::OnKillfocusDacedit19() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(18);	
}

void CAdjustDacInitDlg::OnKillfocusDacedit2() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(1);	
}

void CAdjustDacInitDlg::OnKillfocusDacedit20() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(19);	
}

void CAdjustDacInitDlg::OnKillfocusDacedit21() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(20);	
}

void CAdjustDacInitDlg::OnKillfocusDacedit22() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(21);	
}

void CAdjustDacInitDlg::OnKillfocusDacedit24() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(23);	
}

void CAdjustDacInitDlg::OnKillfocusDacedit23() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(22);	
}

void CAdjustDacInitDlg::OnKillfocusDacedit3() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(2);	
}

void CAdjustDacInitDlg::OnKillfocusDacedit4() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(3);	
}

void CAdjustDacInitDlg::OnKillfocusDacedit5() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(4);	
}

void CAdjustDacInitDlg::OnKillfocusDacedit6() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(5);	
}

void CAdjustDacInitDlg::OnKillfocusDacedit7() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(6);	
}

void CAdjustDacInitDlg::OnKillfocusDacedit8() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(7);	
}

void CAdjustDacInitDlg::OnKillfocusDacedit9() 
{
	// this always calls OnKillFocus with value dacnumber-1
	//	to be sure to reference the correct dac array elements
	OnKillFocus(8);	
}
