/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_AUTOSETUP1_H__0521C340_B439_11D2_B907_004005A3C9E9__INCLUDED_)
#define AFX_AUTOSETUP1_H__0521C340_B439_11D2_B907_004005A3C9E9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// AutoSetup1.h : header file
//

#define MAX_NUM_CATEGORIES				10
#define	MAX_NUM_ENTRIES_PER_CATEGORY	10

struct CategoryInfo {
	int CatPtr;
	CString CatStr;
};

struct SetupFileEntryInfo {
	int EntryPtr;
	CString EntryCode;
	CString EntryStr;
};

/////////////////////////////////////////////////////////////////////////////
// CAutoSetup1 dialog

class CAutoSetup1 : public CDialog
{
// Construction
public:
	BOOL m_FileOpenFlag;
	CFileStatus status;
	CFile m_file;
	int m_SORI;
	double m_HighMass;
	double m_LowMass;
	int m_ExciteWindow;
	int m_DetectWindow;
	CString m_SetupFileName;
	CString m_Description;
	CString filename;
	BOOL GetEntryInfo();
	CInstrument* pInst;
	CString m_EntryCodeString;
	int m_EntryPtr[MAX_NUM_CATEGORIES];
	int m_CatPtr;
	struct sys* sys;
	CString GetFileEntryString(CString str);
	CString GetEntryString(CString str);
	CString GetCategoryString(CString str);
	struct SetupFileEntryInfo m_EntryInfo[MAX_NUM_CATEGORIES][MAX_NUM_ENTRIES_PER_CATEGORY];
	struct CategoryInfo m_CatInfo[MAX_NUM_CATEGORIES];
	CString CompressString(CString str, int mode);
	BOOL SetupCombos();
	int m_vc;
	CAutoSetup1(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CAutoSetup1)
	enum { IDD = IDD_EXPERT_SYSTEMS };
	CButton		m_EsiBtn;
	CButton		m_MaldiBtn;
	CComboBox	m_ExpCombo;
	CComboBox	m_CatCombo;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAutoSetup1)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CAutoSetup1)
	afx_msg void OnEsi();
	afx_msg void OnMaldi();
	afx_msg void OnSelchangeCategoryCombo();
	afx_msg void OnSelchangeExperimentCombo();
	virtual BOOL OnInitDialog();
	afx_msg void OnClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_AUTOSETUP1_H__0521C340_B439_11D2_B907_004005A3C9E9__INCLUDED_)
