// AutoSetup2.cpp : implementation file
//
/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "stdafx.h"
#include "Buda.h"
#include "AutoSetup2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAutoSetup2 dialog


CAutoSetup2::CAutoSetup2(CWnd* pParent /*=NULL*/)
	: CDialog(CAutoSetup2::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAutoSetup2)
	m_Mass0 = 0.0;
	m_Mass1 = 0.0;
	//}}AFX_DATA_INIT
}


void CAutoSetup2::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAutoSetup2)
	DDX_Control(pDX, IDC_MASS1_EDIT, m_Mass1Edit);
	DDX_Control(pDX, IDC_MASS0_EDIT, m_Mass0Edit);
	DDX_Text(pDX, IDC_MASS0_EDIT, m_Mass0);
	DDV_MinMaxDouble(pDX, m_Mass0, -100000., 100000.);
	DDX_Text(pDX, IDC_MASS1_EDIT, m_Mass1);
	DDV_MinMaxDouble(pDX, m_Mass1, -100000., 100000.);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAutoSetup2, CDialog)
	//{{AFX_MSG_MAP(CAutoSetup2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAutoSetup2 message handlers

BOOL CAutoSetup2::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_Mass1Edit.EnableWindow(FALSE);
	if(m_SORI>1) m_Mass1Edit.EnableWindow(TRUE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
