/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_CSDETPARMSDLG_H__99262840_CA9C_11D3_AFFA_0090278ECA2A__INCLUDED_)
#define AFX_CSDETPARMSDLG_H__99262840_CA9C_11D3_AFFA_0090278ECA2A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CSDetParmsDlg.h : header file
//
#include "BudaDoc.h"

/////////////////////////////////////////////////////////////////////////////
// CCSDetParmsDlg dialog

class CCSDetParmsDlg : public CPropertyPage
{
	DECLARE_DYNCREATE(CCSDetParmsDlg)

// Construction
public:
	void ValidateParms();
	int m_CSDetMethod;
	void OnUpdate();
	CBudaDoc* pDoc;
	CCSDetParmsDlg();
	~CCSDetParmsDlg();

// Dialog Data
	//{{AFX_DATA(CCSDetParmsDlg)
	enum { IDD = IDD_CSDET_PARMS };
	int		m_HighChargeLimit;
	CButton m_DeltaMassBtn;
	CButton m_PattersonBtn;
	CButton m_FourierBtn;
	CButton m_ComboBtn;
	CButton m_AutoCorrBtn;
	CButton m_CrossCorrBtn;
	CButton m_EntropyBtn;
	CButton m_Spare1Btn;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CCSDetParmsDlg)
	public:
	virtual BOOL OnSetActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CCSDetParmsDlg)
	afx_msg void OnCsmethodCombo();
	afx_msg void OnCsmethodAutocorr();
	afx_msg void OnCsmethodDeltamass();
	afx_msg void OnCsmethodFourier();
	afx_msg void OnCsmethodPatterson();
	afx_msg void OnKillfocusHighestCSCharge();
	virtual void OnOK();
	afx_msg void OnSaveAsDefaults();
	afx_msg void OnAutocorrelation();
	afx_msg void OnCsmethodCrosscorr();
	afx_msg void OnCsmethodEntropy();
	afx_msg void OnCsmethodSpare1();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CSDETPARMSDLG_H__99262840_CA9C_11D3_AFFA_0090278ECA2A__INCLUDED_)
