// CSMapDlg.cpp : implementation file
//

#include "stdafx.h"
#include "buda.h"
#include "ChargeStateDetermination.h"
#include "CSMapBtn.h"
#include "CSMapDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCSMapDlg dialog


CCSMapDlg::CCSMapDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCSMapDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCSMapDlg)
	m_MaxChargeString = _T("");
	m_CSValueString = _T("");
	m_MassStr = _T("");
	//}}AFX_DATA_INIT
}


void CCSMapDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCSMapDlg)
	DDX_Control(pDX, IDC_CSMAP, m_CSMapBtn);
	DDX_Control(pDX, IDC_CSMETHOD_DELTAMASS, m_DeltaMassBtn);
	DDX_Control(pDX, IDC_CSMETHOD_PATTERSON, m_PattersonBtn);
	DDX_Control(pDX, IDC_CSMETHOD_FOURIER, m_FourierBtn);
	DDX_Control(pDX, IDC_CSMETHOD_COMBO, m_ComboBtn);
	DDX_Control(pDX, IDC_CSMETHOD_AUTOCORRELATION, m_AutoCorrBtn);
	DDX_Control(pDX, IDC_CSMETHOD_CROSSCORR, m_CrossCorrBtn);
	DDX_Control(pDX, IDC_CSMETHOD_ENTROPY, m_EntropyBtn);
	DDX_Control(pDX, IDC_CSMETHOD_SPARE1, m_Spare1Btn);
	DDX_Text(pDX, IDC_MAXCHARGE, m_MaxChargeString);
	DDX_Text(pDX, IDC_CHARGE_STATE_VALUE_STRING, m_CSValueString);
	DDX_Text(pDX, IDC_MASS, m_MassStr);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCSMapDlg, CDialog)
	//{{AFX_MSG_MAP(CCSMapDlg)
	ON_CBN_SELCHANGE(IDC_CSDET_METHOD_COMBO, OnSelchangeCsdetMethodCombo)
	ON_BN_CLICKED(IDC_DUMP_CSMAP_TO_TEXT, OnDumpCsmapToText)
	ON_EN_CHANGE(IDC_MAXCHARGE, OnChangeMaxcharge)
	ON_BN_CLICKED(IDC_CSMETHOD_DELTAMASS, OnCsDeltaMass)
	ON_BN_CLICKED(IDC_CSMETHOD_COMBO, OnCsCombo)
	ON_BN_CLICKED(IDC_CSMETHOD_AUTOCORRELATION, OnCsAutocorrelation)
	ON_BN_CLICKED(IDC_CSMETHOD_FOURIER, OnCsFourier)
	ON_BN_CLICKED(IDC_CSMETHOD_CROSSCORR, OnCsPattOfFourier)
	ON_BN_CLICKED(IDC_CSMETHOD_PATTERSON, OnCsPatterson)
	ON_BN_CLICKED(IDC_CSMETHOD_ENTROPY, OnCsEntropy)
	ON_BN_CLICKED(IDC_CSMETHOD_SPARE1, OnCsSpare1)
	ON_EN_KILLFOCUS(IDC_MAXCHARGE, OnKillfocusMaxcharge)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCSMapDlg message handlers

void CCSMapDlg::OnSelchangeCsdetMethodCombo() 
{
/*	int method;
	method = m_CSDetMethodCombo.GetCurSel();
	if (method < 0 || method > 7) {
		MessageBox("out of range","error");
		m_CSDetMethodCombo.SetCurSel(pDoc->CSDetMethod);
		return;
	}
	if (method == 0) {
		MessageBox("not currently defined","error");
		m_CSDetMethodCombo.SetCurSel(pDoc->CSDetMethod);
		return;
	}
	if (method == 6) {
		MessageBox("not currently defined","error");
		m_CSDetMethodCombo.SetCurSel(pDoc->CSDetMethod);
		return;
	}
	if (method == 7) {
		MessageBox("not currently defined","error");
		m_CSDetMethodCombo.SetCurSel(pDoc->CSDetMethod);
		return;
	}
	pDoc->CSDetMethod = method;
	UpdateCSMap();
	*/
}

void CCSMapDlg::OnDumpCsmapToText() 
{
	int retval,i;
	CString path;
	CString filename;

	CFileDialog *dlg;
	dlg = new CFileDialog(TRUE,"*.txt","CSMap.txt",OFN_HIDEREADONLY | OFN_LONGNAMES,"*.txt",NULL);
	dlg->m_ofn.lpstrFilter = "text files (*.txt)\0*.txt\0All Files (*.*)\0*.*\0";
	//dlg->m_ofn.lpstrInitialDir = "C:\\Buda";
	retval = dlg->DoModal();

	path = dlg->GetPathName();
	filename = dlg->GetFileName();
	delete dlg;
	if (retval == IDCANCEL) return;

	CFile file;
	file.Open(filename,CFile::modeCreate | CFile::modeWrite);
	CArchive ar(&file,CArchive::store,4096,NULL);

	CString str;

	str.Format("Buda Charge State Determination output file\r\n\r\n");
	ar.WriteString(str);
	str.Format("MinMass = %1.5f, MaxMass = %1.5f\r\n", m_MinMass, m_MaxMass);
	ar.WriteString(str);

	switch(pDoc->CSDetMethod) {
	case CSDET_DELTAMASS:
		str.Format("Delta Mass\r\n");
		break;
	case CSDET_MULTIPLICATIVE:
		str.Format("Patterson\r\n");
		break;
	case CSDET_FOURIER:
		str.Format("Fourier\r\n");
		break;
	case CSDET_COMBO:
		str.Format("Fourier.*Patterson\r\n");
		break;
	case CSDET_AUTOCORR:
		str.Format("AutoCorrelation\r\n");
		break;
	case CSDET_OCONNOR:
		str.Format("CrossCorrelation of Fourier\r\n");
		break;
	case CSDET_ENTROPY:
		str.Format("Entropy\r\n");
		break;
	case CSDET_SPARE1:
		str.Format("spare1\r\n");
		break;
	}
	ar.WriteString(str);
	str.Format("\r\n Z   ZMap[Z]\r\n----------------\r\n");
	ar.WriteString(str);

	for(i=0; i<CSDet.ChargeLimit*10; i++) {
		str.Format(" %1.1f   %1.5f\r\n",CSDet.CSValue[i], CSDet.CSMap[i]);
		ar.WriteString(str);		
	}

	ar.Flush();
	file.Close();
}

void CCSMapDlg::OnChangeMaxcharge() 
{	
}

BOOL CCSMapDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// setup combo;
/*	m_CSDetMethodCombo.ResetContent();
	m_CSDetMethodCombo.InsertString(0,"Delta Mass");
	m_CSDetMethodCombo.InsertString(1,"Patterson");
	m_CSDetMethodCombo.InsertString(2,"Fourier");
	m_CSDetMethodCombo.InsertString(3,"Fourier*Patt");
	m_CSDetMethodCombo.InsertString(4,"AutoCorr");
	m_CSDetMethodCombo.InsertString(5,"CrossCorr");
	m_CSDetMethodCombo.InsertString(6,"Entropy");
	m_CSDetMethodCombo.InsertString(7,"Spare1");
*/

	CSDet.pDoc = pDoc;
	m_CSMapBtn.pCSDet = &CSDet;
	UpdateMaxCharge();
	UpdateCSDetMethod();
	//UpdateCSDetMethodCombo();
	UpdateCSMap();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCSMapDlg::UpdateCSMap()
{
	long cs = 0;

	CSDet.GetChargeState(m_MaxPeak);
	m_CSValueString.Format("Charge State : %d",CSDet.CSCalcResult);
	cs = CSDet.CSCalcResult;

	//m_MassStr.Format("Mass: %1.3f",
	UpdateData(FALSE);

	// now plot CSDet.CSValue x CSDet.CSMap on the button
	m_CSMapBtn.Invalidate();
}

void CCSMapDlg::UpdateMaxCharge()
{
	m_MaxChargeString.Format("%d",CSDet.ChargeLimit);
	UpdateData(FALSE);
}

void CCSMapDlg::UpdateCSDetMethodCombo()
{
//	m_CSDetMethodCombo.SetCurSel(pDoc->CSDetMethod);
//	UpdateData(FALSE);
}

void CCSMapDlg::UpdateCSDetMethod()
{
	int method = pDoc->CSDetMethod;
	if (method < 0 || method > 7) {
		MessageBox("out of range","error");
		pDoc->CSDetMethod = CSDET_OCONNOR;
		return;
	}
	if (method == CSDET_DELTAMASS) {
		MessageBox("not currently defined","error");
		pDoc->CSDetMethod = CSDET_OCONNOR;
		return;
	}
	if (method == CSDET_SPARE1) {
		MessageBox("not currently defined","error");
		pDoc->CSDetMethod = CSDET_OCONNOR;
		return;
	}
	switch(pDoc->CSDetMethod) {
	case CSDET_DELTAMASS:
		OnCsDeltaMass();
		break;
	case CSDET_MULTIPLICATIVE:
		OnCsPatterson();
		break;
	case CSDET_FOURIER:
		OnCsFourier();
		break;
	case CSDET_COMBO:
		OnCsCombo();
		break;
	case CSDET_AUTOCORR:
		OnCsAutocorrelation();
		break;
	case CSDET_OCONNOR:
		OnCsPattOfFourier();
		break;
	case CSDET_ENTROPY:
		OnCsEntropy();
		break;
	case CSDET_SPARE1:
		OnCsSpare1();
		break;
	}

}

void CCSMapDlg::OnCsDeltaMass() 
{
	pDoc->CSDetMethod = CSDET_DELTAMASS;
	m_DeltaMassBtn.SetCheck(TRUE);
	m_PattersonBtn.SetCheck(FALSE);
	m_FourierBtn.SetCheck(FALSE);
	m_ComboBtn.SetCheck(FALSE);
	m_AutoCorrBtn.SetCheck(FALSE);
	m_CrossCorrBtn.SetCheck(FALSE);
	m_EntropyBtn.SetCheck(FALSE);
	m_Spare1Btn.SetCheck(FALSE);

	UpdateData(FALSE);
	UpdateCSMap();
}

void CCSMapDlg::OnCsCombo() 
{
	pDoc->CSDetMethod = CSDET_COMBO;
	m_DeltaMassBtn.SetCheck(FALSE);
	m_PattersonBtn.SetCheck(FALSE);
	m_FourierBtn.SetCheck(FALSE);
	m_ComboBtn.SetCheck(TRUE);
	m_AutoCorrBtn.SetCheck(FALSE);
	m_CrossCorrBtn.SetCheck(FALSE);
	m_EntropyBtn.SetCheck(FALSE);
	m_Spare1Btn.SetCheck(FALSE);

	UpdateData(FALSE);
	UpdateCSMap();
}

void CCSMapDlg::OnCsAutocorrelation() 
{
	pDoc->CSDetMethod = CSDET_AUTOCORR;
	m_DeltaMassBtn.SetCheck(FALSE);
	m_PattersonBtn.SetCheck(FALSE);
	m_FourierBtn.SetCheck(FALSE);
	m_ComboBtn.SetCheck(FALSE);
	m_AutoCorrBtn.SetCheck(TRUE);
	m_CrossCorrBtn.SetCheck(FALSE);
	m_EntropyBtn.SetCheck(FALSE);
	m_Spare1Btn.SetCheck(FALSE);

	UpdateData(FALSE);
	UpdateCSMap();
}

void CCSMapDlg::OnCsFourier() 
{
	pDoc->CSDetMethod = CSDET_FOURIER;
	m_DeltaMassBtn.SetCheck(FALSE);
	m_PattersonBtn.SetCheck(FALSE);
	m_FourierBtn.SetCheck(TRUE);
	m_ComboBtn.SetCheck(FALSE);
	m_AutoCorrBtn.SetCheck(FALSE);
	m_CrossCorrBtn.SetCheck(FALSE);
	m_EntropyBtn.SetCheck(FALSE);
	m_Spare1Btn.SetCheck(FALSE);

	UpdateData(FALSE);
	UpdateCSMap();
}

void CCSMapDlg::OnCsPattOfFourier() 
{
	pDoc->CSDetMethod = CSDET_OCONNOR;
	m_DeltaMassBtn.SetCheck(FALSE);
	m_PattersonBtn.SetCheck(FALSE);
	m_FourierBtn.SetCheck(FALSE);
	m_ComboBtn.SetCheck(FALSE);
	m_AutoCorrBtn.SetCheck(FALSE);
	m_CrossCorrBtn.SetCheck(TRUE);
	m_EntropyBtn.SetCheck(FALSE);
	m_Spare1Btn.SetCheck(FALSE);

	UpdateData(FALSE);
	UpdateCSMap();
}

void CCSMapDlg::OnCsPatterson() 
{
	pDoc->CSDetMethod = CSDET_MULTIPLICATIVE;
	m_DeltaMassBtn.SetCheck(FALSE);
	m_PattersonBtn.SetCheck(TRUE);
	m_FourierBtn.SetCheck(FALSE);
	m_ComboBtn.SetCheck(FALSE);
	m_AutoCorrBtn.SetCheck(FALSE);
	m_CrossCorrBtn.SetCheck(FALSE);
	m_EntropyBtn.SetCheck(FALSE);
	m_Spare1Btn.SetCheck(FALSE);

	UpdateData(FALSE);
	UpdateCSMap();
}

void CCSMapDlg::OnCsEntropy() 
{
	pDoc->CSDetMethod = CSDET_ENTROPY;
	m_DeltaMassBtn.SetCheck(FALSE);
	m_PattersonBtn.SetCheck(FALSE);
	m_FourierBtn.SetCheck(FALSE);
	m_ComboBtn.SetCheck(FALSE);
	m_AutoCorrBtn.SetCheck(FALSE);
	m_CrossCorrBtn.SetCheck(FALSE);
	m_EntropyBtn.SetCheck(TRUE);
	m_Spare1Btn.SetCheck(FALSE);

	UpdateData(FALSE);
	UpdateCSMap();
}

void CCSMapDlg::OnCsSpare1() 
{
	pDoc->CSDetMethod = CSDET_SPARE1;
	m_DeltaMassBtn.SetCheck(FALSE);
	m_PattersonBtn.SetCheck(FALSE);
	m_FourierBtn.SetCheck(FALSE);
	m_ComboBtn.SetCheck(FALSE);
	m_AutoCorrBtn.SetCheck(FALSE);
	m_CrossCorrBtn.SetCheck(FALSE);
	m_EntropyBtn.SetCheck(FALSE);
	m_Spare1Btn.SetCheck(TRUE);

	UpdateData(FALSE);
	UpdateCSMap();
}

void CCSMapDlg::OnKillfocusMaxcharge() 
{
	double z;

	UpdateData(TRUE);

	sscanf(m_MaxChargeString,"%lf",&z);
	if(z>100) {
		MessageBox("Can't handle charge states > 100\n Resetting to 100","Error");
		z = 100;
	}
	CSDet.ChargeLimit = (int)z;

	UpdateCSMap();	
}
