/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_CALIBRATEDLG_H__26478AA1_A6B1_11D1_9106_44455354616F__INCLUDED_)
#define AFX_CALIBRATEDLG_H__26478AA1_A6B1_11D1_9106_44455354616F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// CalibrateDlg.h : header file
//
#include "BudaMaster.h"

/////////////////////////////////////////////////////////////////////////////
// CCalibrateDlg dialog

class CCalibrateDlg : public CDialog
{
// Construction
public:
	struct PeakMatchPoint RefPeak[2];
	void SetCourierStrWidth(CString* str, int len);
	
	CFont m_font;
	void SetCalListFont();
	BOOL IsPeakMatching;
	double B;
	double A;
	void CalculateNewCalibration();
	void UpdateCalibrationDialog();
	CBudaDoc* pDoc;
	int MIindex;
	BOOL OnInitDialog();
	double ExactMass;
	struct FITableElement* FITable;
	struct PS * PS;
	struct sys * sys;
	CString CalFileStr;
	CCalibrateDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CCalibrateDlg)
	enum { IDD = IDD_CALIBRATE_DLG };
	CStatic	m_PeakMatchStatic;
	CListBox	m_CalibrationList;
	CButton	m_ExternalCalBtn;
	CString	m_CalParmA;
	CString	m_CalParmB;
	CString	m_CalDate;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCalibrateDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CCalibrateDlg)
	afx_msg void OnAddPeak();
	afx_msg void OnApplySpectrum();
	afx_msg void OnExternalCalibration();
	afx_msg void OnLoadCalibrationFromFile();
	afx_msg void OnSaveCalibrationToFile();
	afx_msg void OnSaveDefaultCalibration();
	afx_msg void OnRemovePeak();
	afx_msg void OnDblclkCalibrationList();
	afx_msg void OnExit();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CALIBRATEDLG_H__26478AA1_A6B1_11D1_9106_44455354616F__INCLUDED_)
