// ChangeInstruments.cpp : implementation file
//
/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "stdafx.h"
#include "Buda.h"
#include "ChangeInstruments.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChangeInstruments dialog


CChangeInstruments::CChangeInstruments(CWnd* pParent /*=NULL*/)
	: CDialog(CChangeInstruments::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChangeInstruments)
	//}}AFX_DATA_INIT
}


void CChangeInstruments::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChangeInstruments)
	DDX_Control(pDX, IDC_MALDI_INSTRUMENT, m_MALDIInst);
	DDX_Control(pDX, IDC_ESI_INSTRUMENT, m_ESIInst);
	DDX_Control(pDX, IDC_EI_INSTRUMENT, m_EIInst);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CChangeInstruments, CDialog)
	//{{AFX_MSG_MAP(CChangeInstruments)
	ON_BN_CLICKED(IDC_EI_INSTRUMENT, OnEiInstrument)
	ON_BN_CLICKED(IDC_ESI_INSTRUMENT, OnEsiInstrument)
	ON_BN_CLICKED(IDC_MALDI_INSTRUMENT, OnMaldiInstrument)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChangeInstruments message handlers

BOOL CChangeInstruments::OnInitDialog() 
{
	CDialog::OnInitDialog();

	EnableInstruments();

	if(m_CurrentInstrument == EI_INSTRUMENT) {
		m_EIInst.SetCheck(1);
		m_MALDIInst.SetCheck(0);
		m_ESIInst.SetCheck(0);
	}
	if(m_CurrentInstrument == MALDI_INSTRUMENT) {
		m_EIInst.SetCheck(0);
		m_MALDIInst.SetCheck(1);
		m_ESIInst.SetCheck(0);
	}
	if(m_CurrentInstrument == ESI_INSTRUMENT) {
		m_EIInst.SetCheck(0);
		m_MALDIInst.SetCheck(0);
		m_ESIInst.SetCheck(1);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CChangeInstruments::OnEiInstrument() 
{
	m_CurrentInstrument = EI_INSTRUMENT;
	m_EIInst.SetCheck(1);
	m_MALDIInst.SetCheck(0);
	m_ESIInst.SetCheck(0);
}

void CChangeInstruments::OnEsiInstrument() 
{
	if(!CheckEnabledInsts(ESI_INSTRUMENT)) return;
	m_CurrentInstrument = ESI_INSTRUMENT;
	m_EIInst.SetCheck(0);
	m_MALDIInst.SetCheck(0);
	m_ESIInst.SetCheck(1);
}

void CChangeInstruments::OnMaldiInstrument() 
{
	if(!CheckEnabledInsts(MALDI_INSTRUMENT)) return;
	m_CurrentInstrument = MALDI_INSTRUMENT;
	m_EIInst.SetCheck(0);
	m_MALDIInst.SetCheck(1);
	m_ESIInst.SetCheck(0);
}

void CChangeInstruments::EnableInstruments()
{
	m_EIInst.EnableWindow(TRUE);
	m_ESIInst.EnableWindow(TRUE);
	m_MALDIInst.EnableWindow(TRUE);
}

BOOL CChangeInstruments::CheckEnabledInsts(int instrument)
{
/*	if(instrument == ESI_INSTRUMENT && !pInst->sys[0].HiResESI) {
		MessageBox("This instrument is not configured for Electrospray","Invalid Instrument");
		return FALSE;
	}
	if(instrument == MALDI_INSTRUMENT && !pInst->sys[0].HiResMALDI) {
		MessageBox("This instrument is not configured for MALDI","Invalid Instrument");
		return FALSE;
	}
*/

  return TRUE;
}
