/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_CHANGEINSTRUMENTS_H__108BA500_B05D_11D2_B907_004005A3C9E9__INCLUDED_)
#define AFX_CHANGEINSTRUMENTS_H__108BA500_B05D_11D2_B907_004005A3C9E9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ChangeInstruments.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CChangeInstruments dialog

class CChangeInstruments : public CDialog
{
// Construction
public:
	BOOL CheckEnabledInsts(int instrument);
	void EnableInstruments();
	CInstrument* pInst;
	int m_CurrentInstrument;
	CChangeInstruments(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CChangeInstruments)
	enum { IDD = IDD_CHANGE_INSTRUMENTS };
	CButton	m_MALDIInst;
	CButton	m_ESIInst;
	CButton	m_EIInst;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChangeInstruments)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CChangeInstruments)
	virtual BOOL OnInitDialog();
	afx_msg void OnEiInstrument();
	afx_msg void OnEsiInstrument();
	afx_msg void OnMaldiInstrument();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHANGEINSTRUMENTS_H__108BA500_B05D_11D2_B907_004005A3C9E9__INCLUDED_)
