// ChangeMemo.cpp : implementation file
//
/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "stdafx.h"
#include "Buda.h"
#include "ChangeMemo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChangeMemo dialog


CChangeMemo::CChangeMemo(CWnd* pParent /*=NULL*/)
	: CDialog(CChangeMemo::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChangeMemo)
	m_Notes = _T("");
	m_Memo = _T("");
	//}}AFX_DATA_INIT
}


void CChangeMemo::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChangeMemo)
	DDX_Text(pDX, IDC_NOTES, m_Notes);
	DDV_MaxChars(pDX, m_Notes, 600);
	DDX_Text(pDX, IDC_MEMO, m_Memo);
	DDV_MaxChars(pDX, m_Memo, 60);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CChangeMemo, CDialog)
	//{{AFX_MSG_MAP(CChangeMemo)
	ON_EN_SETFOCUS(IDC_MEMO, OnSetfocusMemo)
	ON_EN_SETFOCUS(IDC_NOTES, OnSetfocusNotes)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChangeMemo message handlers

BOOL CChangeMemo::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_Memo = CString('\0',61);
	m_Notes = CString('\0',601);
	
	// set up the strings
	int i;
	for(i=0; i<60; i++) m_Memo.SetAt(i,m_pMemo[i]);	
	for(i=0; i<600; i++) m_Notes.SetAt(i,m_pNotes[i]);

	UpdateData(FALSE);
	return TRUE;  
}

void CChangeMemo::OnSetfocusMemo() 
{
	SetDefID(IDC_MEMO);	
}

void CChangeMemo::OnSetfocusNotes() 
{
	SetDefID(IDC_NOTES);
}
