// ChangUser2Dlg.cpp : implementation file
//
/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "stdafx.h"
#include "Buda.h"
#include "ChangeUserDlg.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "BudaDoc.h"
#include "BudaView.h"
#include "MITableView.h"
#include "TextView.h"
#include "AddUserDlg.h"

#include <direct.h>

#include "BudaMaster.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChangeUserDlg dialog


CChangeUserDlg::CChangeUserDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChangeUserDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChangeUserDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CChangeUserDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChangeUserDlg)
	DDX_Control(pDX, IDC_CHANGEUSERLISTBOX, m_listbox);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CChangeUserDlg, CDialog)
	//{{AFX_MSG_MAP(CChangeUserDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChangeUserDlg message handlers

void CChangeUserDlg::OnOK() 
{

	//select highlighted name from the list,
	//then find name in file and set global variables

	UpdateData(FALSE);

	//This is the position of the user in the file
	int		i = m_listbox.GetCurSel();

	//setup for opening file
	//CString	UIDFile = pApp->UserIDFile;
	CString	UIDFile = "c:\\Buda\\BudaUserIDs";
	CString	file_error_msg,line;
	CString file_error_title = "File Open Error";
	BOOL    testfile;
	CFile	file;
	
	//open file for reading
	testfile = file.Open(UIDFile, CFile::modeRead, NULL);

	//if didn't open, display error message box and return
	if (!testfile){
		file_error_msg.Format("Couldn't open User ID file: \n %s \n", UIDFile);
		MessageBox(file_error_msg,file_error_title);
		return;
	}

	//create archive 
	CArchive ar(&file,CArchive::load,4096,NULL);

	//calculate how many lines to skip in file to get to specified user
	int		k = 4*i;
	//now loop till that user is pointed to in the file
	while (k>0) {
		ar.ReadString(line); // read in line to advance
		k--;
	}

	//now read in the stuff:
	ar.ReadString(UserID);
	ar.ReadString(UserDir);
	ar.ReadString(UserFilename);

	ar.Close();
	file.Close();

	CDialog::OnOK();

	MessageBox("This User's Specifications have been set   ",
				"User Notice", MB_OK + MB_ICONINFORMATION);

}

BOOL CChangeUserDlg::OnInitDialog()	
{
	/*****************NOTE*******************************************

	the code from this section has been pasted to VerifyValideUSrID()
	in Buda.cpp. Any relevent changes to this code should be made
	in that function as well. 

	*****************************************************************/

	//SetBoxListFont();

	UpdateData(FALSE);
	m_listbox.ResetContent();
	//m_UserList.InitStorage(MAXUSERS, 100);

	//fill in user list box


	CString	UIDFile = "c:\\Buda\\BudaUserIDs";
	//CString	UIDFile = pApp->UserIDFile;
	CString	file_error_msg;
	CString file_error_title = "File Open Error";
	BOOL    testfile;
	CFile	file;
	
	//open file for reading
	testfile = file.Open(UIDFile, CFile::modeRead, NULL);

	
	//if didn't open, display error message box and return
	if (!testfile){
		file_error_msg.Format("Couldn't open User ID file: \n %s \n", UIDFile);
		MessageBox(file_error_msg,file_error_title);
		return TRUE;
	}
	
	
	CString	line,check_userID;
	BOOL	testline = TRUE;
	CString user_error = "Duplicate User";
	CString user_error_str;

	//create archive 
	CArchive ar(&file,CArchive::load,4096,NULL);
	
	//loop till end of file 
	// UserIDFile entries should be 3 lines each separated by
	// a blank line
	while (testline) {
		//read line 
		testline = ar.ReadString(line); // read in UserID line
		//if a line (UserID) was read...
		if (testline) {
			//display to UserList
			m_listbox.AddString(line);
		}//endif

		testline = ar.ReadString(line); // read in directory line
		testline = ar.ReadString(line); // read in setupfile line
		testline = ar.ReadString(line); // read in blank line

	}//end while

	ar.Close();
	file.Close();

	//set initial cursor
	m_listbox.SetCurSel(0);

	UpdateData(FALSE);

	return TRUE;

}//end BOOL CAddPeakDlg::OnInitDialog()	


