/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_CHARGESTATEDETERMINATION_H__EA4EAD20_8833_11D2_B907_004005A3C9E9__INCLUDED_)
#define AFX_CHARGESTATEDETERMINATION_H__EA4EAD20_8833_11D2_B907_004005A3C9E9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ChargeStateDetermination.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CChargeStateDetermination window

class CChargeStateDetermination : public CWnd
{
// Construction
public:
	CChargeStateDetermination();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChargeStateDetermination)
	//}}AFX_VIRTUAL

// Implementation
public:
	int GetEntropyMap(double mass, float* EMap, float* Zvalue);
	void ComputeOConnorCS();
	int GetOConnorCSValue(float *FourMap, float *Zvalue, float *ZMap);
	int GetAutoCorrFourierCSValue(float* FourMap, float* Zvalue, float* ZMap);
	int GetAutoCorrMap(double mass, float* ZMap, float* Zvalue);
	void ComputeAutoCorrCS();
	float CSMap[1024];
	float CSValue[1024];
	int CSCalcResult;
	int GetChargeState(long index);
	int GetMultiplicativeMap(double mass, float *PattMap, float* ZValues );
	int GetComboCSMap(double mass, float *ComboMap, float* ZValues );
	int GetFourierCSValue(float* FourMap, float* Zvalue, float* ZMap);
	void GetFourierMap(double Mass, float *FourMap,float* ZValues);
	double GetIntensityatMass(double mass);
	void ComputeComboCS();
	void ComputeFourierCS();
	void ComputeMultiplicativeCS();
	double gammln( double xx );
	double factln(int n);
	double bico(int n, int k);
	void GetModelIsotopicDistribution(double mass, float cs, float *model, int numpts);
	void GenerateFilteredRawData(long lowpoint, float* data, int numpts);
	void ComputeXCorrCS();
	int ChargeLimit;
//	struct sys* pSys;
	float scale;
	int CountPeaks(double m1, double m2);
	void ClearGroupStruct();
	double Mass(int);
	void CSDetermination();
	void AddToCSGroup(int groupnum, int MINum);
	void ComputeDeltaMassCS();
	void ExtractOverlappingCSDists();
	void RoughGroupAssignment();
	void InitializeCSDet();
	int maxgroup;
	struct groupstruct groups[MAX_NUMBER_OF_GROUPS];
	CBudaDoc* pDoc;
	virtual ~CChargeStateDetermination();

	// Generated message map functions
protected:
	//{{AFX_MSG(CChargeStateDetermination)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHARGESTATEDETERMINATION_H__EA4EAD20_8833_11D2_B907_004005A3C9E9__INCLUDED_)
