// ChefDlg.cpp : implementation file
//

#include "stdafx.h"
#include "buda.h"
#include "ChefDlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChefDlg dialog


CChefDlg::CChefDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChefDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChefDlg)
	m_Time = 0.0;
	m_freq1 = 0.0;
	m_freq2 = 0.0;
	m_freq3 = 0.0;
	m_freq4 = 0.0;
	m_Mass2 = 0.0;
	m_Mass3 = 0.0;
	m_Mass1 = 0.0;
	m_Mass4 = 0.0;
	m_IsoMass = 0.0;
	//}}AFX_DATA_INIT
}


void CChefDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChefDlg)
	DDX_Text(pDX, IDC_CHEF_EXCITATION_TIME, m_Time);
	DDX_Text(pDX, IDC_CHEF_ION1FREQ, m_freq1);
	DDX_Text(pDX, IDC_CHEF_ION2FREQ, m_freq2);
	DDX_Text(pDX, IDC_CHEF_ION3FREQ, m_freq3);
	DDX_Text(pDX, IDC_CHEF_ION4FREQ, m_freq4);
	DDX_Text(pDX, IDC_CHEF_ION2MASS, m_Mass2);
	DDX_Text(pDX, IDC_CHEF_ION3MASS, m_Mass3);
	DDX_Text(pDX, IDC_CHEF_ION1MASS, m_Mass1);
	DDX_Text(pDX, IDC_CHEF_ION4MASS, m_Mass4);
	DDX_Text(pDX, IDC_CHEF_IONISOLATIONMASS, m_IsoMass);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CChefDlg, CDialog)
	//{{AFX_MSG_MAP(CChefDlg)
	ON_BN_CLICKED(IDC_CHEF_CALCULATE, OnChefCalculate)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChefDlg message handlers

void CChefDlg::OnChefCalculate() 
{
	double twopi, df, fion;
	long rdf;
	twopi = 4*acos(0);

	UpdateData(TRUE);
	m_Time = m_Time / 1000000.0; // convert time to seconds
	if(!VerifyDataValid()) return;

	// calculate the relevant frequencies.
	// m_Mass1
	if(m_Mass1 > 0) {
		fion =pDoc->MassToFreq(m_IsoMass); 
		df = m_Time*(fion - pDoc->MassToFreq(m_Mass1))/twopi;
		rdf = (long)df;
		if((df-(double)rdf) > 0.5) rdf++;
		m_freq1 = fion-twopi*(double)rdf/m_Time;
	}
	if(m_Mass2 > 0) {
		fion =pDoc->MassToFreq(m_IsoMass); 
		df = m_Time*(fion - pDoc->MassToFreq(m_Mass2))/twopi;
		rdf = (long)df;
		if((df-(double)rdf) > 0.5) rdf++;
		m_freq2 = fion-twopi*(double)rdf/m_Time;
	}
	if(m_Mass3 > 0) {
		fion =pDoc->MassToFreq(m_IsoMass); 
		df = m_Time*(fion - pDoc->MassToFreq(m_Mass3))/twopi;
		rdf = (long)df;
		if((df-(double)rdf) > 0.5) rdf++;
		m_freq3 = fion-twopi*(double)rdf/m_Time;
	}
	if(m_Mass4 > 0) {
		fion =pDoc->MassToFreq(m_IsoMass); 
		df = m_Time*(fion - pDoc->MassToFreq(m_Mass4))/twopi;
		rdf = (long)df;
		if((df-(double)rdf) > 0.5) rdf++;
		m_freq4 = fion-twopi*(double)rdf/m_Time;
	}

	// save data back to screen.
	m_Time = m_Time * 1000000.0; // convert time back to microseconds
	UpdateData(FALSE);
}

BOOL CChefDlg::VerifyDataValid()
{
	// check to see that the data has valid ranges.
	BOOL retval = TRUE;

	if(m_Mass1 < pDoc->PS.DetectLowMass || m_Mass1 > pDoc->PS.DetectHighMass) {
		if(m_Mass1 != 0) {
			m_Mass1 = 0;
			retval = FALSE;
		}
	}
	if(m_Mass2 < pDoc->PS.DetectLowMass || m_Mass2 > pDoc->PS.DetectHighMass) {
		if(m_Mass2 != 0) {
			m_Mass2 = 0;
			retval = FALSE;
		}
	}
	if(m_Mass3 < pDoc->PS.DetectLowMass || m_Mass3 > pDoc->PS.DetectHighMass) {
		if(m_Mass3 != 0) {
			m_Mass3 = 0;
			retval = FALSE;
		}
	}
	if(m_Mass4 < pDoc->PS.DetectLowMass || m_Mass4 > pDoc->PS.DetectHighMass) {
		if(m_Mass4 != 0) {
			m_Mass4 = 0;
			retval = FALSE;
		}
	}
	if(m_IsoMass < pDoc->PS.DetectLowMass || m_IsoMass > pDoc->PS.DetectHighMass) {
		if(m_IsoMass != 0) {
			m_IsoMass = 0;
			retval = FALSE;
		}
	}
	if(m_Time <= 0) retval = FALSE;

	if(!retval) {
		UpdateData(TRUE);
	}
	return retval;
}

BOOL CChefDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_Mass1 = 0;
	m_Mass2 = 0;
	m_Mass3 = 0;
	m_Mass4 = 0;
	m_IsoMass = 0;
	m_Time = 0;
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
