// DACSetupDlg.cpp : implementation file
//
/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "stdafx.h"
#include "Resource.h"
#include "DAC_Master.h"
//#include "EventStruct.h"
#include "DACBudaSetupDlg.h"
#include <stdio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDACBudaSetupDlg dialog


CDACBudaSetupDlg::CDACBudaSetupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDACBudaSetupDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDACBudaSetupDlg)
	m_DACName = _T("");
	m_Delay = 0.0f;
	m_Duration = 0.0f;
	m_Voltage = 0.0f;
	m_StartTimeStr = _T("");
	m_TrapLinkStr = _T("");
	//}}AFX_DATA_INIT
}


void CDACBudaSetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDACBudaSetupDlg)
	DDX_Control(pDX, IDC_START_TIME_STR, m_DelayCtrl);	//
	DDX_Control(pDX, IDC_DURATIONSTR, m_DurationCtrl);	//
	DDX_Control(pDX, IDC_DELAY, m_DelayEdit);			//
	DDX_Control(pDX, IDC_LINK_CHK, m_LinkChk);			//
	DDX_Control(pDX, IDOK, m_OkBtn);					//
	DDX_Control(pDX, IDC_DURATION, m_DurationEdit);		//
	DDX_Control(pDX, IDC_VOLTAGE, m_VoltageEdit);		//
	DDX_Control(pDX, IDC_DACINIT, m_DACInitBtn);		//
	DDX_Control(pDX, IDC_DACSTEP, m_DACStepBtn);		//
	DDX_Control(pDX, IDC_DACPULSE, m_DACPulseBtn);		//
	DDX_Control(pDX, IDC_DACRAMP, m_DACRampBtn);		//
	DDX_Control(pDX, IDC_EVENTLIST, m_EventListBox);	//
	DDX_Text(pDX, IDC_DACNAME, m_DACName);				//
	DDX_Text(pDX, IDC_DELAY, m_Delay);					//
	DDX_Text(pDX, IDC_DURATION, m_Duration);			//
	DDX_Text(pDX, IDC_VOLTAGE, m_Voltage);				//
	DDX_Text(pDX, IDC_START_TIME_STR, m_StartTimeStr);	//
	DDX_Text(pDX, IDC_TRAP_LINK_STR, m_TrapLinkStr);	//
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDACBudaSetupDlg, CDialog)
	//{{AFX_MSG_MAP(CDACBudaSetupDlg)
//	ON_BN_CLICKED(IDC_LINK_DAC, OnLinkDac)
	ON_LBN_SELCHANGE(IDC_EVENTLIST, OnSelchangeEventlist)
	ON_EN_CHANGE(IDC_DELAY, OnChangeDelay)
	ON_EN_CHANGE(IDC_DURATION, OnChangeDuration)
	ON_EN_CHANGE(IDC_VOLTAGE, OnChangeVoltage)
	ON_BN_CLICKED(IDC_DACINIT, OnDacinit)
	ON_BN_CLICKED(IDC_DACPULSE, OnDacpulse)
	ON_BN_CLICKED(IDC_DACRAMP, OnDacramp)
	ON_BN_CLICKED(IDC_DACSTEP, OnDacstep)
	ON_BN_CLICKED(IDC_DELETE_EVENT, OnDeleteEvent)
	ON_BN_CLICKED(IDC_ADD_EVENT, OnAddEvent)
	ON_BN_CLICKED(IDC_CLEAR_ALL_EVENTS, OnClearAllEvents)
	ON_BN_CLICKED(IDC_LINK_CHK, OnLinkChk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDACBudaSetupDlg message handlers

void CDACBudaSetupDlg::OnLinkDac() 
{
/*	if(PS.GenPS[EventList[CurrentChannelEvent]].EventType == DAC_INIT) {
		MessageBox("Rejected:\nCannot link an Initialization event","Error: Invalid Input");
		return;
	}
	CLinkingDlg dlg;
	dlg.Linking = PS.GenPS[EventList[CurrentChannelEvent]].Linking;
	dlg.InEvent = PS.GenPS[EventList[CurrentChannelEvent]].Link2Event;
	dlg.pPS = &PS;
	dlg.pSys = pSys;
	dlg.pDoc = pDoc;

	if( dlg.DoModal() == IDOK) {
		PS.GenPS[EventList[CurrentChannelEvent]].Linking = dlg.Linking;
		PS.GenPS[EventList[CurrentChannelEvent]].Link2Event = dlg.InEvent;
	}
	*/
}

BOOL CDACBudaSetupDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	int i;
	
	//	for(i=0; i<	MAX_PS_EVENTS; i++) EventList[i]=0;

	// make a copy of Eventlist, and in OnOK, copy it back.
/*	TempEvents = new EventStruct[MAX_NUM_EVENTS];
	for(i=0; i<MAX_NUM_EVENTS; i++) {
		TempEvents[i].time = 0;
		TempEvents[i].Duration = 0;
		TempEvents[i].Voltage = 0;
		TempEvents[i].EventType = DAC_Null;
		TempEvents[i].Channel = 0;
	}
*/
	for(i=0; i<MAX_NUM_EVENTS; i++) {
		//TempEvents[i] = Events[i];
		if(TempEvents[i].EventType == DAC_Null) {
			eventnum = i;
			break;
		}
	}

	//initialize the Event list
	m_EventListBox.ResetContent();
	m_EventListBox.InitStorage(40,30);

	// set up the list box
	CurrentChannelEvent = 0;
	SetupEventListBox();

	InitEventInfo();

	// force the dialog to update the window
	UpdateData(FALSE);

	return TRUE;
}

void CDACBudaSetupDlg::InitEventInfo()
{
	CString str;
	int CurrentEvent;

	// uses the event listed in CurrentChannelEvent 
	// Current Event is the zero based event number for
	// this channel.
	CurrentChannelEvent = m_EventListBox.GetCurSel();
	CurrentEvent = EventMap[CurrentChannelEvent];

	m_DACInitBtn.EnableWindow(TRUE);
	m_StartTimeStr = "Start Time (msec):";

	if(eventnum==0) {
		str.Format("No Events");
		m_EventListBox.AddString(str);
		return;
	}
	if(CurrentChannelEvent < 0 || CurrentChannelEvent > eventnum-1) {
		MessageBox("Invalid Event Number","Error");
		return;
	}
	/*
	if(InitEventExist && TempEvents[CurrentChannelEvent] != InitEvent) {
		m_DACInitBtn.EnableWindow(FALSE);
		if (TempEvents[CurrentChannelEvent].EventType == DAC_INIT) {
			MessageBox("Invalid Event:\n There is more than one initialization event\nChanging event type to NEW event","Error: Invalid event");
			TempEvents[CurrentChannelEvent].EventType = BLANK_EVENT;
		}
	}
	*/
	//m_LinkChk.EnableWindow(TRUE);


	switch(TempEvents[CurrentEvent].EventType) {
	case DAC_Init: 
		m_DACInitBtn.SetCheck(1);
		m_DACStepBtn.EnableWindow(TRUE);
		m_DACStepBtn.SetCheck(0);
		m_DACStepBtn.EnableWindow(FALSE);
		m_DACRampBtn.SetCheck(0);
		m_DACRampBtn.EnableWindow(FALSE);
		m_DACPulseBtn.SetCheck(0);
		m_DACPulseBtn.EnableWindow(FALSE);

		m_VoltageEdit.EnableWindow(TRUE);
		m_DelayEdit.EnableWindow(FALSE);
		m_DurationEdit.EnableWindow(FALSE);

		m_VoltageEdit.ShowWindow(SW_SHOW);
		m_DelayEdit.ShowWindow(SW_HIDE);
		m_DelayCtrl.ShowWindow(SW_HIDE);
		m_DurationEdit.ShowWindow(SW_HIDE);
		m_DurationCtrl.ShowWindow(SW_HIDE);

		//PS.GenPS[EventList[CurrentChannelEvent]].Linking = NO_LINK;
		//PS.GenPS[EventList[CurrentChannelEvent]].Link2Event = 0;
		//m_LinkChk.SetCheck(0);
		//m_LinkChk.EnableWindow(FALSE);
		//m_LinkChk.ShowWindow(SW_HIDE);
		break;
	case DAC_Step:
		m_DACStepBtn.EnableWindow(FALSE);
		m_DACStepBtn.EnableWindow(TRUE);
		m_DACRampBtn.EnableWindow(TRUE);
		m_DACPulseBtn.EnableWindow(TRUE);
		m_DACInitBtn.SetCheck(0);
		m_DACStepBtn.SetCheck(1);
		m_DACRampBtn.SetCheck(0);
		m_DACPulseBtn.SetCheck(0);

		m_VoltageEdit.EnableWindow(TRUE);
		m_VoltageEdit.ShowWindow(SW_SHOW);
		m_DelayEdit.EnableWindow(TRUE);
		m_DelayEdit.ShowWindow(SW_SHOW);
		m_DelayCtrl.ShowWindow(SW_SHOW);
		m_DurationEdit.EnableWindow(FALSE);
		m_DurationEdit.ShowWindow(SW_HIDE);
		m_DurationCtrl.ShowWindow(SW_HIDE);

		//m_LinkChk.EnableWindow(TRUE);
		//m_LinkChk.ShowWindow(SW_SHOW);
		break;
	case DAC_Pulse:
		m_DACStepBtn.EnableWindow(FALSE);
		m_DACStepBtn.EnableWindow(TRUE);
		m_DACRampBtn.EnableWindow(TRUE);
		m_DACPulseBtn.EnableWindow(TRUE);
		m_DACInitBtn.SetCheck(0);
		m_DACStepBtn.SetCheck(0);
		m_DACRampBtn.SetCheck(0);
		m_DACPulseBtn.SetCheck(1);

		m_VoltageEdit.EnableWindow(TRUE);
		m_DelayEdit.EnableWindow(TRUE);
		m_DurationEdit.EnableWindow(TRUE);

		m_VoltageEdit.ShowWindow(SW_SHOW);
		m_DelayEdit.ShowWindow(SW_SHOW);
		m_DelayCtrl.ShowWindow(SW_SHOW);
		m_DurationEdit.ShowWindow(SW_SHOW);
		m_DurationCtrl.ShowWindow(SW_SHOW);

		//m_LinkChk.EnableWindow(TRUE);
		//m_LinkChk.ShowWindow(SW_SHOW);
		break;
	case DAC_Ramp:
		m_DACStepBtn.EnableWindow(FALSE);
		m_DACStepBtn.EnableWindow(TRUE);
		m_DACRampBtn.EnableWindow(TRUE);
		m_DACPulseBtn.EnableWindow(TRUE);
		m_DACInitBtn.SetCheck(0);
		m_DACStepBtn.SetCheck(0);
		m_DACRampBtn.SetCheck(1);
		m_DACPulseBtn.SetCheck(0);

		m_VoltageEdit.EnableWindow(TRUE);
		m_DelayEdit.EnableWindow(TRUE);
		m_DurationEdit.EnableWindow(TRUE);

		m_VoltageEdit.ShowWindow(SW_SHOW);
		m_DelayEdit.ShowWindow(SW_SHOW);
		m_DelayCtrl.ShowWindow(SW_SHOW);
		m_DurationEdit.ShowWindow(SW_SHOW);
		m_DurationCtrl.ShowWindow(SW_SHOW);

		//m_LinkChk.EnableWindow(TRUE);
		//m_LinkChk.ShowWindow(SW_SHOW);
		break;
	case DAC_Null:
		m_DACInitBtn.SetCheck(0);
		m_DACStepBtn.SetCheck(0);
		m_DACRampBtn.SetCheck(0);
		m_DACPulseBtn.SetCheck(0);
		m_DACStepBtn.EnableWindow(FALSE);
		m_DACStepBtn.EnableWindow(TRUE);
		m_DACRampBtn.EnableWindow(TRUE);
		m_DACPulseBtn.EnableWindow(TRUE);

		m_VoltageEdit.EnableWindow(FALSE);
		m_DelayEdit.EnableWindow(FALSE);
		m_DurationEdit.EnableWindow(FALSE);

		m_VoltageEdit.ShowWindow(SW_HIDE);
		m_DelayEdit.ShowWindow(SW_HIDE);
		m_DelayCtrl.ShowWindow(SW_HIDE);
		m_DurationEdit.ShowWindow(SW_HIDE);
		m_DurationCtrl.ShowWindow(SW_HIDE);

		//m_LinkChk.EnableWindow(FALSE);
		//m_LinkChk.ShowWindow(SW_HIDE);
		break;
	}

	
	m_Delay = TempEvents[CurrentEvent].time;
	str.Format("%1.3f",m_Delay);

	m_Duration = TempEvents[CurrentEvent].Duration;
	str.Format("%1.3f",m_Duration);

	m_Voltage = TempEvents[CurrentEvent].Voltage;
	str.Format("%1.3f",m_Voltage);

	/*
	if(TempEvents[CurrentChannelEvent].Linking == NO_LINK) {
		m_LinkChk.SetCheck(0);
		m_LinkChk.SetWindowText("Not Linked");
		m_StartTimeStr = "Start Time (msec):";
		m_TrapLinkStr = "";
	} else {
		m_LinkChk.SetCheck(1);
		m_LinkChk.SetWindowText("Linked to");
		m_StartTimeStr = "DELTA Start Time (msec):";
		m_TrapLinkStr = pDoc->GetLinkedToStr(&PS,EventList[CurrentChannelEvent]);
		if(m_TrapLinkStr == "" ) {
			MessageBox("Error 86: A Link is defined to or from an invalid event\nWe will try to remove the link.  Please repair link manually","Error: Link to/from invalid event");
			TempEvents[CurrentChannelEvent].Linking = NO_LINK;
			TempEvents[CurrentChannelEvent].Link2Event = 0;
			m_LinkChk.SetCheck(0);
			m_LinkChk.SetWindowText("Not Linked");
			m_StartTimeStr = "Start Time (msec):";
		}
	}
	*/

	UpdateData(FALSE);
}

void CDACBudaSetupDlg::OnSelchangeEventlist() 
{
	CurrentChannelEvent = m_EventListBox.GetCurSel();
	OnUpdate();
}

void CDACBudaSetupDlg::OnChangeDelay() 
{
	char buffer[100];
	double delay=m_Delay;
	int CurrentEvent;
	int i;
	for (i=0; i<100; i++) buffer[i] = '\0';

	m_DelayEdit.GetLine(0,buffer,100);

	sscanf(buffer,"%lf",&delay);
	if(delay < 0) delay = 0;

	CurrentChannelEvent = m_EventListBox.GetCurSel();
	CurrentEvent = EventMap[CurrentChannelEvent];

	//todo: verify valid values of delay
	m_Delay = delay;

	TempEvents[CurrentEvent].time = m_Delay;

	OnUpdate();
}

void CDACBudaSetupDlg::OnChangeDuration() 
{
	char buffer[100];
	int CurrentEvent;
	int i;
	for (i=0; i<100; i++) buffer[i] = '\0';
	m_DurationEdit.GetLine(0,buffer,100);

	CurrentChannelEvent = m_EventListBox.GetCurSel();
	CurrentEvent = EventMap[CurrentChannelEvent];

	if(sscanf(buffer,"%lf",&m_Duration) <= 0) m_Duration = 0;
	//PS.GenPS[EventList[CurrentChannelEvent]].Width = m_Duration;

	TempEvents[CurrentEvent].Duration = m_Duration;
	OnUpdate();
}

void CDACBudaSetupDlg::OnChangeVoltage() 
{
	char buffer[100];
	int CurrentEvent;
	int i;
	for (i=0; i<100; i++) buffer[i] = '\0';
	m_VoltageEdit.GetLine(0,buffer,100);

	CurrentChannelEvent = m_EventListBox.GetCurSel();
	CurrentEvent = EventMap[CurrentChannelEvent];

	if(sscanf(buffer,"%lf",&m_Voltage) <= 0) m_Voltage = 0;
	// now check to be sure that this voltage is a valid one.
	// it must be within the range specified by the PS.dac info.
	CString str;
	if(m_Voltage > m_MaxVoltage) {
		str.Format("This DAC is limited to %1.3f Volts\n Voltage adjusted",m_MaxVoltage);
		MessageBox(str,"Overvoltage");
		m_Voltage = m_MaxVoltage;
	}
	if(m_Voltage < m_MinVoltage) {
		str.Format("This DAC is limited to %1.3f Volts\n Voltage adjusted",m_MinVoltage);
		MessageBox(str,"Undervoltage");
		m_Voltage = m_MinVoltage;
	}
	
	TempEvents[CurrentEvent].Voltage = m_Voltage;
	OnUpdate();
}

void CDACBudaSetupDlg::OnDacinit() 
{
	int i,CurrentEvent;

	for(i=0; i<eventnum; i++) {
		CurrentEvent = EventMap[i];
		if(TempEvents[CurrentEvent].EventType == DAC_Init) {
			MessageBox("There can only be one Init Event\n Changing this event to a Step","DAC Error");
			CurrentEvent = EventMap[CurrentChannelEvent];
			TempEvents[CurrentEvent].EventType = DAC_Step;
			OnUpdate();	
			return;
		}
	}

	CurrentEvent = EventMap[CurrentChannelEvent];
	TempEvents[CurrentEvent].EventType = DAC_Init;
	OnUpdate();	
}

void CDACBudaSetupDlg::OnDacpulse() 
{
	int CurrentEvent;
	CurrentEvent = EventMap[CurrentChannelEvent];

	TempEvents[CurrentEvent].EventType = DAC_Pulse;
	OnUpdate();	
}

void CDACBudaSetupDlg::OnDacramp() 
{
	int CurrentEvent;
	CurrentEvent = EventMap[CurrentChannelEvent];

	TempEvents[CurrentEvent].EventType = DAC_Ramp;
	OnUpdate();	
}

void CDACBudaSetupDlg::OnDacstep() 
{
	int CurrentEvent;
	CurrentEvent = EventMap[CurrentChannelEvent];

	TempEvents[CurrentEvent].EventType = DAC_Step;
	OnUpdate();	
}

void CDACBudaSetupDlg::SetupEventListBox()
{
	// this function clears the Eventlistbox and then
	// fills it with new events
	m_EventListBox.ResetContent();
	//pDoc->SortGenPS();

	CString str;
	int i;
	eventnum=0;
	InitEventExist = FALSE;
	InitEvent = 0;
	for(i=0; i<MAX_NUM_EVENTS; i++) EventMap[i]=0;

	for(i=0; i<MAX_NUM_EVENTS; i++) {
		if(TempEvents[i].EventType == DAC_Null) continue;
		if(TempEvents[i].Channel == Channel) {
			if(TempEvents[i].EventType == DAC_Init) {
				InitEventExist = TRUE;
				InitEvent = i;
				str.Format("%1.3f : Init. DAC to %1.1f Volts",TempEvents[i].time, TempEvents[i].Voltage);
			}
			if(TempEvents[i].EventType == DAC_Step)
				str.Format("%1.3f : Step DAC to %1.1f Volts",TempEvents[i].time, TempEvents[i].Voltage);
			if(TempEvents[i].EventType == DAC_Pulse)
				str.Format("%1.3f : Pulse DAC to %1.1f Volts",TempEvents[i].time, TempEvents[i].Voltage);
			if(TempEvents[i].EventType == DAC_Ramp)
				str.Format("%1.3f : Ramp DAC to %1.1f Volts",TempEvents[i].time, TempEvents[i].Voltage);
			m_EventListBox.AddString(str);
			EventMap[eventnum] = i;
			eventnum++;
		}
	}

	m_EventListBox.SetCurSel(CurrentChannelEvent);
}

void CDACBudaSetupDlg::OnUpdate()
{
	SetupEventListBox();
	InitEventInfo();
}

void CDACBudaSetupDlg::OnDeleteEvent() 
{
	int CurrentEvent;
	CurrentChannelEvent = m_EventListBox.GetCurSel();
	CurrentEvent = EventMap[CurrentChannelEvent];

	if(TempEvents[CurrentEvent].EventType == DAC_Init) {
		MessageBox("Cannot delete the initialization event","Error!");
		return;
	}
	TempEvents[CurrentEvent].time=0;
	TempEvents[CurrentEvent].Voltage=0;
	TempEvents[CurrentEvent].EventType=DAC_Null;
	CurrentChannelEvent = 0;
	m_EventListBox.SetCurSel(CurrentChannelEvent);
	OnUpdate();
}

void CDACBudaSetupDlg::OnAddEvent() 
{
	int i;
	for(i=0; i<MAX_NUM_EVENTS; i++) {
		if(TempEvents[i].EventType<=DAC_Null) break;
	}

	// add a blank event
	TempEvents[i].time=0;
	TempEvents[i].EventType=DAC_Step;
	TempEvents[i].Channel=Channel;
	TempEvents[i].Duration=0;
	TempEvents[i].Voltage=0;
	EventMap[eventnum]=i;
	eventnum++;
	m_EventListBox.SetCurSel(CurrentChannelEvent);
	OnUpdate();
}

void CDACBudaSetupDlg::OnClearAllEvents() 
{
	/*
	for(CurrentChannelEvent=0; CurrentChannelEvent<eventnum; CurrentChannelEvent++) {
		TempEvents[CurrentChannelEvent].time=0;
		TempEvents[CurrentChannelEvent].EventType=DAC_Null;
		TempEvents[CurrentChannelEvent].Channel=Channel;
		TempEvents[CurrentChannelEvent].Duration=0;
		TempEvents[CurrentChannelEvent].Voltage=0;
	}
	*/
	OnUpdate();
}

void CDACBudaSetupDlg::OnOK() 
{
	// check for overlapping events in time and condense them
	if(	CheckOverlappingEvents()) {
		MessageBox("Invalid value: \nTwo or more events overlap in time\nPlease correct this and continue","Error: Overlapping Events");
		return;
	}

	CDialog::OnOK();
}


BOOL CDACBudaSetupDlg::CheckOverlappingEvents()
{
	// compare to #define PB_MINUMUM_UPDATE_PERIOD 
	// to identify if there are any events within that
	// timeframe and condense them if there are.

	int i,j;
	double start2,stop2;
	double start1,stop1;
	int Event1, Event2;

	// basically making sure that for any particular channel,
	// there are not two things happening at the same time.

	for(i=0; i<eventnum; i++) {
		Event1 = EventMap[i];
		start1 = TempEvents[Event1].time;
		if(TempEvents[Event1].Duration <= 0) {
			stop1 = start1 + PB_MINUMUM_UPDATE_PERIOD;
		} else {
			stop1 = start1 + TempEvents[Event1].Duration;
		}
		for(j=i+1; j<eventnum; j++) {
			Event2 = EventMap[j];
			start2 = TempEvents[Event2].time;
			if(TempEvents[Event2].Duration <= 0) {
				stop2 = start2 + PB_MINUMUM_UPDATE_PERIOD;
			} else {
				stop2 = start2 + TempEvents[Event2].Duration;
			}
			if(start1>=start2 && start1<=stop2) return TRUE;
			if(stop1>=start2 && stop1<=stop2) return TRUE;
			if(start2>=start1 && start2<=stop1) return TRUE;
			if(stop2>=start1 && stop2<=stop1) return TRUE;
		}
	}
	return FALSE;
}

void CDACBudaSetupDlg::OnLinkChk() 
{
/*	if(PS.GenPS[EventList[CurrentChannelEvent]].EventType == DAC_INIT) {
		MessageBox("Rejected:\nCannot link an Initialization event","Error: Invalid Input");
		return;
	}

	CLinkingDlg dlg;
	dlg.Linking = PS.GenPS[EventList[CurrentChannelEvent]].Linking;
	dlg.InEvent = PS.GenPS[EventList[CurrentChannelEvent]].Link2Event;
	dlg.CurrentChannelEvent = EventList[CurrentChannelEvent];
	dlg.pPS = &PS;
	dlg.pSys = pDoc->sys;
	dlg.pDoc = pDoc;

	if( dlg.DoModal() == IDOK) {
		if(dlg.Linking != NO_LINK && dlg.InEvent == EventList[CurrentChannelEvent]) {
			MessageBox("Cannot link an event to itself\nRejecting the link","Error: Invalid link");
			PS.GenPS[EventList[CurrentChannelEvent]].Link2Event=0;
			PS.GenPS[EventList[CurrentChannelEvent]].Linking = NO_LINK;
			
		} else {
			pDoc->RecalcEventTime(&PS, EventList[CurrentChannelEvent],dlg.Linking,dlg.InEvent);		

			m_Delay = PS.GenPS[EventList[CurrentChannelEvent]].Delay;
			m_Voltage = PS.GenPS[EventList[CurrentChannelEvent]].Value;	

			InitEventInfo();
			UpdateData(FALSE);
		}
	}

	if(PS.GenPS[EventList[CurrentChannelEvent]].Linking == NO_LINK) m_LinkChk.SetCheck(0);
	else m_LinkChk.SetCheck(1);
	*/
}


