/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_DACSETUPDLG_H__DB06E102_5DC4_11D2_B907_9E81BA4C2427__INCLUDED_)
#define AFX_DACSETUPDLG_H__DB06E102_5DC4_11D2_B907_9E81BA4C2427__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DACSetupDlg.h : header file
//

//	StartFlags definitions
#define ADD_NEW_EVENT 1
#define STANDARD_STARTUP 0

/////////////////////////////////////////////////////////////////////////////
// CDACBudaSetupDlg dialog

class CDACBudaSetupDlg : public CDialog
{
// Construction
public:
	int EventMap[MAX_NUM_EVENTS];
	BOOL CheckOverlappingEvents();
//	DAC_Parameters_Struct* pDACParms;
	double m_MaxVoltage;
	double m_MinVoltage;
	EventStruct *TempEvents;
//	EventStruct *Events;
	int InitEvent;
	BOOL InitEventExist;
//	struct sys* pSys;
//	struct PS PS;
	int StartFlags;
	int eventnum;
	void OnUpdate();
	void SetupEventListBox();
//	int EventList[MAX_PS_EVENTS];
	void InitEventInfo();
	int CurrentChannelEvent;
//	struct PS* pPS;
//	CBudaDoc* pDoc;
	int Channel;
	BOOL OnInitDialog();
	CDACBudaSetupDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CDACBudaSetupDlg)
	enum { IDD = IDD_DACSETUP };
	CStatic	m_DelayCtrl;
	CStatic	m_DurationCtrl;
	CEdit	m_DelayEdit;
	CButton	m_LinkChk;
	CButton	m_OkBtn;
	CEdit	m_DurationEdit;
	CEdit	m_VoltageEdit;
	CButton	m_DACInitBtn;
	CButton	m_DACStepBtn;
	CButton	m_DACPulseBtn;
	CButton	m_DACRampBtn;
	CListBox	m_EventListBox;
	CString	m_DACName;
	double	m_Delay;
	double	m_Duration;
	double	m_Voltage;
	CString	m_StartTimeStr;
	CString	m_TrapLinkStr;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDACBudaSetupDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDACBudaSetupDlg)
	afx_msg void OnLinkDac();
	afx_msg void OnSelchangeEventlist();
	afx_msg void OnChangeDelay();
	afx_msg void OnChangeDuration();
	afx_msg void OnChangeVoltage();
	afx_msg void OnDacinit();
	afx_msg void OnDacpulse();
	afx_msg void OnDacramp();
	afx_msg void OnDacstep();
	afx_msg void OnDeleteEvent();
	afx_msg void OnAddEvent();
	afx_msg void OnClearAllEvents();
	virtual void OnOK();
	afx_msg void OnLinkChk();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DACSETUPDLG_H__DB06E102_5DC4_11D2_B907_9E81BA4C2427__INCLUDED_)
