// DAC_Master.h : main header file for the DACCTRLDLG application
//

#define MAX_NUM_DACS 24
#define NUM_RAMP_STEPS 100
#define MAX_NUM_EVENTS 1000

// DAC Event Options
#define DAC_Null	0
#define DAC_Init	1
#define DAC_Step	2
#define DAC_Pulse	3
#define DAC_Ramp	4

// Pulseblaster minima
#define PB_MINUMUM_UPDATE_PERIOD	0.000090 // milliseconds 
#define PB_Resolution				0.000010 // milliseconds
#define MAX_PB_EVENTS				32768

#define DAC_Minimum_Update_Period	0.001	 // milliseconds
#define NUM_STEPS_PER_DAC_RAMP	100

// Trigger mask definitions
#define DAC0_MASK	0x0200
#define DAC1_MASK	0x0100
#define DAC2_MASK	0x0080
#define DIO_MASK	0x0040
#define DIG_MASK	0x0020
#define AWG_MASK	0x0010

struct PB_Pattern
{
	double time;
	unsigned int pattern;
};

struct DAC_Parameters_Struct  
{
	CString DACName;
	char SmallName[9];
	int DACNumber;
	int CardNumber;	// also equals the PB trigger number
	int BitDepth;
	int MaxDigValue;
	int MinDigValue;
	double MaxVoltage;
	double MinVoltage;
};

struct EventStruct  
{
//	struct DAC_Parameters_Struct* DACparms;
	double time; // in milliseconds from the start of this PS
	int Channel;
	int EventType; // Event_Init, Event_Change, Event_Pulse, Event_Ramp
	double Voltage;
	double Duration;
//	double DAC_Values[MAX_NUM_DACS];
//	int DAC_Change[MAX_NUM_DACS];
	/* DAC_Values are the voltage values for that DAC at the time of
	this event as follows:
	Event_Init,		DAC_Value = Initialization voltage
	Event_Change,	DAC_Value = voltage after change
	Event_Pulse,	DAC_Value = voltage during pulse 
			(gets entered into final event table as 2 events)
	Event_Ramp,		DAC_Value = current value
			(gets entered into final event table as NUM_RAMP_STEPS steps)
	*/

};