// DebugDialog.cpp : implementation file
//

#include "stdafx.h"
#include "buda.h"
#include "DebugDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDebugDialog dialog


CDebugDialog::CDebugDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CDebugDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDebugDialog)
	m_FtmFreqTxt = _T("");
	m_FtmMtfMassTxt = _T("");
	m_MtfMassTxt = _T("");
	m_MtfFtmFreqTxt = _T("");
	m_Mass = 0.0;
	m_Freq = 0.0;
	m_MtpMassTxt = _T("");
	m_PtmMtpMassTxt = _T("");
	m_FtpFreqTxt = _T("");
	m_PtfFtpFreqTxt = _T("");
	m_PtmFtpFreqTxt = _T("");
	m_PtmMtpMass2Txt = _T("");
	m_PtmMtpMass3Txt = _T("");
	m_PtmFtpFreq2Txt = _T("");
	m_PtmFtpFreq3Txt = _T("");
	//}}AFX_DATA_INIT
}


void CDebugDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDebugDialog)
	DDX_Text(pDX, IDC_FTM_FREQ_TXT, m_FtmFreqTxt);
	DDX_Text(pDX, IDC_FTM_MTF_MASS_TXT, m_FtmMtfMassTxt);
	DDX_Text(pDX, IDC_MTF_MASS_TXT, m_MtfMassTxt);
	DDX_Text(pDX, IDC_MTF_FTM_FREQ_TXT, m_MtfFtmFreqTxt);
	DDX_Text(pDX, IDC_FTM_MASS_BOX, m_Mass);
	DDV_MinMaxDouble(pDX, m_Mass, 10., 1000000.);
	DDX_Text(pDX, IDC_FTM_FREQ_BOX, m_Freq);
	DDV_MinMaxDouble(pDX, m_Freq, 10., 20000000.);
	DDX_Text(pDX, IDC_MTP_MASS_TXT, m_MtpMassTxt);
	DDX_Text(pDX, IDC_PTM_MTP_MASS_TXT, m_PtmMtpMassTxt);
	DDX_Text(pDX, IDC_FTP_FREQ_TXT, m_FtpFreqTxt);
	DDX_Text(pDX, IDC_PTF_FTP_FREQ_TXT2, m_PtfFtpFreqTxt);
	DDX_Text(pDX, IDC_PTM_FTP_FREQ_TXT, m_PtmFtpFreqTxt);
	DDX_Text(pDX, IDC_PTM_MTP_MASS_TXT2, m_PtmMtpMass2Txt);
	DDX_Text(pDX, IDC_PTM_MTP_MASS_TXT3, m_PtmMtpMass3Txt);
	DDX_Text(pDX, IDC_PTF_FTP_FREQ_TXT3, m_PtmFtpFreq2Txt);
	DDX_Text(pDX, IDC_PTF_FTP_FREQ_TXT4, m_PtmFtpFreq3Txt);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDebugDialog, CDialog)
	//{{AFX_MSG_MAP(CDebugDialog)
	ON_EN_CHANGE(IDC_FTM_FREQ_BOX, OnChangeFtmFreqBox)
	ON_EN_CHANGE(IDC_FTM_MASS_BOX, OnChangeFtmMassBox)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDebugDialog message handlers

BOOL CDebugDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_Mass=1000.0;
	m_Freq=100000.0;

	// force the DoDataExchange to initialize things
	UpdateData(FALSE);
	UpdateDlgData();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDebugDialog::UpdateDlgData()
{
	UpdateData(TRUE);
	if(pDoc) {
		mtf_mass=pDoc->MassToFreq(m_Mass);
		ftm_mtf_mass=pDoc->FreqToMass(mtf_mass);
		ftm_freq=pDoc->FreqToMass(m_Freq);
		mtf_ftm_freq=pDoc->MassToFreq(ftm_freq);
		mtp_mass=pDoc->MassToPt(m_Mass);
		ptm_mtp_mass=pDoc->PtToMass(mtp_mass);
		ptm_mtp_mass2=pDoc->PtToMass(mtp_mass+1);
		ptm_mtp_mass3=pDoc->PtToMass(mtp_mass-1);
		ftp_freq=pDoc->FreqToPt(mtf_mass);
		ptf_ftp_freq=pDoc->PtToFreq(ftp_freq);
		ptm_ftp_freq=pDoc->PtToMass(ftp_freq);
		ptm_ftp_freq2=pDoc->PtToMass(ftp_freq+1);
		ptm_ftp_freq3=pDoc->PtToMass(ftp_freq-1);
	}
	m_MtfMassTxt.Format("%1.4f",mtf_mass);
	m_FtmMtfMassTxt.Format("%1.4f",ftm_mtf_mass);
	m_FtmFreqTxt.Format("%1.4f",ftm_freq);
	m_MtfFtmFreqTxt.Format("%1.4f",mtf_ftm_freq);
	m_MtpMassTxt.Format("%d",mtp_mass);
	m_PtmMtpMassTxt.Format("%1.4f",ptm_mtp_mass);
	m_PtmMtpMass2Txt.Format("%1.4f",ptm_mtp_mass2);
	m_PtmMtpMass3Txt.Format("%1.4f",ptm_mtp_mass3);
	m_FtpFreqTxt.Format("%d",ftp_freq);
	m_PtfFtpFreqTxt.Format("%1.4f",ptf_ftp_freq);
	m_PtmFtpFreq2Txt.Format("%1.4f",ptm_ftp_freq2);
	m_PtmFtpFreq3Txt.Format("%1.4f",ptm_ftp_freq3);

	UpdateData(FALSE);

}

void CDebugDialog::OnChangeFtmFreqBox() 
{
	UpdateDlgData();
}

void CDebugDialog::OnChangeFtmMassBox() 
{
	UpdateDlgData();
}
