// DeconOptions.cpp : implementation file
//

#include "stdafx.h"
#include "buda.h"
#include "DeconOptions.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDeconOptions dialog


CDeconOptions::CDeconOptions(CWnd* pParent /*=NULL*/)
	: CDialog(CDeconOptions::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDeconOptions)
	m_HighMass = 0.0;
	m_LowMass = 0.0;
	m_MaxCharge = 0;
	m_DeconRes = 0.0;
	m_AdductMass = 0.0;
	m_MinCharge = 0;
	m_IsotopicallyResolved = FALSE;
	//}}AFX_DATA_INIT
}


void CDeconOptions::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDeconOptions)
	DDX_Text(pDX, IDC_HIGHMASS, m_HighMass);
	DDX_Text(pDX, IDC_LOWMASS, m_LowMass);
	DDX_Text(pDX, IDC_MAXCHARGE, m_MaxCharge);
	DDX_Text(pDX, IDC_DECON_RESOLUTION, m_DeconRes);
	DDX_Text(pDX, IDC_ADDUCT_MASS, m_AdductMass);
	DDX_Text(pDX, IDC_MINCHARGE, m_MinCharge);
	DDX_Control(pDX, IDC_DECONMETHOD_FENN2, m_DeconFennBtn);
	DDX_Control(pDX, IDC_DECONMETHOD_REINHOLD2, m_DeconReinholdBtn);
	DDX_Control(pDX, IDC_DECONMETHOD_OCONNOR2, m_DeconOConnorBtn);
	DDX_Control(pDX, IDC_DECONMETHOD_ZHANG2, m_DeconZhangBtn);
	DDX_Control(pDX, IDC_REPORTED_Z_0, m_Z0);
	DDX_Control(pDX, IDC_REPORTED_Z_1, m_Z1);
	DDX_Check(pDX, IDC_ISOTOPICALLY_RESOLVED, m_IsotopicallyResolved);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDeconOptions, CDialog)
	//{{AFX_MSG_MAP(CDeconOptions)
	ON_BN_CLICKED(IDC_DECONMETHOD_FENN2, OnDeconmethodFenn)
	ON_BN_CLICKED(IDC_DECONMETHOD_OCONNOR2, OnDeconmethodOconnor)
	ON_BN_CLICKED(IDC_DECONMETHOD_REINHOLD2, OnDeconmethodReinhold)
	ON_BN_CLICKED(IDC_DECONMETHOD_ZHANG2, OnDeconmethodZhang)
	ON_BN_CLICKED(IDC_ISOTOPICALLY_RESOLVED, OnIsotopicallyResolved)
	ON_BN_CLICKED(IDC_REPORTED_Z_0, OnReportedZ0)
	ON_BN_CLICKED(IDC_REPORTED_Z_1, OnReportedZ1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDeconOptions message handlers

BOOL CDeconOptions::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	switch(m_DeconMethod) {
	case DECON_FENN:
		OnDeconmethodFenn();
		break;
	case DECON_REINHOLD:
		OnDeconmethodReinhold();
		break;
	case DECON_OCONNOR:
		OnDeconmethodOconnor();
		break;
	case DECON_ZHANG:
		OnDeconmethodZhang();
		break;
	}	
	
	switch(m_ReportedZ) {
	case 0:
		OnReportedZ0();
		break;
	case 1:
		OnReportedZ1();
		break;
	default:
		OnReportedZ0();
		break;
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDeconOptions::OnDeconmethodFenn() 
{
	m_DeconMethod = DECON_FENN;
	m_DeconFennBtn.SetCheck(TRUE);
	m_DeconReinholdBtn.SetCheck(FALSE);
	m_DeconOConnorBtn.SetCheck(FALSE);
	m_DeconZhangBtn.SetCheck(FALSE);
}

void CDeconOptions::OnDeconmethodReinhold() 
{
	m_DeconMethod = DECON_REINHOLD;
	m_DeconFennBtn.SetCheck(FALSE);
	m_DeconReinholdBtn.SetCheck(TRUE);
	m_DeconOConnorBtn.SetCheck(FALSE);
	m_DeconZhangBtn.SetCheck(FALSE);
}

void CDeconOptions::OnDeconmethodOconnor() 
{
	m_DeconMethod = DECON_OCONNOR;
	m_DeconFennBtn.SetCheck(FALSE);
	m_DeconReinholdBtn.SetCheck(FALSE);
	m_DeconOConnorBtn.SetCheck(TRUE);
	m_DeconZhangBtn.SetCheck(FALSE);
}


void CDeconOptions::OnDeconmethodZhang() 
{
	m_DeconMethod = DECON_ZHANG;
	m_DeconFennBtn.SetCheck(FALSE);
	m_DeconReinholdBtn.SetCheck(FALSE);
	m_DeconOConnorBtn.SetCheck(FALSE);
	m_DeconZhangBtn.SetCheck(TRUE);
}

void CDeconOptions::OnIsotopicallyResolved() 
{
	// TODO: Add your control notification handler code here
	return;
}

void CDeconOptions::OnReportedZ0() 
{
	m_ReportedZ = 0;
	m_Z0.SetCheck(TRUE);
	m_Z1.SetCheck(FALSE);
}

void CDeconOptions::OnReportedZ1() 
{
	m_ReportedZ = 1;
	m_Z0.SetCheck(FALSE);
	m_Z1.SetCheck(TRUE);
}

