/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_DECONOPTIONSDLG_H__00435A00_DE45_11D3_AFFA_0090278ECA2A__INCLUDED_)
#define AFX_DECONOPTIONSDLG_H__00435A00_DE45_11D3_AFFA_0090278ECA2A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DeconOptionsDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDeconOptionsDlg dialog

class CDeconOptionsDlg : public CPropertyPage
{
// Construction
public:
	CBudaDoc* pDoc;
	void ValidateParms();
	int m_ReportedZ;
	int m_DeconMethod;
	CDeconOptionsDlg();   // standard constructor
	void OnUpdate();
	virtual BOOL OnSetActive();
	CButton m_DeconFennBtn;
	CButton m_DeconReinholdBtn;
	CButton m_DeconOConnorBtn;
	CButton m_DeconZhangBtn;
	CButton m_Z0;
	CButton m_Z1;

// Dialog Data
	//{{AFX_DATA(CDeconOptionsDlg)
	enum { IDD = IDD_DECONOPTIONS };
	CEdit	m_MinChargeEdit;
	CEdit	m_DeconResEdit;
	CEdit	m_MaxChargeEdit;
	CEdit	m_LowMassEdit;
	CEdit	m_HighMassEdit;
	double	m_HighMass;
	double	m_LowMass;
	UINT	m_MaxCharge;
	double	m_DeconRes;
	double	m_AdductMass;
	UINT	m_MinCharge;
	BOOL	m_IsotopicallyResolved;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDeconOptionsDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDeconOptionsDlg)
	afx_msg void OnDeconmethodFenn();
	afx_msg void OnDeconmethodReinhold();
	afx_msg void OnDeconmethodOconnor();
	afx_msg void OnDeconmethodZhang();
	afx_msg void OnKillfocusHighmass();
	afx_msg void OnKillfocusLowmass();
	afx_msg void OnKillfocusMaxcharge();
	virtual void OnOK();
	afx_msg void OnKillfocusDeconResolution();
	afx_msg void OnToolsElementalcomp();
	afx_msg void OnSaveAsDefaults();
	afx_msg void OnIsotopicallyResolved();
	afx_msg void OnReportedZ0();
	afx_msg void OnReportedZ1();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DECONOPTIONSDLG_H__00435A00_DE45_11D3_AFFA_0090278ECA2A__INCLUDED_)
