// Deconvolution.h: interface for the CDeconvolution class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DECONVOLUTION_H__570B76E0_049E_11D4_AFFA_0090278ECA2A__INCLUDED_)
#define AFX_DECONVOLUTION_H__570B76E0_049E_11D4_AFFA_0090278ECA2A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef float CfReal;
class CBudaView;

class CDeconvolution  
{
public:
//	CBudaDoc* GetpDoc();
//	static CfReal fpPtToMass(CfReal point);
//	static CfReal fpMassToPt(CfReal mass);
	BOOL DeconIsotopicallyResolved;
	long CreateMITable(float* Mass, float* Intensity);
	void splint(double* xa,double* ya,double* y2a,long n,double x,double* y);
	void spline(double* x,double* y,long n,double yp1,double ypn,double* y2);
	void CreateIndexTable(long NumPeaks, long* indexx);
	long GetMITableInt(double mass, double deltafreq);
	void AddToDeconData(double mass, int charge);
	void FindNeighbors(int CurrentCharge, long CurrentIndex, long* indexx);
	int GetChargeState(long index);
	long FindHighestUnprocessedPeak(long* indexx, double* CurrentIntensity);
	void CalculateOConnor2Decon();
	long MaxDeconIndex;
	float MaxDeconIntensity;
	double GetDeconThreshold();
	double DeconSigma;
	double DeconThreshold;
	double NoiseSigma;
	double NoiseThreshold;
	double GetNoiseThreshold();
	double AdductMass;
	void CheckDeconSize();
	float PtToMass(long);
	long MassToPt(float mass);
	double DeconRes;
	long DeconSize;
	CDeconvolution();
	virtual ~CDeconvolution();
	void CalculateFennDecon();
	void CalculateReinholdDecon();
	void CalculateOConnorDecon();
	double GetIntensityatMass(double mass);

	int DeconMethod;
	UINT DeconHighChargeLimit;
	UINT DeconLowChargeLimit;
	double DeconLowMassLimit;
	double DeconHighMassLimit;
	int DeconReportedZ;
	float DeconData[MAX_DECON_SIZE];
	CBudaApp* pApp;
	CBudaDoc* pDoc;
	CBudaView* pView;
};

#endif // !defined(AFX_DECONVOLUTION_H__570B76E0_049E_11D4_AFFA_0090278ECA2A__INCLUDED_)
