/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_DETECTDLG_H__DB06E101_5DC4_11D2_B907_9E81BA4C2427__INCLUDED_)
#define AFX_DETECTDLG_H__DB06E101_5DC4_11D2_B907_9E81BA4C2427__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DetectDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDetectDlg dialog
#define CHROMATOGRAPHY_MODE 0
#define SINGLEACQ_MODE 1

class CDetectDlg : public CDialog
{
// Construction
public:
	long m_NumSpectra;
	CBudaDoc* pDoc;
	long m_NumScans;
	void OnUpdate();
	void UpdateAcqMode();
	struct sys* pSys;
	struct PS* pPS;
	double ADCRates[12];
	double AdcRate;
	long NumDataPoints;
	long NDP[12];
	CString NDPComboEntries[12];
	int DetectMode;
	int AcqMode;
	CFont m_font;
	void SetListBoxFont();
	BOOL OnInitDialog();
	CDetectDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CDetectDlg)
	enum { IDD = IDD_SETUP_DETECTION_DLG };
	CEdit	m_MonitorMassEdit;
	CEdit	m_HighMassEdit;
	CEdit	m_LowMassEdit;
	CStatic	m_NumSpecTitle;
	CStatic	m_WarningStatic;
	CStatic	m_MixerFreqTitleStatic;
	CStatic	m_MixerFreqStatic;
	CButton	m_DirectModeBtn;
	CButton	m_MixerModeBtn;
	CButton	m_AcqModeSingle;
	CButton	m_AcqModeChrom;
	CButton	m_AcqModeTimeScan;
	CComboBox	m_AcqRateCombo;
	CComboBox	m_NDPCombo;
	CButton	m_LinkBtn;
	double	m_HighMass;
	double	m_LowMass;
	double	m_MonitorMass;
	CString	m_DetectTime;
	CString	m_MixerFreq;
	CString	m_NumScansString;
	CString	m_NumSpectraString;
	CString	m_WarningString;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDetectDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDetectDlg)
	afx_msg void OnLink();
	afx_msg void OnSelchangeNdpcombo();
	afx_msg void OnSelchangeAcqrateCombo();
	afx_msg void OnDetectmodeDirect();
	afx_msg void OnDetectmodeMixer();
	afx_msg void OnAcqModeChrom();
	afx_msg void OnAcqModeSingle();
	afx_msg void OnAcqModeTimescan();
	afx_msg void OnLinkChk();
	afx_msg void OnKillfocusLowmass();
	afx_msg void OnKillfocusHighmass();
	afx_msg void OnKillfocusMonitormass();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DETECTDLG_H__DB06E101_5DC4_11D2_B907_9E81BA4C2427__INCLUDED_)
