/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_DISPLAYOPTIONS_H__57000101_9D69_11D1_9106_44455354616F__INCLUDED_)
#define AFX_DISPLAYOPTIONS_H__57000101_9D69_11D1_9106_44455354616F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// DisplayOptions.h : header file
//
#include "BudaMaster.h"
/////////////////////////////////////////////////////////////////////////////
// CDisplayOptions dialog

class CDisplayOptions : public CPropertyPage
{
	DECLARE_DYNCREATE(CDisplayOptions)

// Construction
public:
	struct DispParms dp;
	CBudaDoc* pDoc;
	BOOL m_LabelPeakPos;
	CDisplayOptions();
	~CDisplayOptions();

// Dialog Data
	//{{AFX_DATA(CDisplayOptions)
	enum { IDD = IDD_DISP_PARMS };
	CButton	m_DispScalefactorBtn;
	CButton	m_disp_labelcharge_btn;
	CButton	m_disp_time_btn;
	CButton	m_disp_posneg_btn;
	CButton	m_noisebtn;
	CButton	m_labelptsbtn;
	CButton	m_LablePeakPosbtn;
	CButton	m_disptrapbtn;
	CButton	m_dispdatebtn;
	CButton	m_dispzerobtn;
	CButton	m_dispscansbtn;
	CButton	m_dispnumptsbtn;
	CButton	m_dispnotesbtn;
	CButton	m_dispmassbtn;
	CButton	m_dispfilebtn;
	CButton	m_dispexcbtn;
	CButton	m_dispcalbtn;
	CButton	m_dispapodbtn;
	CButton	m_dispacqbtn;
	CButton	m_dispparmsbtn;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CDisplayOptions)
	public:
	virtual BOOL OnSetActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CDisplayOptions)
	afx_msg void OnDispParmsClicked();
	afx_msg void OnLabelPeakPos();
	afx_msg void OnDispAcqrate();
	afx_msg void OnDispApodfunc();
	afx_msg void OnDispCalconsts();
	afx_msg void OnDispExcamp();
	afx_msg void OnDispFilename();
	afx_msg void OnDispMassrange();
	afx_msg void OnDispNotes();
	afx_msg void OnDispNumpts();
	afx_msg void OnDispNumscans();
	afx_msg void OnDispNumzerofills();
	afx_msg void OnDispTimedate();
	afx_msg void OnDispTrapvolts();
	afx_msg void OnLabelPts();
	afx_msg void OnNoisethreshold();
	afx_msg void OnLablecharge();
	afx_msg void OnDispPosneg();
	afx_msg void OnDispTime();
	afx_msg void OnDispScalefactor();
	afx_msg void OnSaveasdefaults();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DISPLAYOPTIONS_H__57000101_9D69_11D1_9106_44455354616F__INCLUDED_)
