/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_EDITARBDLG_H__BFA036E1_7AD0_11D2_B907_9ABEA479E36E__INCLUDED_)
#define AFX_EDITARBDLG_H__BFA036E1_7AD0_11D2_B907_9ABEA479E36E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// EditARBDlg.h : header file
//

#include "ARBPlotBtn.h"

/////////////////////////////////////////////////////////////////////////////
// CEditARBDlg dialog

class CEditARBDlg : public CDialog
{
// Construction
public:
	int NumArbEvents;
	struct ArbEvent NullARBEvent;
	void CalculateSamples();
	void CalculateFilter();
	void CalculateDacRate();
	void CalculateAmplitude();
	CDC* pDC;
	BOOL CheckOverlappingWindows();
	BOOL CheckOverlappingNotches();
	struct PS* pPS;
	int GetNextARBEvent();
	int CurrentArbWaveform;
	struct PS PSold;
	CBudaDoc* pDoc;
	CRect ViewSize;
	void UpdateARB();
	BOOL OnInitDialog();
	CEditARBDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CEditARBDlg)
	enum { IDD = IDD_EDIT_ARB };
	CListBox	m_EventListBox;
	CARBPlotBtn	m_ARBPlotBtn;
	CButton	m_AddNotchBtn;
	CButton	m_AddWindowBtn;
	CButton	m_AdvancedBtn;
	CButton	m_ChangeDisplayBtn;
	CButton	m_ARBFilesBtn;
	CString	m_DACText;
	CString	m_DurationText;
	CString	m_FilterText;
	CString	m_AmplitudeText;
	CString	m_MemoryText;
	CString	m_WindowText;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEditARBDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CEditARBDlg)
	afx_msg void OnAddnotch();
	afx_msg void OnAddwindow();
	afx_msg void OnArbAdvanced();
	afx_msg void OnArbFiles();
	afx_msg void OnChangeArbDisplay();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnRemovearbevent();
	afx_msg void OnEditarbevent();
	afx_msg void OnSelchangeEventlistbox();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EDITARBDLG_H__BFA036E1_7AD0_11D2_B907_9ABEA479E36E__INCLUDED_)
