// ElemCompDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "ElemCompDlg.h"
#include <math.h>
#include "ResultsDlg.h"

#define ELECTRONMASS 0.00054857

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CElemCompDlg dialog

CElemCompDlg::CElemCompDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CElemCompDlg::IDD, pParent)
{
	int i;
	for(i=0; i<10; i++) {
		m_Elem[i] = _T("");
		m_Mass[i] = 0.0;
		m_Max[i] = 0;
		m_Min[i] = 0;
	}
	//{{AFX_DATA_INIT(CElemCompDlg)
	m_ChargeState = 0;
	m_MeasuredMass = 0.0;
	m_Tolerance = 0.0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CElemCompDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Text(pDX, IDC_ELEM1, m_Elem[0]);
	DDX_Text(pDX, IDC_ELEM2, m_Elem[1]);
	DDX_Text(pDX, IDC_ELEM3, m_Elem[2]);
	DDX_Text(pDX, IDC_ELEM4, m_Elem[3]);
	DDX_Text(pDX, IDC_ELEM5, m_Elem[4]);
	DDX_Text(pDX, IDC_ELEM6, m_Elem[5]);
	DDX_Text(pDX, IDC_ELEM7, m_Elem[6]);
	DDX_Text(pDX, IDC_ELEM8, m_Elem[7]);
	DDX_Text(pDX, IDC_ELEM9, m_Elem[8]);
	DDX_Text(pDX, IDC_ELEM10, m_Elem[9]);

	DDX_Text(pDX, IDC_MASS1, m_Mass[0]);
	DDX_Text(pDX, IDC_MASS2, m_Mass[1]);
	DDX_Text(pDX, IDC_MASS3, m_Mass[2]);
	DDX_Text(pDX, IDC_MASS4, m_Mass[3]);
	DDX_Text(pDX, IDC_MASS5, m_Mass[4]);
	DDX_Text(pDX, IDC_MASS6, m_Mass[5]);
	DDX_Text(pDX, IDC_MASS7, m_Mass[6]);
	DDX_Text(pDX, IDC_MASS8, m_Mass[7]);
	DDX_Text(pDX, IDC_MASS9, m_Mass[8]);
	DDX_Text(pDX, IDC_MASS10, m_Mass[9]);

	DDX_Text(pDX, IDC_MAX1, m_Max[0]);
	DDX_Text(pDX, IDC_MAX2, m_Max[1]);
	DDX_Text(pDX, IDC_MAX3, m_Max[2]);
	DDX_Text(pDX, IDC_MAX4, m_Max[3]);
	DDX_Text(pDX, IDC_MAX5, m_Max[4]);
	DDX_Text(pDX, IDC_MAX6, m_Max[5]);
	DDX_Text(pDX, IDC_MAX7, m_Max[6]);
	DDX_Text(pDX, IDC_MAX8, m_Max[7]);
	DDX_Text(pDX, IDC_MAX9, m_Max[8]);
	DDX_Text(pDX, IDC_MAX10, m_Max[9]);

	DDX_Text(pDX, IDC_MIN1, m_Min[0]);
	DDX_Text(pDX, IDC_MIN2, m_Min[1]);
	DDX_Text(pDX, IDC_MIN3, m_Min[2]);
	DDX_Text(pDX, IDC_MIN4, m_Min[3]);
	DDX_Text(pDX, IDC_MIN5, m_Min[4]);
	DDX_Text(pDX, IDC_MIN6, m_Min[5]);
	DDX_Text(pDX, IDC_MIN7, m_Min[6]);
	DDX_Text(pDX, IDC_MIN8, m_Min[7]);
	DDX_Text(pDX, IDC_MIN9, m_Min[8]);
	DDX_Text(pDX, IDC_MIN10, m_Min[9]);

	//{{AFX_DATA_MAP(CElemCompDlg)
	DDX_Text(pDX, IDC_CHARGESTATE, m_ChargeState);
	DDX_Text(pDX, IDC_MASS, m_MeasuredMass);
	DDX_Text(pDX, IDC_TOLERANCE, m_Tolerance);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CElemCompDlg, CDialog)
	//{{AFX_MSG_MAP(CElemCompDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CALCULATE, OnCalculate)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CElemCompDlg message handlers

BOOL CElemCompDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	InitializeMemberVariables();
	UpdateData(FALSE);

	// Add "About..." menu item to system menu.

	/*  --- this stuff was added by visual studio in elemcomp's
	    --- previous incarnation as a stand-alone program.
		--- Peter O'Connor


	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	*/

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CElemCompDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	// "Pete" this stuff isn't necessary in the version put into BUDA
/*	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
*/
	CDialog::OnSysCommand(nID, lParam);
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CElemCompDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CElemCompDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CElemCompDlg::InitializeMemberVariables()
{
	m_ChargeState = 0;
	//m_Mass = 0.0;
	//m_Tolerance = 0;

	int i;
	for(i=0; i<10; i++) {
		m_Elem[i] = "---";
		m_Mass[i] = 0.0;
		m_Min[i] = 0;
		m_Max[i] = 0;
	}

	// add cho
	m_Elem[0] = "C";
	m_Mass[0] = 12.000;
	m_Min[0]  = 0;
	m_Max[0]  = 10;

	m_Elem[1] = "H";
	m_Mass[1] = 1.007825035;
	m_Min[1]  = 0;
	m_Max[1]  = 25;

	m_Elem[2] = "O";
	m_Mass[2] = 15.99491463;
	m_Min[2]  = 0;
	m_Max[2]  = 10;

	m_Elem[3] = "N";
	m_Mass[3] = 14.00307400;
	m_Min[3]  = 0;
	m_Max[3]  = 2;

	m_Elem[4] = "S";
	m_Mass[4] = 31.97207070;
	m_Min[4]  = 0;
	m_Max[4]  = 2;

	m_Elem[5] = "P";
	m_Mass[5] = 30.9737620;
	m_Min[5]  = 0;
	m_Max[5]  = 2;

	m_Elem[6] = "Na";
	m_Mass[6] = 22.9897677;
	m_Min[6]  = 0;
	m_Max[6]  = 2;

	ClearResults();
}

void CElemCompDlg::OnCalculate() 
{
	int i,j;
	double tempmass;
	CString tempcomp;
	ClearResults();

	// this function does the 10 tiered loop and creates 
	// the list of masses and compositions.
	UpdateData(TRUE);
	
	// setup comp.
	for(i=0; i<10; i++) {
		comp[i]=m_Min[i];
	}

	Composition(0);

	// sort hits
	for(i=0;i<NumHits; i++) {
		if(fabs(MassList[i] - m_MeasuredMass) < fabs(MassList[i-1] - m_MeasuredMass)) {
			for(j=i; j>0; j--) {
				while(fabs(MassList[j] - m_MeasuredMass) < fabs(MassList[j-1] - m_MeasuredMass)) {
					tempmass = MassList[j];
					MassList[j]=MassList[j-1];
					MassList[j-1]=tempmass;

					tempcomp = MassComp[j];
					MassComp[j] = MassComp[j-1];
					MassComp[j-1]=tempcomp;
				} // while
			} // for j
		}  // if
	} // for i

	// popup window to display results.
	CResultsDlg dlg;
	CString str;
	dlg.m_ResultsString = "";
	for(i=0;i<NumHits; i++) {
		str.Format("%1.5f   %1.5f   %s\r\n",m_MeasuredMass-MassList[i],MassList[i],MassComp[i]);
		dlg.m_ResultsString += str;
	}
	dlg.DoModal();

}

void CElemCompDlg::Composition(int index)
{
	double mass = 0;
	int i;

	// this function is called recursively.
	// 
	// if index < 9, it calls Composition with 
	// index = index +1;
	//
	// if index = 9, do the 9th loop and return.
	// on return, if index != 9, increment comp[index] until max.
	if(index < 10 && m_Max[index] != 0) {
		while(comp[index] < m_Max[index]) {
			Composition(index+1);
			comp[index]++;
			for(i=index+1; i<10; i++) comp[i]=0;
		}
	} else {
		mass = 0;
		for(i=0; i<10; i++) {
			if(m_Max[i]==0) break;
			mass += comp[i]*m_Mass[i];
		}
		mass -= m_ChargeState*ELECTRONMASS;
		if(mass > m_MeasuredMass-m_Tolerance && mass < m_MeasuredMass+m_Tolerance) {
			AddCompToTable(mass);
		}
	}
}

void CElemCompDlg::AddCompToTable(double mass)
{
	int i;
	CString str("",256);
	// if we get here, it's because mass is inside the tolerance
	// window of mass calculated from comp.
	MassList[NumHits] = mass;
	for(i=0; i<10; i++) {
		if(comp[i] != 0) {
			str.Format("%s %s%d",str,m_Elem[i],comp[i]);
		}
	}
	MassComp[NumHits] = str;
	NumHits++;
}

void CElemCompDlg::ClearResults()
{
	int i;
	for(i=0; i<8192; i++) {
		MassList[i]=0.0;
		MassComp[i]="";
	}
	NumHits = 0;
}
