// ElemDlg.cpp : implementation file
//
/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "stdafx.h"
#include "Buda.h"
#include "ElemDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CElemDlg dialog


CElemDlg::CElemDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CElemDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CElemDlg)
	m_ElementName = _T("");
	m_IsoNum = 0;
	//}}AFX_DATA_INIT
}


void CElemDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CElemDlg)
	DDX_Control(pDX, IDC_ISOMASSES, m_IsoMasses);
	DDX_Text(pDX, IDC_ELEMENTNAME, m_ElementName);
	DDX_Text(pDX, IDC_ISONUM, m_IsoNum);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CElemDlg, CDialog)
	//{{AFX_MSG_MAP(CElemDlg)
	ON_LBN_SELCHANGE(IDC_ISOMASSES, OnSelchangeIsomasses)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CElemDlg message handlers

void CElemDlg::OnSelchangeIsomasses() 
{
	// TODO: Add your control notification handler code here
	
}

BOOL CElemDlg::OnInitDialog()
{
	if(!CDialog::OnInitDialog()) return FALSE;

	//first search PeriodTable for ElementName
	//then get index for Element
	int i, ec;
	for (i=0;i<120; i++)
	{
		if (m_PeriodTable[i].ElementName==m_ElementName) break;					
	}

	//create the IsoMass list box
	UpdateData(FALSE);
	SetListBoxFont();

	m_IsoMasses.ResetContent();
	m_IsoMasses.InitStorage(10,32);

	//fill the IsoMass ListBox
	//
	CString str, str1, str2, str3;
	for (ec=0; ec<m_PeriodTable[i].NumIsos; ec++)
	{
		str1.Format("%s",m_PeriodTable[i].Isos[ec].Isoname);
		str2.Format("%lf",m_PeriodTable[i].Isos[ec].Isomass);
		str3.Format("%lf",m_PeriodTable[i].Isos[ec].IsoAbund);
		while(str1.GetLength()<13) str1 = " " +str1;
		while(str2.GetLength()<11) str2 = " " +	str2;
		while(str3.GetLength()<9) str3 = " " +str3;
		str = str1 + str2 + str3;

		m_IsoMasses.AddString(str);
	}

	m_IsoNum = m_PeriodTable[i].Isos[0].IsoNum;
	m_IsoMasses.SetCurSel(0);

	return TRUE;
}

void CElemDlg::SetListBoxFont()
{
   CFont* pFont = GetFont();
   LOGFONT lf;
   if (pFont != NULL)
	   pFont->GetObject(sizeof(LOGFONT), &lf);
   else
	   ::GetObject(GetStockObject(SYSTEM_FONT), sizeof(LOGFONT), &lf);

	lf.lfPitchAndFamily = FIXED_PITCH | FF_MODERN;
	lf.lfWidth = 7;
	lf.lfHeight = 16;
	lf.lfWeight = 10;
	//char fnt[32]="Courier\0";
	//lf.lfFaceName = "Courier                       \0";
		// switch to new font.
	m_font.DeleteObject();
	if (m_font.CreateFontIndirect(&lf))
	{
		//CWaitCursor wait;
		m_IsoMasses.SetFont(&m_font);
	}
}

