// ElementalCompDlg.cpp : implementation file
//

#include "stdafx.h"
#include "buda.h"
#include "ElementalCompDlg.h"
#include <math.h>
#include "resource.h"
#include "ResultsDlg.h"

#define ELECTRONMASS 0.00054857

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CElementalCompDlg dialog


CElementalCompDlg::CElementalCompDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CElementalCompDlg::IDD, pParent)
{
	int i;
	for(i=0; i<10; i++) {
		m_Elem[i] = _T("");
		m_Mass[i] = 0.0;
		m_Max[i] = 0;
		m_Min[i] = 0;
	}
	//{{AFX_DATA_INIT(CElementalCompDlg)
	m_ChargeState = 0;
	m_MeasuredMass = 0.0;
	m_Tolerance = 0.0;
	m_MaxRplusDB = 10;
	m_RplusDB = TRUE;
	m_NitrogenRule = FALSE;
	//}}AFX_DATA_INIT
}


void CElementalCompDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Text(pDX, IDC_ELEM1, m_Elem[0]);
	DDX_Text(pDX, IDC_ELEM2, m_Elem[1]);
	DDX_Text(pDX, IDC_ELEM3, m_Elem[2]);
	DDX_Text(pDX, IDC_ELEM4, m_Elem[3]);
	DDX_Text(pDX, IDC_ELEM5, m_Elem[4]);
	DDX_Text(pDX, IDC_ELEM6, m_Elem[5]);
	DDX_Text(pDX, IDC_ELEM7, m_Elem[6]);
	DDX_Text(pDX, IDC_ELEM8, m_Elem[7]);
	DDX_Text(pDX, IDC_ELEM9, m_Elem[8]);
	DDX_Text(pDX, IDC_ELEM10, m_Elem[9]);

	DDX_Text(pDX, IDC_MASS1, m_Mass[0]);
	DDX_Text(pDX, IDC_MASS2, m_Mass[1]);
	DDX_Text(pDX, IDC_MASS3, m_Mass[2]);
	DDX_Text(pDX, IDC_MASS4, m_Mass[3]);
	DDX_Text(pDX, IDC_MASS5, m_Mass[4]);
	DDX_Text(pDX, IDC_MASS6, m_Mass[5]);
	DDX_Text(pDX, IDC_MASS7, m_Mass[6]);
	DDX_Text(pDX, IDC_MASS8, m_Mass[7]);
	DDX_Text(pDX, IDC_MASS9, m_Mass[8]);
	DDX_Text(pDX, IDC_MASS10, m_Mass[9]);

	DDX_Text(pDX, IDC_MAX1, m_Max[0]);
	DDX_Text(pDX, IDC_MAX2, m_Max[1]);
	DDX_Text(pDX, IDC_MAX3, m_Max[2]);
	DDX_Text(pDX, IDC_MAX4, m_Max[3]);
	DDX_Text(pDX, IDC_MAX5, m_Max[4]);
	DDX_Text(pDX, IDC_MAX6, m_Max[5]);
	DDX_Text(pDX, IDC_MAX7, m_Max[6]);
	DDX_Text(pDX, IDC_MAX8, m_Max[7]);
	DDX_Text(pDX, IDC_MAX9, m_Max[8]);
	DDX_Text(pDX, IDC_MAX10, m_Max[9]);

	DDX_Text(pDX, IDC_MIN1, m_Min[0]);
	DDX_Text(pDX, IDC_MIN2, m_Min[1]);
	DDX_Text(pDX, IDC_MIN3, m_Min[2]);
	DDX_Text(pDX, IDC_MIN4, m_Min[3]);
	DDX_Text(pDX, IDC_MIN5, m_Min[4]);
	DDX_Text(pDX, IDC_MIN6, m_Min[5]);
	DDX_Text(pDX, IDC_MIN7, m_Min[6]);
	DDX_Text(pDX, IDC_MIN8, m_Min[7]);
	DDX_Text(pDX, IDC_MIN9, m_Min[8]);
	DDX_Text(pDX, IDC_MIN10, m_Min[9]);

	//{{AFX_DATA_MAP(CElementalCompDlg)
	DDX_Text(pDX, IDC_CHARGESTATE, m_ChargeState);
	DDX_Text(pDX, IDC_MASS, m_MeasuredMass);
	DDX_Text(pDX, IDC_TOLERANCE, m_Tolerance);
	DDX_Text(pDX, IDC_MAX_RplusDB, m_MaxRplusDB);
	DDX_Check(pDX, IDC_RplusDB, m_RplusDB);
	DDX_Check(pDX, IDC_NITROGENRULE, m_NitrogenRule);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CElementalCompDlg, CDialog)
	//{{AFX_MSG_MAP(CElementalCompDlg)
	ON_BN_CLICKED(IDC_CALCULATE, OnCalculate)
	ON_BN_CLICKED(IDC_MplusH_ION, OnMplusH)
	ON_BN_CLICKED(IDC_RADICAL_CATION, OnRadicalCation)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CElementalCompDlg message handlers
BOOL CElementalCompDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here
	InitializeMemberVariables();
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CElementalCompDlg::InitializeMemberVariables()
{
	m_ChargeState = 1;
	m_MeasuredMass = 100.0;
	m_Tolerance = 0.01;
	m_RplusDB = TRUE;
	m_NitrogenRule = FALSE;
	m_MaxRplusDB = 10;
	m_IonType = 1;

	int i;
	for(i=0; i<10; i++) {
		m_Elem[i] = "---";
		m_Mass[i] = 0.0;
		m_Min[i] = 0;
		m_Max[i] = 0;
	}

	// add cho
	m_Elem[0] = "C";
	m_Mass[0] = 12.000;
	m_Min[0]  = 0;
	m_Max[0]  = 20;

	m_Elem[1] = "H";
	m_Mass[1] = 1.007825035;
	m_Min[1]  = 0;
	m_Max[1]  = 40;

	m_Elem[2] = "O";
	m_Mass[2] = 15.99491463;
	m_Min[2]  = 0;
	m_Max[2]  = 10;

	m_Elem[3] = "N";
	m_Mass[3] = 14.00307400;
	m_Min[3]  = 0;
	m_Max[3]  = 5;

	m_Elem[4] = "S";
	m_Mass[4] = 31.97207070;
	m_Min[4]  = 0;
	m_Max[4]  = 2;

	m_Elem[5] = "Li";
	m_Mass[5] = 7.0160030;
	m_Min[5]  = 0;
	m_Max[5]  = 0;

	m_Elem[6] = "Na";
	m_Mass[6] = 22.9897677;
	m_Min[6]  = 0;
	m_Max[6]  = 2;

	m_Elem[7] = "P";
	m_Mass[7] = 30.9737620;
	m_Min[7]  = 0;
	m_Max[7]  = 0;

	ClearResults();
}

void CElementalCompDlg::OnCalculate() 
{
	int i,j;
	double tempmass;
	CString tempcomp;
	ClearResults();
	for(i=10; i>=0; i--) {
		if(m_Max[i] !=0 ) break;
	}
	MaxIndex = i;

	// this function does the 10 tiered loop and creates 
	// the list of masses and compositions.
	UpdateData(TRUE);
	
	// setup comp.
	for(i=0; i<10; i++) {
		comp[i]=m_Min[i];
	}

	Composition(0);

	// sort hits
	for(i=0;i<NumHits; i++) {
		if(fabs(MassList[i] - m_MeasuredMass) < fabs(MassList[i-1] - m_MeasuredMass)) {
			for(j=i; j>0; j--) {
				while(fabs(MassList[j] - m_MeasuredMass) < fabs(MassList[j-1] - m_MeasuredMass)) {
					tempmass = MassList[j];
					MassList[j]=MassList[j-1];
					MassList[j-1]=tempmass;

					tempcomp = MassComp[j];
					MassComp[j] = MassComp[j-1];
					MassComp[j-1]=tempcomp;
				} // while
			} // for j
		}  // if
	} // for i

	// popup window to display results.
	CResultsDlg dlg;
	CString str;
	dlg.m_ResultsString = "";

	str.Format("Results of Elemental Composition Calculation...\r\n");
	dlg.m_ResultsString += str;
	str.Format("Mass: %1.5f  +/- %1.2f\r\n",m_MeasuredMass, m_Tolerance);
	dlg.m_ResultsString += str;
	str.Format("Charge: %d \r\n",m_ChargeState);
	dlg.m_ResultsString += str;
	if(m_RplusDB) {
		str.Format("Results filtered using RplusDB [-0.5, %d]\r\n",m_MaxRplusDB);
		dlg.m_ResultsString += str;
	}
	if(m_NitrogenRule) {
		if(m_IonType == 0) str.Format("Results filtered using Nitrogen Rule for M+.\r\n");
		else str.Format("Results filtered using Nitrogen Rule for M+H+\r\n \r\n");
		dlg.m_ResultsString += str;
	}

	str.Format(" \r\n");
	dlg.m_ResultsString += str;

	for(i=0; i<10; i++) {
		if(m_Max[i] == 0) continue;
		str.Format("%s = [%d,%d]\r\n",m_Elem[i],m_Min[i],m_Max[i]);
		dlg.m_ResultsString += str;
	}

	str.Format(" \r\nError         Mass         R+DB  Composition\r\n",m_ChargeState);
	dlg.m_ResultsString += str;
	str.Format("--------------------------------------------------------\r\n");
	dlg.m_ResultsString += str;

	for(i=0;i<NumHits; i++) {
		str.Format("%1.5f   %1.5f   %1.1f    %s\r\n",m_MeasuredMass-MassList[i],MassList[i],MassRDB[i],MassComp[i]);
		dlg.m_ResultsString += str;
	}
	dlg.DoModal();

}

void CElementalCompDlg::Composition(int index)
{
	double mass = 0;
	int i;

	// this function is called recursively.
	// 
	// if index < 9, it calls Composition with 
	// index = index +1;
	//
	// if index = 9, do the 9th loop and return.
	// on return, if index != 9, increment comp[index] until max.
	//if(index < 10 && m_Max[index] != 0) {
	if(index <= MaxIndex) {
		while(comp[index] <= m_Max[index]) {
			Composition(index+1);
			comp[index]++;
			for(i=index+1; i<10; i++) comp[i]=0;
		}
	} else {
		mass = 0;
		for(i=0; i<10; i++) {
			if(m_Max[i]==0) continue;
			mass += comp[i]*m_Mass[i];
		}
		mass -= m_ChargeState*ELECTRONMASS;
		if(mass > m_MeasuredMass-m_Tolerance && mass < m_MeasuredMass+m_Tolerance) {
			AddCompToTable(mass);
		}
	}
}

void CElementalCompDlg::AddCompToTable(double mass)
{
	int i;
	double rdb=0;

	CString str("",256);
	// if we get here, it's because mass is inside the tolerance
	// window of mass calculated from comp.

	// first check if Rings plus double bonds is reasonable.
	if(m_RplusDB) {
		if(!RingsPlusDoubleBonds(mass, &rdb)) return;
	}

	// now check if Nitrogen rule is sensible.
	if(m_NitrogenRule) {
		if(!NitrogenRule(mass)) return;
	}

	// if still here, then composition should be listed
	MassList[NumHits] = mass;
	MassRDB[NumHits] = (float)rdb;
	for(i=0; i<10; i++) {
		if(comp[i] != 0) {
			str.Format("%s %s%d",str,m_Elem[i],comp[i]);
		}
	}
	MassComp[NumHits] = str;
	NumHits++;
}

void CElementalCompDlg::ClearResults()
{
	int i;
	for(i=0; i<8192; i++) {
		MassList[i]=0.0;
		MassRDB[i] = 0.0;
		MassComp[i]="";
	}
	NumHits = 0;
	MaxIndex = 0;
}

BOOL CElementalCompDlg::RingsPlusDoubleBonds(double mass, double *rdb)
{
	mass=mass;
	// calculate rings plus double bonds from composition
	// if r+db > maxr+db, return false. else return true.
	//
	// for calculation, see McLafferty, pg 27.
	//
	// note values of R+DB < -0.5 are impossible.  

	int type1, type2, type3, type4,i;
	type1=0;
	type2=0;
	type3=0;
	type4=0;

	// first, identify the elements of type I (H,F,Cl,etc...)
	for(i=0; i<10; i++) {
		if(comp[i] == 0) continue;
		if(IsType1Element(i)) type1+=comp[i];
	}
	// second, identify the elements of type II (O,S)
	// type II elements don't figure in the calculation

	// third, identify the elements of type III (N,P)
	for(i=0; i<10; i++) {
		if(comp[i] == 0) continue;
		if(IsType3Element(i)) type3+=comp[i];
	}
	// fourth, identify the elements of type IV (C,Si)
	for(i=0; i<10; i++) {
		if(comp[i] == 0) continue;
		if(IsType4Element(i)) type4+=comp[i];
	}

	// value = type4 - 0.5(type1) + 0.5(type3) + 1
	*rdb = (double)type4 - (double)type1/2.0 + (double)type3/2.0 + 1.0;

	if(*rdb < -0.50) return FALSE; 
	if(*rdb > m_MaxRplusDB) return FALSE;
	else return TRUE;
}

BOOL CElementalCompDlg::NitrogenRule(double mass)
{
	// if composition violates nitrogen rule, return false, else return true.
	int i,type3 = 0;
	int intmass=0;
	double nommass;
	int odd=0;
	mass = mass;

	// first, identify the elements of type III (N,P)
	for(i=0; i<10; i++) {
		if(comp[i] == 0) continue;
		if(IsType3Element(i)) type3+=comp[i];
	}
	
	//is nominal mass even or odd?
	nommass = 0;
	for(i=0; i<10; i++) {
		if(m_Max[i]==0) continue;
		nommass = floor(m_Mass[i]);
		if((m_Mass[i] - nommass) > 0.5) nommass += 1.0;
		intmass += (int)((double)comp[i]*nommass);
	}

	if((intmass % 2) != 0) odd = 1;

	if(m_IonType == 0) { // radical cations
		if(odd) {
			if ((type3 % 2) != 0) return TRUE;
		}
		if(!odd) {
			if ((type3 % 2) == 0) return TRUE;
		}
	}
	if(m_IonType == 1) { // M+H ions
		if(odd) {
			if ((type3 % 2) == 0) return TRUE;
		}
		if(!odd) {
			if ((type3 % 2) != 0) return TRUE;
		}
	}
	
	// failed.
	return FALSE;
}

BOOL CElementalCompDlg::IsType1Element(int index)
{
	// (H,F,Cl,Br,I,Na)
	CString str;
	str = m_Elem[index];
	str.TrimLeft();
	str.TrimRight();
	str.MakeUpper();
	if(str == "H" || str == "HYDROGEN") return TRUE;
	if(str == "CL" || str == "CHLORINE") return TRUE;
	if(str == "F" || str == "FLUORINE") return TRUE;
	if(str == "BR" || str == "BROMINE") return TRUE;
	if(str == "I" || str == "IODINE") return TRUE;
	if(str == "NA" || str == "SODIUM") return TRUE;
	if(str == "LI" || str == "LITHIUM") return TRUE;
	if(str == "K" || str == "POTASSIUM") return TRUE;
	if(str == "CS" || str == "CESIUM") return TRUE;
	return FALSE;
}

BOOL CElementalCompDlg::IsType2Element(int index)
{
	// (O,S)
	CString str;
	str = m_Elem[index];
	str.TrimLeft();
	str.TrimRight();
	str.MakeUpper();
	if(str == "O" || str == "OXYGEN") return TRUE;
	if(str == "S" || str == "SULPHUR") return TRUE;
	return FALSE;
}

BOOL CElementalCompDlg::IsType3Element(int index)
{
	// (N,P)
	CString str;
	str = m_Elem[index];
	str.TrimLeft();
	str.TrimRight();
	str.MakeUpper();
	if(str == "N" || str == "NITROGEN") return TRUE;
	if(str == "P" || str == "PHOSPHORUS") return TRUE;
	return FALSE;

}

BOOL CElementalCompDlg::IsType4Element(int index)
{
	// (C,Si,Ge,Sn,Pb)
	CString str;
	str = m_Elem[index];
	str.TrimLeft();
	str.TrimRight();
	str.MakeUpper();
	if(str == "C" || str == "CARBON") return TRUE;
	if(str == "SI" || str == "SILICON") return TRUE;
	if(str == "GE" || str == "GERMANIUM") return TRUE;
	if(str == "SN" || str == "TIN") return TRUE;
	if(str == "PB" || str == "LEAD") return TRUE;
	return FALSE;
}

void CElementalCompDlg::OnMplusH()
{
	m_IonType = 1;
}

void CElementalCompDlg::OnRadicalCation()
{
	m_IonType = 0;
}

BOOL CElementalCompDlg::CheckValency()
{
	// this function checks the Valency of the composition
	// and returns TRUE if it is possible, and FALSE if not.
	// not sure how to do this yet.  
	return TRUE;
}
