// EventStruct.h: interface for the EventStruct class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EVENTSTRUCT_H__A71AD755_5ECA_4033_9E9D_8B9C9365B52C__INCLUDED_)
#define AFX_EVENTSTRUCT_H__A71AD755_5ECA_4033_9E9D_8B9C9365B52C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DAC_Master.h"

struct EventStruct  
{
	struct DAC_Parameters_Struct* DACparms;
	double time; // in milliseconds from the start of this PS
	int EventType; // Event_Init, Event_Change, Event_Pulse, Event_Ramp
	double DAC_Values[MAX_NUM_DACS];
	int DAC_Change[MAX_NUM_DACS];
	/* DAC_Values are the voltage values for that DAC at the time of
	this event as follows:
	Event_Init,		DAC_Value = Initialization voltage
	Event_Change,	DAC_Value = voltage after change
	Event_Pulse,	DAC_Value = voltage during pulse 
			(gets entered into final event table as 2 events)
	Event_Ramp,		DAC_Value = current value
			(gets entered into final event table as NUM_RAMP_STEPS steps)
	*/

};

#endif // !defined(AFX_EVENTSTRUCT_H__A71AD755_5ECA_4033_9E9D_8B9C9365B52C__INCLUDED_)
