#if !defined(AFX_FDM_H__60CAC0A0_B7AA_11D3_AFFA_0090278ECA2A__INCLUDED_)
#define AFX_FDM_H__60CAC0A0_B7AA_11D3_AFFA_0090278ECA2A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Fdm.h : header file
//
#include "stdafx.h"
#include <math.h>
#include <complex>
using namespace std;

#define	Nbmax  500
#define Nsigmax 500001
#define Npowermax 10000
#define dcplx complex<double>

/////////////////////////////////////////////////////////////////////////////
// CFdm dialog

class CFdm : public CDialog
{
// Construction
public:
	void FD();
	long Nb;
	long Nb2;
	long M;
	long Nsig;
	long Npower;
    dcplx U[Nbmax][Nbmax][3];
	dcplx uk[Nbmax];
    dcplx wk[Nbmax];
	dcplx dk[Nbmax];
	dcplx Spec[Npowermax];
    dcplx AL[Nbmax][Nbmax];
	dcplx AR[Nbmax][Nbmax];
	dcplx uu;
	dcplx phase_corr;
    dcplx f[2*Nbmax][3][3];
	dcplx xi;
	dcplx z[2*Nbmax];
	dcplx coef[Nsigmax];
	double err[Nbmax];
	double PI;
	double wmin;
	double wmax;
	double delt;
	//       This arrays are needed for qz only    
    double Zr[Nbmax][Nbmax][3];
	double wr[Nbmax][3];

	CBudaDoc* pDoc;
	void InitializeParameters();
	struct PS* pPS;
	void FDM();
	CFdm(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CFdm)
	enum { IDD = IDD_FDM };
	double	m_CheatFactor;
	BOOL	m_Cheatmore;
	double	m_ErrorLimit;
	double	Gamm;
	double	Gcut;
	double	m_HighFreq;
	double	m_LowFreq;
	int		m_NPower;
	double	rho;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFdm)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CFdm)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FDM_H__60CAC0A0_B7AA_11D3_AFFA_0090278ECA2A__INCLUDED_)
