/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_LINKINGDLG_H__A50CBD21_FD0E_11D1_B00C_444553540000__INCLUDED_)
#define AFX_LINKINGDLG_H__A50CBD21_FD0E_11D1_B00C_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// LinkingDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CLinkingDlg dialog

class CLinkingDlg : public CDialog
{
// Construction
public:
	int IndexChannel;
	int IndexEvent;
	int CurrentEvent;
	int LinkChannel;
	CBudaDoc* pDoc;
	int NumChannels;
	int InEvent;
	struct sys* pSys;
	int NumEvents;
	struct PS* pPS;
	void InitEventList();
	void InitChannelList();
	int EventList[TOTAL_PS_EVENTS];
	int SelectedChannel;
	int SelectedEvent;
	int ChannelList[40];
	int Linking;
	BOOL OnInitDialog();
	CLinkingDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CLinkingDlg)
	enum { IDD = IDD_LINKING };
	CListBox	m_EventList;
	CListBox	m_ChannelList;
	CButton		m_NoLinkBtn;
	CButton		m_LinkStartBtn;
	CButton		m_LinkEndBtn;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLinkingDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CLinkingDlg)
	afx_msg void OnNoLink();
	afx_msg void OnLinkStart();
	afx_msg void OnLinkEnd();
	afx_msg void OnSelchangeChannellist();
	afx_msg void OnSelchangeEventlist();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LINKINGDLG_H__A50CBD21_FD0E_11D1_B00C_444553540000__INCLUDED_)
