/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__23A26EEE_6AF3_11D1_9106_44455354616F__INCLUDED_)
#define AFX_MAINFRM_H__23A26EEE_6AF3_11D1_9106_44455354616F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Buda.h"

// declare classes that will be needed so that I
// can use interlinked includes
class CBudaApp;
class CInstrument;
class CBudaDoc;
//class CMainFrame;

class CMainFrame : public CMDIFrameWnd
{
	DECLARE_DYNAMIC(CMainFrame)
public:
	CMainFrame();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	//void OnExperimentDone();
	int setting;
	//CStatusProgress c_StatusProgress;
	//void OnUpdateStatus(int);
	//void OnFinishStatus();
	//void OnStartStatus();
	//void OnUpdateSysStatusPane(CCmdUI *pCmdUI);
	CFFTWorkerThread* pFFT;
	CBudaApp* pApp;
	void OnFFTProgress();
	struct	sys*	sys;
	CMenu* m_Menu;
	CStatusBar* GetStatusBar();
	//CBudaApp* pApp;
	virtual ~CMainFrame();
	//update UserID pane
	afx_msg void OnUpdateUserIDPane(CCmdUI *pCmdUI);
	afx_msg void OnUpdateFFTStatusPane(CCmdUI *pCmdUI);
	afx_msg void OnUpdateFFTQueuePane(CCmdUI *pCmdUI);
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//afx_msg void OnTestProgressBar();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__23A26EEE_6AF3_11D1_9106_44455354616F__INCLUDED_)
