// OscilloscopeDlg.cpp : implementation file
//
/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "stdafx.h"
#include "Buda.h"
#include "OscilloscopeDlg.h"
#include "OScopeCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COscilloscopeDlg dialog


COscilloscopeDlg::COscilloscopeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COscilloscopeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COscilloscopeDlg)
	m_TimeScale = _T("");
	m_Volts = _T("");
	//}}AFX_DATA_INIT
}


void COscilloscopeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COscilloscopeDlg)
	DDX_Text(pDX, IDC_TIMESCALE, m_TimeScale);
	DDX_Text(pDX, IDC_VOLTS, m_Volts);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COscilloscopeDlg, CDialog)
	//{{AFX_MSG_MAP(COscilloscopeDlg)
	ON_BN_CLICKED(IDC_TRIGGER_DETECT, OnTriggerDetect)
	ON_BN_CLICKED(IDC_TRIGGER_EXP, OnTriggerExp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COscilloscopeDlg message handlers

void COscilloscopeDlg::OnTriggerDetect() 
{
	// TODO: Add your control notification handler code here
	
}

void COscilloscopeDlg::OnTriggerExp() 
{
	// TODO: Add your control notification handler code here
	
}

BOOL COscilloscopeDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	Running = TRUE;
	// check status and if nbmonitor is not available, set running = FALSE
/*	int status = GetNBStatus();
	if(status == NOT_AVAILABLE) {
		Running = FALSE;
		MessageBox("Cannot initialize scope. Narrow Band Monitor Unavailable","Scope Error");
		return FALSE;
	}
*/

	// create the scope
	CRect rect;
	GetDlgItem(IDC_OSCOPE_CRTL)->GetWindowRect(rect);
	ScreenToClient(rect);
	m_Scope.Create(WS_VISIBLE | WS_CHILD, rect, this);

	// setup parms
	m_Scope.SetRange(-10.0, 10.0, 1) ;
	m_Scope.SetYUnits("Volts") ;
	m_Scope.SetXUnits("Time") ;
	m_Scope.SetBackgroundColor(RGB(0, 0, 64)) ;
	m_Scope.SetGridColor(RGB(192, 192, 255)) ;
	m_Scope.SetPlotColor(RGB(255, 255, 255)) ;

	// initialize the narrow band monitor
	//InitNB();
	//StartNB();

	return TRUE;  
}

void COscilloscopeDlg::Update()
{
	//long data[1024],numpts=0,i;
	// this is called from pApp->OnIdle().  here we check if there
	// is more data to display, and if so, get it and append it to the scope.
/*	if(GetNBStatus() & NB_DATA_READY) {
		numpts=ReadNBMem(data);
		for(i=0; i<numpts; i++) {
			// convert data[i] into volts
			// what is the data rate? how do I know the time?
			// AppendData()
		}
	}
*/
}

void COscilloscopeDlg::Initialize()
{
	Running= FALSE;
}

void COscilloscopeDlg::OnCancel() 
{
	//StopNB();	
	CDialog::OnCancel();
}

BOOL COscilloscopeDlg::IsRunning()
{
	return Running;
}
