/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_OSCILLOSCOPEDLG_H__452B7AE0_B9F1_11D2_B907_004005A3C9E9__INCLUDED_)
#define AFX_OSCILLOSCOPEDLG_H__452B7AE0_B9F1_11D2_B907_004005A3C9E9__INCLUDED_

#include "resource.h"       
#include "OScopeCtrl.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// OscilloscopeDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// COscilloscopeDlg dialog

class COscilloscopeDlg : public CDialog
{
// Construction
public:
	BOOL IsRunning();
	BOOL Running;
	void Initialize();
	void Update();
	COScopeCtrl m_Scope;
	COscilloscopeDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(COscilloscopeDlg)
	enum { IDD = IDD_OSCILLOSCOPE};
	CString	m_TimeScale;
	CString	m_Volts;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COscilloscopeDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(COscilloscopeDlg)
	afx_msg void OnTriggerDetect();
	afx_msg void OnTriggerExp();
	virtual BOOL OnInitDialog();
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OSCILLOSCOPEDLG_H__452B7AE0_B9F1_11D2_B907_004005A3C9E9__INCLUDED_)
