///////////////////////////////////////////////////////////////////
// PEGRAPHS API FUNCTIONS AND DEFINES      //
//                                         //
// Copyright (c) 1996-1997 Gigasoft, Inc.  //
/////////////////////////////////////////////

#ifndef __PEGRPAPI_H__
#define __PEGRPAPI_H__

// FUNCTION / PROPERTY HELPER CODES //
#define PECONTROL_GRAPH             300
#define PECONTROL_PIE               302
#define PECONTROL_SGRAPH            304
#define PECONTROL_PGRAPH            308

#define PESTA_CENTER                0
#define PESTA_LEFT                  1
#define PESTA_RIGHT                 2

#define PEDO_DRIVERDEFAULT          0
#define PEDO_LANDSCAPE              1   
#define PEDO_PORTRAIT               2

#define PEVS_COLOR                  0
#define PEVS_MONO                   1
#define PEVS_MONOWITHSYMBOLS        2

#define PEFS_LARGE                  0
#define PEFS_MEDIUM                 1
#define PEFS_SMALL                  2

#define PEVB_NONE                   0
#define PEVB_TOP                    1
#define PEVB_BOTTOM                 2
#define PEVB_TOPANDBOTTOM           3 

#define PEAC_AUTO                   0
#define PEAC_NORMAL                 1
#define PEAC_LOG                    2

#define PEGPM_LINE                  0
#define PEGPM_BAR                   1
#define PEGPM_STICK                 4
#define PEGPM_POINT                 2
#define PEGPM_AREA                  3
#define PEGPM_AREASTACKED           4
#define PEGPM_AREASTACKEDPERCENT    5
#define PEGPM_BARSTACKED            6
#define PEGPM_BARSTACKEDPERCENT     7
#define PEGPM_POINTSPLUSBFL         8
#define PEGPM_POINTSPLUSBFLGRAPHED  9
#define PEGPM_HISTOGRAM             10
#define PEGPM_SPECIFICPLOTMODE      11
#define PEGPM_BUBBLE                12
#define PEGPM_POINTSPLUSBFC         13
#define PEGPM_POINTSPLUSBFCGRAPHED  14
#define PEGPM_POINTSPLUSSPLINE      15
#define PEGPM_SPLINE                16
#define PEGPM_POINTSPLUSLINE        17
#define PEGPM_HORIZONTALBAR         18
#define PEGPM_HORZBARSTACKED        19
#define PEGPM_HORZBARSTACKEDPERCENT 20

#define PEGLC_BOTH                  0
#define PEGLC_YAXIS                 1
#define PEGLC_XAXIS                 2
#define PEGLC_NONE                  3

#define PEAS_SUMPP                  51
#define PEAS_MINAP                  1
#define PEAS_MINPP                  52
#define PEAS_MAXAP                  2
#define PEAS_MAXPP                  53
#define PEAS_AVGAP                  3
#define PEAS_AVGPP                  54
#define PEAS_P1SDAP                 4
#define PEAS_P1SDPP                 55
#define PEAS_P2SDAP                 5
#define PEAS_P2SDPP                 56
#define PEAS_P3SDAP                 6
#define PEAS_P3SDPP                 57
#define PEAS_M1SDAP                 7
#define PEAS_M1SDPP                 58
#define PEAS_M2SDAP                 8
#define PEAS_M2SDPP                 59
#define PEAS_M3SDAP                 9
#define PEAS_M3SDPP                 60
#define PEAS_PARETO_ASC             90
#define PEAS_PARETO_DEC             91

#define PEPTGI_FIRSTPOINTS          0
#define PEPTGI_LASTPOINTS           1   

#define PEPTGV_SEQUENTIAL           0
#define PEPTGV_RANDOM               1

#define PEGPT_GRAPH                 0
#define PEGPT_TABLE                 1
#define PEGPT_BOTH                  2

#define PETW_GRAPHED                0
#define PETW_ALLSUBSETS             1

#define PEDLT_PERCENTAGE            0
#define PEDLT_VALUE                 1

#define PEMSC_NONE                  0
#define PEMSC_MIN                   1
#define PEMSC_MAX                   2
#define PEMSC_MINMAX                3

#define IDEXPORTBUTTON              1015
#define IDMAXIMIZEBUTTON            1016
#define IDORIGINALBUTTON            1109    

#define PEHS_NONE                   0
#define PEHS_SUBSET                 1
#define PEHS_POINT                  2
#define PEHS_GRAPH                  3
#define PEHS_TABLE                  4
#define PEHS_DATAPOINT              5
#define PEHS_ANNOTATION             6
#define PEHS_XAXISANNOTATION        7
#define PEHS_YAXISANNOTATION        8
#define PEHS_HORZLINEANNOTATION     9
#define PEHS_VERTLINEANNOTATION     10

#define PESPM_NONE                  0
#define PESPM_HIGHLOWBAR            1
#define PESPM_HIGHLOWLINE           2
#define PESPM_HIGHLOWCLOSE          3
#define PESPM_OPENHIGHLOWCLOSE      4
#define PESPM_BOXPLOT               5

// HORIZONTAL LINE ANNOTATIONS CAN BE WITH RESPECT TO RIGHT Y AXIS COORDINATES
// BY ADDING 1000 TO THE FOLLOWING CONSTANTS 
#define PELT_THINSOLID              0
#define PELT_DASH                   1
#define PELT_DOT                    2
#define PELT_DASHDOT                3
#define PELT_DASHDOTDOT             4
#define PELT_MEDIUMSOLID            5
#define PELT_THICKSOLID             6
#define PELAT_GRIDTICK              7
#define PELAT_GRIDLINE              8
#define PELT_MEDIUMTHINSOLID		9
#define PELT_MEDIUMTHICKSOLID		10
#define PELT_EXTRATHICKSOLID		11

#define PEPS_SMALL                  0
#define PEPS_MEDIUM                 1
#define PEPS_LARGE                  2
#define PEPS_MICRO					3

#define PEPT_PLUS                   0
#define PEPT_CROSS                  1
#define PEPT_DOT                    2
#define PEPT_DOTSOLID               3
#define PEPT_SQUARE                 4
#define PEPT_SQUARESOLID            5
#define PEPT_DIAMOND                6
#define PEPT_DIAMONDSOLID           7
#define PEPT_UPTRIANGLE             8
#define PEPT_UPTRIANGLESOLID        9
#define PEPT_DOWNTRIANGLE           10
#define PEPT_DOWNTRIANGLESOLID      11

#define PEADL_NONE                  0
#define PEADL_DATAVALUES            1
#define PEADL_POINTLABELS           2
#define PEADL_DATAPOINTLABELS       3

#define PEAZ_NONE                   0
#define PEAZ_HORIZONTAL             1
#define PEAZ_VERTICAL               2
#define PEAZ_HORZANDVERT            3

#define PEBFD_2ND                   0
#define PEBFD_3RD                   1
#define PEBFD_4TH                   2

#define PEBS_SMALL                  0
#define PEBS_MEDIUM                 1
#define PEBS_LARGE                  2

#define PECG_COARSE                 0
#define PECG_MEDIUM                 1
#define PECG_FINE                   2

#define PEAE_NONE                   0
#define PEAE_ALLSUBSETS             1
#define PEAE_INDSUBSETS             2

#define PECM_NOCURSOR               0
#define PECM_POINT                  1
#define PECM_DATACROSS              2
#define PECM_DATASQUARE             3
#define PECM_POINTPLUSHORZ			4
#define PECM_CROSSHAIR              5

// GRAPH ANNOTATIONS CAN BE WITH RESPECT TO RIGHT Y AXIS COORDINATES
// BY ADDING 1000 TO THE FOLLOWING CONSTANTS
#define PEGAT_NOSYMBOL               0
#define PEGAT_PLUS                   1
#define PEGAT_CROSS                  2
#define PEGAT_DOT                    3
#define PEGAT_DOTSOLID               4
#define PEGAT_SQUARE                 5
#define PEGAT_SQUARESOLID            6
#define PEGAT_DIAMOND                7
#define PEGAT_DIAMONDSOLID           8
#define PEGAT_UPTRIANGLE             9
#define PEGAT_UPTRIANGLESOLID        10
#define PEGAT_DOWNTRIANGLE           11
#define PEGAT_DOWNTRIANGLESOLID      12
#define PEGAT_SMALLPLUS              13
#define PEGAT_SMALLCROSS             14
#define PEGAT_SMALLDOT               15
#define PEGAT_SMALLDOTSOLID          16
#define PEGAT_SMALLSQUARE            17
#define PEGAT_SMALLSQUARESOLID       18
#define PEGAT_SMALLDIAMOND           19
#define PEGAT_SMALLDIAMONDSOLID      20
#define PEGAT_SMALLUPTRIANGLE        21
#define PEGAT_SMALLUPTRIANGLESOLID   22
#define PEGAT_SMALLDOWNTRIANGLE      23
#define PEGAT_SMALLDOWNTRIANGLESOLID 24
#define PEGAT_LARGEPLUS              25
#define PEGAT_LARGECROSS             26
#define PEGAT_LARGEDOT               27
#define PEGAT_LARGEDOTSOLID          28
#define PEGAT_LARGESQUARE            29
#define PEGAT_LARGESQUARESOLID       30
#define PEGAT_LARGEDIAMOND           31
#define PEGAT_LARGEDIAMONDSOLID      32
#define PEGAT_LARGEUPTRIANGLE        33
#define PEGAT_LARGEUPTRIANGLESOLID   34
#define PEGAT_LARGEDOWNTRIANGLE      35
#define PEGAT_LARGEDOWNTRIANGLESOLID 36

#define PEGAT_POINTER               37 

#define PEGAT_THINSOLIDLINE         38
#define PEGAT_DASHLINE              39
#define PEGAT_DOTLINE               40
#define PEGAT_DASHDOTLINE           41
#define PEGAT_DASHDOTDOTLINE        42
#define PEGAT_MEDIUMSOLIDLINE       43
#define PEGAT_THICKSOLIDLINE        44
#define PEGAT_LINECONTINUE          45

#define PEGAT_TOPLEFT               46
#define PEGAT_BOTTOMRIGHT           47

#define PEGAT_RECT_THIN             48
#define PEGAT_RECT_DASH             49
#define PEGAT_RECT_DOT              50
#define PEGAT_RECT_DASHDOT          51
#define PEGAT_RECT_DASHDOTDOT       52
#define PEGAT_RECT_MEDIUM           53
#define PEGAT_RECT_THICK            54
#define PEGAT_RECT_FILL             55

#define PEGAT_ROUNDRECT_THIN        56
#define PEGAT_ROUNDRECT_DASH        57
#define PEGAT_ROUNDRECT_DOT         58
#define PEGAT_ROUNDRECT_DASHDOT     59
#define PEGAT_ROUNDRECT_DASHDOTDOT  60
#define PEGAT_ROUNDRECT_MEDIUM      61
#define PEGAT_ROUNDRECT_THICK       62
#define PEGAT_ROUNDRECT_FILL        63

#define PEGAT_ELLIPSE_THIN          64
#define PEGAT_ELLIPSE_DASH          65
#define PEGAT_ELLIPSE_DOT           66
#define PEGAT_ELLIPSE_DASHDOT       67
#define PEGAT_ELLIPSE_DASHDOTDOT    68
#define PEGAT_ELLIPSE_MEDIUM        69  
#define PEGAT_ELLIPSE_THICK         70
#define PEGAT_ELLIPSE_FILL          71

#define PEDTM_NONE                  0
#define PEDTM_VB                    1
#define PEDTM_DELPHI                2

#define PESA_ALL                    0
#define PESA_AXISLABELS             1
#define PESA_GRIDNUMBERS            2
#define PESA_NONE                   3
#define PESA_LABELONLY              4
#define PESA_EMPTY                  5

#define PEGS_THIN                   0
#define PEGS_THICK                  1
#define PEGS_DOT                    2
#define PEGS_DASH                   3

#define PEFVP_AUTO                  0
#define PEFVP_VERT                  1
#define PEFVP_HORZ                  2

#define PEMAS_NONE                  0
#define PEMAS_THIN                  1
#define PEMAS_MEDIUM                2
#define PEMAS_THICK                 3
#define PEMAS_THICKPLUSTICK         4

typedef struct tagGLOBALPROPERTIES
{
    // GLOBAL SCOPE //
    UINT    nObjectType;            // read only
    char    szMainTitle[48];
    char    szSubTitle[48];
    UINT    nSubsets;
    UINT    nPoints;
    
    BOOL    bMonoWithSymbols;
    UINT    nDefOrientation;
    BOOL    bPrepareImages;
    BOOL    b3dDialogs;
    BOOL    bDataShadows;
    
    BOOL    bAllowCustomization;
    BOOL    bAllowExporting;
    BOOL    bAllowMaximization;
    BOOL    bAllowPopup;
    BOOL    bAllowUserInterface;
    
    UINT    nPageWidth;
    UINT    nPageHeight;
    RECT    rectLogicalLoc;
    
    BOOL    bCustom;
    BOOL    nViewingStyle;
    BOOL    nCViewingStyle;
    
    DWORD   dwMonoDeskColor;
    DWORD   dwMonoTextColor;
    DWORD   dwMonoShadowColor;   
    DWORD   dwMonoGraphForeColor;
    DWORD   dwMonoGraphBackColor;
    DWORD   dwMonoTableForeColor;
    DWORD   dwMonoTableBackColor;
    
    DWORD   dwCMonoDeskColor;
    DWORD   dwCMonoTextColor;
    DWORD   dwCMonoShadowColor;
    DWORD   dwCMonoGraphForeColor;
    DWORD   dwCMonoGraphBackColor;
    DWORD   dwCMonoTableForeColor;
    DWORD   dwCMonoTableBackColor;
    
    DWORD   dwDeskColor;
    DWORD   dwTextColor;
    DWORD   dwShadowColor;        
    DWORD   dwGraphForeColor;
    DWORD   dwGraphBackColor;
    DWORD   dwTableForeColor;
    DWORD   dwTableBackColor;
    
    DWORD   dwCDeskColor;
    DWORD   dwCTextColor;
    DWORD   dwCShadowColor;
    DWORD   dwCGraphForeColor;
    DWORD   dwCGraphBackColor;
    DWORD   dwCTableForeColor;
    DWORD   dwCTableBackColor;
    
    UINT    nDataPrecision;
    UINT    nCDataPrecision;
    
    UINT    nFontSize;
    UINT    nCFontSize;
    
    char    szMainTitleFont[48];
    BOOL    bMainTitleBold;
    BOOL    bMainTitleItalic;
    BOOL    bMainTitleUnderline;
    char    szCMainTitleFont[48];
    BOOL    bCMainTitleBold;
    BOOL    bCMainTitleItalic;
    BOOL    bCMainTitleUnderline;
    char    szSubTitleFont[48];
    BOOL    bSubTitleBold;
    BOOL    bSubTitleItalic;
    BOOL    bSubTitleUnderline;    
    char    szCSubTitleFont[48];
    BOOL    bCSubTitleBold;
    BOOL    bCSubTitleItalic;
    BOOL    bCSubTitleUnderline;    
    char    szLabelFont[48];
    BOOL    bLabelBold;
    BOOL    bLabelItalic;
    BOOL    bLabelUnderline;    
    char    szCLabelFont[48];
    BOOL    bCLabelBold;
    BOOL    bCLabelItalic;
    BOOL    bCLabelUnderline;   
    char    szTableFont[48];    
    char    szCTableFont[48];
    
    // Version 2.0 //
    BOOL    bAllowSubsetHotSpots;
    BOOL    bAllowPointHotSpots;
    
} GLOBALPROPERTIES; 

typedef struct tagGRAPHPROPERTIES
{
    // GRAPH SCOPE //
    char    szXAxisLabel[48];
    char    szYAxisLabel[48];
    UINT    nVBoundTypes;
    double   fUpperBoundValue;
    double   fLowerBoundValue;
    char    szUpperBoundText[48];
    char    szLowerBoundText[48];
    UINT    nYAxisScaleControl;
    UINT    nManualScaleControlY;
    double   fManualMinY;
    double   fManualMaxY;
    BOOL    bNoScrollingSubsetControl;  
    UINT    nScrollingSubsets;
    UINT    nCScrollingSubsets;
    UINT    nPlottingMethod;
    UINT    nCPlottingMethod;
    UINT    nGridLineControl;
    UINT    nCGridLineControl;
    BOOL    bGridInFront;
    BOOL    bCGridInFront;
    BOOL    bTreatCompsAsNormal;
    BOOL    bCTreatCompsAsNormal;
    UINT    nComparisonSubsets;

    BOOL    bNoStackedData;
    UINT    nPointsToGraphInit;
    UINT    nPointsToGraphVersion;
    UINT    nCPointsToGraphVersion;
    UINT    nPointsToGraph;
    UINT    nCPointsToGraph;
    BOOL    bForceVerticalPoints;
    BOOL    bCForceVerticalPoints;
    UINT    nGraphPlusTable;
    UINT    nCGraphPlusTable;
    UINT    nTableWhat;
    UINT    nCTableWhat;
    
    // Version 2.0 //
    BOOL    bAllowDataHotSpots;
    BOOL    bAllowGraphHotSpots;
    BOOL    bAllowTableHotSpots;
    BOOL    bAllowCoordPrompting;
    BOOL    bMarkDataPoints;
    BOOL    bCMarkDataPoints;
    
    UINT    nRYAxisComparisonSubsets;
    UINT    nRYAxisScaleControl;
    UINT    nRYAxisInitialScaleForY;
    UINT    nRYAxisManualScaleControlY; 
    double   fRYAxisManualMinY;
    double   fRYAxisManualMaxY;
    char    szRYAxisLabel[48];
    
    BOOL    bAllowPlotCustomization;
    BOOL    bAllowHistogram;
    int     nSpecificPlotMode;
    BOOL    bNegativeFromXAxis;
    
    BOOL    bManualYAxisTicknLine;
    double   fManualYAxisTick;
    double   fManualYAxisLine;
    BOOL    bManualRYAxisTicknLine;
    double   fManualRYAxisTick;
    double   fManualRYAxisLine;
    
    int     nTargetPointsToTable;
    int     nAltFreqThreshold;
    
    double   fNullDataValue;
    
    int     nPointSize;
    BOOL    bAllowBestFitCurve;
    int     nBestFitDegree;
    BOOL    bAllowSpline;
    int     nCurveGranularity;
    
    double   fManualStackedMaxY;
    
    int     nMaxPointsToGraph;
    BOOL    bDisableRandomPointsToGraph;
    
    BOOL    bAllowLine;
    BOOL    bAllowBar;
    BOOL    bAllowPoint;
    BOOL    bAllowBestFitLine;
    BOOL    bAllowArea;
    
    int     nAllowZooming;
    
    BOOL    bForceRightYAxis;
    BOOL    bAllowPointsPlusLine;
    BOOL    bAllowPointsPlusSpline;
    BOOL    bAllowBestFitLineII;
    BOOL    bAllowBestFitCurveII;
    int     nSymbolFrequency;
    BOOL    bAppendToEnd;
} GRAPHPROPERTIES;  

typedef struct tagSGRAPHPROPERTIES
{
    // SCIENTIFIC GRAPH SCOPE //       
    char    szXAxisLabel[48];
    char    szYAxisLabel[48];
    UINT    nVBoundTypes;
    double   fUpperBoundValue;
    double   fLowerBoundValue;
    char    szUpperBoundText[48];
    char    szLowerBoundText[48];
    UINT    nYAxisScaleControl;
    UINT    nManualScaleControlY;
    double   fManualMinY;
    double   fManualMaxY;
    BOOL    bNoScrollingSubsetControl;  
    UINT    nScrollingSubsets;
    UINT    nCScrollingSubsets;
    UINT    nPlottingMethod;
    UINT    nCPlottingMethod;
    UINT    nGridLineControl;
    UINT    nCGridLineControl;
    BOOL    bGridInFront;
    BOOL    bCGridInFront;
    BOOL    bTreatCompsAsNormal;
    BOOL    bCTreatCompsAsNormal;
    UINT    nComparisonSubsets;

    UINT    nXAxisScaleControl;
    UINT    nManualScaleControlX;
    double   fManualMinX;
    double   fManualMaxX;
    BOOL    bGraphDataLabels;
    BOOL    bCGraphDataLabels;
    
    // Version 2.0 //
    BOOL    bAllowDataHotSpots;
    BOOL    bAllowGraphHotSpots;
    BOOL    bAllowCoordPrompting;
    BOOL    bMarkDataPoints;
    BOOL    bCMarkDataPoints;

    UINT    nRYAxisComparisonSubsets;
    UINT    nRYAxisScaleControl;
    UINT    nRYAxisInitialScaleForY;
    UINT    nRYAxisManualScaleControlY; 
    double   fRYAxisManualMinY;
    double   fRYAxisManualMaxY;
    char    szRYAxisLabel[48];

    BOOL    bAllowPlotCustomization;
    BOOL    bAllowBubble;
    int     nBubbleSize;
    BOOL    bNegativeFromXAxis;
    int     nAllowDataLabels;
    
    BOOL    bManualXAxisTicknLine;
    double   fManualXAxisTick;
    double   fManualXAxisLine;
    BOOL    bManualYAxisTicknLine;
    double   fManualYAxisTick;
    double   fManualYAxisLine;
    BOOL    bManualRYAxisTicknLine;
    double   fManualRYAxisTick;
    double   fManualRYAxisLine;
    
    double   fNullDataValue;
    
    int     nPointSize;
    BOOL    bAllowBestFitCurve;
    int     nBestFitDegree;
    BOOL    bAllowSpline;
    int     nCurveGranularity;
    
    BOOL    bAllowLine;
    BOOL    bAllowPoint;
    BOOL    bAllowBestFitLine;
    BOOL    bAllowStick;
    
    int     nAllowZooming;
    BOOL    bZoomMode;
    double   fZoomMinX;
    double   fZoomMaxX;
    double   fZoomMinY;
    double   fZoomMaxY;
    
    BOOL    bForceRightYAxis;
    BOOL    bAllowPointsPlusLine;
    BOOL    bAllowPointsPlusSpline;
    int     nSymbolFrequency;
} SGRAPHPROPERTIES;

typedef struct tagPIEPROPERTIES
{
    // PIE SCOPE //
    UINT    nGroupingPercent;
    UINT    nCGroupingPercent;
    UINT    nDataLabelType;
    UINT    nCDataLabelType;
    UINT    nAutoExplode;
} PIEPROPERTIES;                

typedef struct tagSCROLLPARMS
{
    int     nVmin;  // vertical scrollbar minimum
    int     nVmax;  // vertical scrollbar maximum
    int     nVpos;  // vertical scrollbar position
    int     nHmin;  // horizontal scrollbar minimum
    int     nHmax;  // horizontal scrollbar maximum
    int     nHpos;  // horizontal scrollbar position
} SCROLLPARMS;

typedef struct tagHOTSPOTDATA
{
    RECT    rectHotSpot;
    UINT    nHotSpotType;
    UINT    w1;
    UINT    w2;
} HOTSPOTDATA; 

typedef struct tagGRAPHLOC
{
    int     nAxis;
    double  fXval;
    double  fYval;
} GRAPHLOC; 

typedef struct tagTM
{
    int     nMonth;
    int     nDay;  
    int     nYear; 
    int     nHour; 
    int     nMinute;
    int     nSecond;
    int     nWeekDay;
    int     nYearDay;
} TM;

////// GLOBAL PROPERTIES //////
#define PEP_nOBJECTTYPE             2100 

#define PEP_szMAINTITLE             2105
#define PEP_szSUBTITLE              2110
#define PEP_nSUBSETS                2115
#define PEP_nPOINTS                 2120
#define PEP_szaSUBSETLABELS         2125
#define PEP_szaPOINTLABELS          2130
#define PEP_faXDATA                 2135
#define PEP_faYDATA                 2140

#define PEP_bMONOWITHSYMBOLS        2145
#define PEP_nDEFORIENTATION         2150
#define PEP_bPREPAREIMAGES          2155

#define PEP_b3DDIALOGS              2160

#define PEP_bALLOWCUSTOMIZATION     2165
#define PEP_bALLOWEXPORTING         2170
#define PEP_bALLOWMAXIMIZATION      2175
#define PEP_bALLOWPOPUP             2180
#define PEP_bALLOWUSERINTERFACE     2185

#define PEP_dwaSUBSETCOLORS         2190
#define PEP_dwaSUBSETSHADES         2195

#define PEP_nPAGEWIDTH              2200
#define PEP_nPAGEHEIGHT             2205
#define PEP_rectLOGICALLOC          2210

#define PEP_bDIRTY                  2215
#define PEP_bDIALOGSHOWN            2220

#define PEP_bCUSTOM                 2225

#define PEP_nVIEWINGSTYLE           2230
#define PEP_nCVIEWINGSTYLE          2235

#define PEP_bDATASHADOWS            2240
#define PEP_bCDATASHADOWS           2245

#define PEP_dwMONODESKCOLOR         2250
#define PEP_dwMONOTEXTCOLOR         2255
#define PEP_dwMONOSHADOWCOLOR       2260
#define PEP_dwMONOGRAPHFORECOLOR    2265
#define PEP_dwMONOGRAPHBACKCOLOR    2270
#define PEP_dwMONOTABLEFORECOLOR    2275
#define PEP_dwMONOTABLEBACKCOLOR    2280

#define PEP_dwCMONODESKCOLOR        2285
#define PEP_dwCMONOTEXTCOLOR        2290
#define PEP_dwCMONOSHADOWCOLOR      2295
#define PEP_dwCMONOGRAPHFORECOLOR   2300
#define PEP_dwCMONOGRAPHBACKCOLOR   2305
#define PEP_dwCMONOTABLEFORECOLOR   2310
#define PEP_dwCMONOTABLEBACKCOLOR   2315

#define PEP_dwDESKCOLOR             2320
#define PEP_dwTEXTCOLOR             2325
#define PEP_dwSHADOWCOLOR           2330
#define PEP_dwGRAPHFORECOLOR        2335
#define PEP_dwGRAPHBACKCOLOR        2340
#define PEP_dwTABLEFORECOLOR        2345
#define PEP_dwTABLEBACKCOLOR        2350

#define PEP_dwCDESKCOLOR            2355
#define PEP_dwCTEXTCOLOR            2360
#define PEP_dwCSHADOWCOLOR          2365
#define PEP_dwCGRAPHFORECOLOR       2370
#define PEP_dwCGRAPHBACKCOLOR       2375
#define PEP_dwCTABLEFORECOLOR       2380
#define PEP_dwCTABLEBACKCOLOR       2385

#define PEP_dwWDESKCOLOR            2390 
#define PEP_dwWTEXTCOLOR            2395
#define PEP_dwWSHADOWCOLOR          2400
#define PEP_dwWGRAPHFORECOLOR       2405
#define PEP_dwWGRAPHBACKCOLOR       2410
#define PEP_dwWTABLEFORECOLOR       2415
#define PEP_dwWTABLEBACKCOLOR       2420

#define PEP_nDATAPRECISION          2425
#define PEP_nCDATAPRECISION         2430

#define PEP_nFONTSIZE               2435
#define PEP_nCFONTSIZE              2440

#define PEP_szMAINTITLEFONT         2445
#define PEP_bMAINTITLEBOLD          2450
#define PEP_bMAINTITLEITALIC        2455
#define PEP_bMAINTITLEUNDERLINE     2460
#define PEP_szCMAINTITLEFONT        2465
#define PEP_bCMAINTITLEBOLD         2470
#define PEP_bCMAINTITLEITALIC       2475
#define PEP_bCMAINTITLEUNDERLINE    2480   

#define PEP_szSUBTITLEFONT          2485
#define PEP_bSUBTITLEBOLD           2490
#define PEP_bSUBTITLEITALIC         2495
#define PEP_bSUBTITLEUNDERLINE      2500
#define PEP_szCSUBTITLEFONT         2505
#define PEP_bCSUBTITLEBOLD          2510
#define PEP_bCSUBTITLEITALIC        2515
#define PEP_bCSUBTITLEUNDERLINE     2520

#define PEP_szLABELFONT             2525
#define PEP_bLABELBOLD              2530
#define PEP_bLABELITALIC            2535
#define PEP_bLABELUNDERLINE         2540
#define PEP_szCLABELFONT            2545
#define PEP_bCLABELBOLD             2550
#define PEP_bCLABELITALIC           2555
#define PEP_bCLABELUNDERLINE        2560

#define PEP_szTABLEFONT             2565
#define PEP_szCTABLEFONT            2570

#define PEP_bCACHEBMP				2574
#define PEP_hMEMBITMAP              2575
#define PEP_hMEMDC                  2580

#define PEP_bALLOWSUBSETHOTSPOTS    2600
#define PEP_bALLOWPOINTHOTSPOTS     2605
#define PEP_structHOTSPOTDATA       2610
#define PEP_bAUTOIMAGERESET         2615
#define PEP_bALLOWTITLESDIALOG      2616

#define PEP_nCURSORMODE             2617
#define PEP_nCURSORSUBSET           2618
#define PEP_nCURSORPOINT            2619
#define PEP_nCURSORPROMPTSTYLE      2620
#define PEP_bCURSORPROMPTTRACKING   2621
#define PEP_bMOUSECURSORCONTROL     2622
#define PEP_bALLOWANNOTATIONCONTROL 2623

#define PEP_naSUBSETSTOLEGEND       2624
#define PEP_naLEGENDANNOTATIONTYPE  2625
#define PEP_szaLEGENDANNOTATIONTEXT 2626
#define PEP_dwaLEGENDANNOTATIONCOLOR 2627
#define PEP_nVERTSCROLLPOS           2628
#define PEP_bALLOWDEBUGOUTPUT       2629

#define PEP_szaMULTISUBTITLES       2630
#define PEP_szaMULTIBOTTOMTITLES    2631
#define PEP_bFOCALRECT              2632
#define PEP_fFONTSIZEGLOBALCNTL     2634
#define PEP_fFONTSIZETITLECNTL      2635
#define PEP_bSUBSETBYPOINT          2636

#define PEP_ptLASTMOUSEMOVE         2637

#define PEP_bALLOWOLEEXPORT         2638

#define PEP_faZDATA                 2900
#define PEP_bINVALID                2905
#define PEP_bOBJECTINSERVER         2910
#define PEP_hwndPARENTALCONTROL     2915

#define PEP_bPAINTING               2916

#define PEP_hARROWCURSOR			2917
#define PEP_hZOOMCURSOR				2918
#define PEP_hHANDCURSOR				2919
#define PEP_hNODROPCURSOR			2920

#define PEP_szXAXISLABEL            3000
#define PEP_szYAXISLABEL            3005
#define PEP_nVBOUNDARYTYPES         3010
#define PEP_fUPPERBOUNDVALUE        3015
#define PEP_fLOWERBOUNDVALUE        3020
#define PEP_szUPPERBOUNDTEXT        3025
#define PEP_szLOWERBOUNDTEXT        3030

#define PEP_nINITIALSCALEFORYDATA   3035
#define PEP_nSCALEFORYDATA          3040
#define PEP_nYAXISSCALECONTROL      3045

#define PEP_nMANUALSCALECONTROLY    3050
#define PEP_fMANUALMINY             3055
#define PEP_fMANUALMAXY             3060

#define PEP_bNOSCROLLINGSUBSETCONTROL   3065

#define PEP_nSCROLLINGSUBSETS       3070
#define PEP_nCSCROLLINGSUBSETS      3075

#define PEP_naRANDOMSUBSETSTOGRAPH  3080
#define PEP_naCRANDOMSUBSETSTOGRAPH 3085

#define PEP_nPLOTTINGMETHOD         3090
#define PEP_nCPLOTTINGMETHOD        3095

#define PEP_nGRIDLINECONTROL        3100
#define PEP_nCGRIDLINECONTROL       3105

#define PEP_bGRIDINFRONT            3110
#define PEP_bCGRIDINFRONT           3115

#define PEP_bTREATCOMPSASNORMAL     3120
#define PEP_bCTREATCOMPSASNORMAL    3125

#define PEP_nCOMPARISONSUBSETS      3130

#define PEP_bALLOWCOORDPROMPTING    3200
#define PEP_bALLOWGRAPHHOTSPOTS     3205
#define PEP_bALLOWDATAHOTSPOTS      3210
#define PEP_bMARKDATAPOINTS         3215
#define PEP_bCMARKDATAPOINTS        3220

#define PEP_nRYAXISCOMPARISONSUBSETS 3225
#define PEP_nRYAXISSCALECONTROL     3230
#define PEP_nINITIALSCALEFORRYDATA  3235
#define PEP_nMANUALSCALECONTROLRY   3240
#define PEP_fMANUALMINRY            3245
#define PEP_fMANUALMAXRY            3250
#define PEP_szRYAXISLABEL           3255
#define PEP_nSCALEFORRYDATA         3256

#define PEP_bALLOWPLOTCUSTOMIZATION 3260
#define PEP_bNEGATIVEFROMXAXIS      3261
#define PEP_bMANUALYAXISTICKNLINE   3262
#define PEP_fMANUALYAXISTICK        3263
#define PEP_fMANUALYAXISLINE        3264
#define PEP_bMANUALRYAXISTICKNLINE  3265
#define PEP_fMANUALRYAXISTICK       3266
#define PEP_fMANUALRYAXISLINE       3267
#define PEP_fNULLDATAVALUE          3268
#define PEP_nPOINTSIZE              3269
#define PEP_naSUBSETPOINTTYPES      3270
#define PEP_naSUBSETLINETYPES       3271
#define PEP_bALLOWBESTFITCURVE      3272
#define PEP_nBESTFITDEGREE          3273
#define PEP_bALLOWSPLINE            3274
#define PEP_nCURVEGRANULARITY       3275

#define PEP_faAPPENDYDATA           3276
#define PEP_szaAPPENDPOINTLABELDATA 3277

#define PEP_bALLOWLINE              3279
#define PEP_bALLOWPOINT             3280
#define PEP_bALLOWBESTFITLINE       3281
#define PEP_nALLOWZOOMING           3282
#define PEP_bZOOMMODE               3283
#define PEP_fZOOMMINY               3284
#define PEP_fZOOMMAXY               3285

#define PEP_bFORCERIGHTYAXIS        3286
#define PEP_bALLOWPOINTSPLUSLINE    3287
#define PEP_bALLOWPOINTSPLUSSPLINE  3288
#define PEP_nSYMBOLFREQUENCY        3289

#define PEP_bSHOWANNOTATIONS        3290
#define PEP_bCSHOWANNOTATIONS       3202
#define PEP_dwANNOTATIONCOLOR       3203
#define PEP_dwCANNOTATIONCOLOR      3204
#define PEP_faGRAPHANNOTATIONX      3291
#define PEP_faGRAPHANNOTATIONY      3292
#define PEP_szaGRAPHANNOTATIONTEXT  3293
#define PEP_nMAXAXISANNOTATIONCLUSTER   3296
#define PEP_faXAXISANNOTATION       3297
#define PEP_szaXAXISANNOTATIONTEXT  3298
#define PEP_faYAXISANNOTATION       3299
#define PEP_szaYAXISANNOTATIONTEXT  3201
#define PEP_bANNOTATIONSINFRONT     3208
#define PEP_nCURSORPAGEAMOUNT       3211
#define PEP_fLINEGAPTHRESHOLD       3212

#define PEP_faHORZLINEANNOTATION    3213
#define PEP_szaHORZLINEANNOTATIONTEXT 3214
#define PEP_naHORZLINEANNOTATIONTYPE 3216
#define PEP_dwaHORZLINEANNOTATIONCOLOR 3217
#define PEP_faVERTLINEANNOTATION    3218
#define PEP_szaVERTLINEANNOTATIONTEXT 3219
#define PEP_naVERTLINEANNOTATIONTYPE 3221
#define PEP_dwaVERTLINEANNOTATIONCOLOR 3222
#define PEP_bSHOWGRAPHANNOTATIONS   3223
#define PEP_bSHOWXAXISANNOTATIONS   3224
#define PEP_bSHOWYAXISANNOTATIONS   3226
#define PEP_bSHOWHORZLINEANNOTATIONS 3227
#define PEP_bSHOWVERTLINEANNOTATIONS 3228
#define PEP_bALLOWGRAPHANNOTHOTSPOTS 3229
#define PEP_bALLOWXAXISANNOTHOTSPOTS 3231
#define PEP_bALLOWYAXISANNOTHOTSPOTS 3232
#define PEP_bALLOWHORZLINEANNOTHOTSPOTS 3233
#define PEP_bALLOWVERTLINEANNOTHOTSPOTS 3234
#define PEP_dwaGRAPHANNOTATIONCOLOR 3236
#define PEP_dwaXAXISANNOTATIONCOLOR 3237
#define PEP_dwaYAXISANNOTATIONCOLOR 3238
#define PEP_nGRAPHANNOTATIONTEXTSIZE 3242
#define PEP_nAXESANNOTATIONTEXTSIZE 3243
#define PEP_nLINEANNOTATIONTEXTSIZE 3244
#define PEP_naGRAPHANNOTATIONTYPE   3246
#define PEP_nZOOMINTERFACEONLY      3247
#define PEP_fZOOMMINX               3248
#define PEP_fZOOMMAXX               3249
#define PEP_nDATAHOTSPOTLIMIT       3251
#define PEP_nHOURGLASSTHRESHOLD     3252
#define PEP_nHORZSCROLLPOS          3253
#define PEP_bALLOWAREA              3254
#define PEP_bVERTORIENT90DEGREES    3257
#define PEP_dwaPOINTCOLORS          3258

#define PEP_naMULTIAXESSUBSETS      3001
#define PEP_naGRAPHANNOTATIONAXIS   3002
#define PEP_naHORZLINEANNOTATIONAXIS 3003
#define PEP_naYAXISANNOTATIONAXIS   3004
#define PEP_nWORKINGAXIS            3006
#define PEP_faMULTIAXESPROPORTIONS  3007
#define PEP_naLEGENDANNOTATIONAXIS  3008

#define PEP_bLOGSCALEEXPLABELS      3009
#define PEP_nPLOTTINGMETHODII       3011
#define PEP_nCPLOTTINGMETHODII      3012
#define PEP_faXDATAII               3013
#define PEP_faYDATAII               3014
#define PEP_bUSINGXDATAII           3016
#define PEP_bUSINGYDATAII           3017
#define PEP_nDATETIMEMODE           3018
#define PEP_fBARWIDTH               3019

#define PEP_nSPECIFICPLOTMODE       3021
#define PEP_bALLOWBAR               3022
#define PEP_structGRAPHLOC          3023
#define PEP_faAPPENDYDATAII         3024
#define PEP_bYAXISONRIGHT           3026

#define PEP_nSHOWYAXIS              3027
#define PEP_nSHOWRYAXIS             3028
#define PEP_nSHOWXAXIS              3029
#define PEP_nGRIDSTYLE              3032
#define PEP_bINVERTEDYAXIS          3033
#define PEP_bINVERTEDRYAXIS         3034
#define PEP_dwYAXISCOLOR            3036
#define PEP_dwRYAXISCOLOR           3037
#define PEP_dwXAXISCOLOR            3038                
#define PEP_fFONTSIZEAXISCNTL       3041
#define PEP_fFONTSIZELEGENDCNTL     3042

#define PEP_bYAXISLONGTICKS         3043
#define PEP_bRYAXISLONGTICKS        3044
#define PEP_nMULTIAXESSEPARATORS    3046
#define PEP_nZOOMMINAXIS            3047
#define PEP_nZOOMMAXAXIS            3048

#define PEP_rectGRAPH               3049
#define PEP_rectAXIS                3051
#define PEP_szLEFTMARGIN            3052
#define PEP_szTOPMARGIN             3053
#define PEP_szRIGHTMARGIN           3054
#define PEP_szBOTTOMMARGIN          3056

#define PEP_bAUTOSCALEDATA          3057                                        
#define PEP_faBESTFITCOEFFS         3058
#define PEP_naOVERLAPMULTIAXES      3059
#define PEP_bNOHIDDENLINESINAREA    3061
#define PEP_bSPECIFICPLOTMODECOLOR  3062
#define PEP_nAUTOMINMAXPADDING      3063

#define PEP_naAUTOSTATSUBSETS       3300    
#define PEP_bNOSTACKEDDATA          3305
#define PEP_nPOINTSTOGRAPHINIT      3310

#define PEP_nPOINTSTOGRAPHVERSION   3315
#define PEP_nCPOINTSTOGRAPHVERSION  3320

#define PEP_nPOINTSTOGRAPH          3325
#define PEP_nCPOINTSTOGRAPH         3330

#define PEP_naRANDOMPOINTSTOGRAPH   3335
#define PEP_naCRANDOMPOINTSTOGRAPH  3340

#define PEP_nFORCEVERTICALPOINTS    3345
#define PEP_nCFORCEVERTICALPOINTS   3350

#define PEP_nGRAPHPLUSTABLE         3355
#define PEP_nCGRAPHPLUSTABLE        3360

#define PEP_nTABLEWHAT              3365
#define PEP_nCTABLEWHAT             3370

#define PEP_bALLOWTABLEHOTSPOTS     3400
#define PEP_bALLOWHISTOGRAM         3401
#define PEP_naALTFREQUENCIES        3403
#define PEP_nTARGETPOINTSTOTABLE    3404
#define PEP_nALTFREQTHRESHOLD       3405
#define PEP_fMANUALSTACKEDMAXY      3406
#define PEP_nMAXPOINTSTOGRAPH       3407
#define PEP_bNORANDOMPOINTSTOGRAPH  3408
#define PEP_szMANUALMAXPOINTLABEL   3409
#define PEP_szMANUALMAXDATASTRING   3410
#define PEP_bALLOWBESTFITLINEII     3413
#define PEP_bALLOWBESTFITCURVEII    3414
#define PEP_bAPPENDTOEND            3415
#define PEP_bALLOWHORIZONTALBAR     3416

#define PEP_nFIRSTPTLABELOFFSET     3417
#define PEP_fMANUALSTACKEDMINY      3418
#define PEP_bALLOWHORZBARSTACKED    3419

#define PEP_nINITIALSCALEFORXDATA   3600
#define PEP_nSCALEFORXDATA          3605
#define PEP_nXAXISSCALECONTROL      3610

#define PEP_nMANUALSCALECONTROLX    3615
#define PEP_fMANUALMINX             3620
#define PEP_fMANUALMAXX             3625

#define PEP_bGRAPHDATALABELS        3630
#define PEP_bCGRAPHDATALABELS       3635

#define PEP_bALLOWBUBBLE            3640
#define PEP_nBUBBLESIZE             3641
#define PEP_nALLOWDATALABELS        3642
#define PEP_szaDATAPOINTLABELS      3643
#define PEP_bMANUALXAXISTICKNLINE   3644
#define PEP_fMANUALXAXISTICK        3645
#define PEP_fMANUALXAXISLINE        3646
#define PEP_bALLOWSTICK             3648
#define PEP_bSCROLLINGHORZZOOM      3652
#define PEP_bNORANDOMPOINTSTOEXPORT 3653
#define PEP_bXAXISVERTNUMBERING     3654
#define PEP_bENGSTATIONFORMAT       3655
#define PEP_fNULLDATAVALUEX         3656
#define PEP_bASSUMESEQDATA          3657
#define PEP_faAPPENDXDATA           3658
#define PEP_faAPPENDXDATAII         3659

#define PEP_nTXAXISCOMPARISONSUBSETS 3661
#define PEP_nTXAXISSCALECONTROL     3662
#define PEP_nINITIALSCALEFORTXDATA  3663
#define PEP_nMANUALSCALECONTROLTX   3664
#define PEP_fMANUALMINTX            3665
#define PEP_fMANUALMAXTX            3666
#define PEP_szTXAXISLABEL           3667
#define PEP_nSCALEFORTXDATA         3668
#define PEP_bMANUALTXAXISTICKNLINE  3669
#define PEP_fMANUALTXAXISTICK       3670
#define PEP_fMANUALTXAXISLINE       3671
#define PEP_bFORCETOPXAXIS          3672
#define PEP_bXAXISONTOP             3673
#define PEP_bINVERTEDXAXIS          3674 
#define PEP_bINVERTEDTXAXIS         3675
#define PEP_nSHOWTXAXIS             3676
#define PEP_dwTXAXISCOLOR           3677                

#define PEP_bXAXISLONGTICKS         3078
#define PEP_bTXAXISLONGTICKS        3079

#define PEP_bSMITHCHART             3800
#define PEP_bSMARTGRID              3801
#define PEP_nSHOWPOLARGRID          3802
#define PEP_nZERODEGREEOFFSET		3803

#define PEP_nGROUPINGPERCENT        3900
#define PEP_nCGROUPINGPERCENT       3905
#define PEP_nDATALABELTYPE          3910
#define PEP_nCDATALABELTYPE         3915
#define PEP_nAUTOEXPLODE            3920

#ifdef __cplusplus
extern "C" {
#endif  /* __cplusplus */

#ifdef WIN32
#define DllExport __declspec( dllexport ) 
#define DllExportReturnBool __declspec( dllexport ) BOOL __stdcall
#define DllExportReturnHWnd __declspec( dllexport ) HWND __stdcall
#define DllExportReturnInt __declspec( dllexport ) int __stdcall
#define DllExportReturnWord __declspec( dllexport ) WORD __stdcall
#define DllExportReturnVoid __declspec( dllexport ) void __stdcall
#define DllExportReturnHMeta __declspec( dllexport ) HMETAFILE __stdcall
#define DllExportReturnLong __declspec( dllexport ) long __stdcall
#define DllExportReturnDWord __declspec( dllexport ) DWORD __stdcall
#else // WIN16
#define DllExport   FAR PASCAL _export
#define DllExportReturnBool BOOL FAR PASCAL _export
#define DllExportReturnHWnd HWND FAR PASCAL _export
#define DllExportReturnInt int FAR PASCAL _export
#define DllExportReturnWord WORD FAR PASCAL _export
#define DllExportReturnVoid void FAR PASCAL _export
#define DllExportReturnHMeta HMETAFILE FAR PASCAL _export
#define DllExportReturnLong long FAR PASCAL _export
#define DllExportReturnDWord DWORD FAR PASCAL _export
#endif

DllExportReturnBool PEdrawcursor(HWND hObject, HDC hdc, UINT nAction);

DllExportReturnBool PEvset(HWND hObject, UINT nProperty, void FAR* lpvData, int nElements);
DllExportReturnInt PEvget(HWND hObject, UINT nProperty, void FAR* lpvDest);

DllExportReturnBool PEvsetcell(HWND hObject, UINT nProperty, int nCell, void FAR* lpvData);
DllExportReturnBool PEvgetcell(HWND hObject, UINT nProperty, int nCell, void FAR* lpvDest);

DllExportReturnBool PEvsetcellEx(HWND hObject, UINT nProperty, int nSubset, int nPoint, void FAR* lpvData);
DllExportReturnBool PEvgetcellEx(HWND hObject, UINT nProperty, int nSubset, int nPoint, void FAR* lpvDest);

DllExportReturnBool PEnset(HWND hObject, UINT nProperty, int nData);
DllExportReturnInt PEnget(HWND hObject, UINT nProperty);

DllExportReturnBool PEszset(HWND hObject, UINT nProperty, char FAR* szData);
DllExportReturnBool PEszget(HWND hObject, UINT nProperty, char FAR* szData);

#ifndef WIN32 // 16 specific
DllExportReturnBool PElset(HWND hObject, UINT nProperty, DWORD lData);
DllExportReturnLong PElget(HWND hObject, UINT nProperty);
#endif

DllExportReturnBool PEgetglobal(HWND hObject, GLOBALPROPERTIES FAR* lpData);
DllExportReturnBool PEsetglobal(HWND hObject, GLOBALPROPERTIES FAR* lpData);
DllExportReturnBool PEgetgraph(HWND hObject, GRAPHPROPERTIES FAR* lpData);
DllExportReturnBool PEsetgraph(HWND hObject, GRAPHPROPERTIES FAR* lpData);
DllExportReturnBool PEgetsgraph(HWND hObject, SGRAPHPROPERTIES FAR* lpData);
DllExportReturnBool PEsetsgraph(HWND hObject, SGRAPHPROPERTIES FAR* lpData);
DllExportReturnBool PEgetpiechart(HWND hObject, PIEPROPERTIES FAR* lpData);
DllExportReturnBool PEsetpiechart(HWND hObject, PIEPROPERTIES FAR* lpData);

DllExportReturnHWnd PEcreate(UINT nObjectType, DWORD dwStyle, RECT FAR* lpRect, HWND hParent, UINT nID);
DllExportReturnBool PEdestroy(HWND hObject);

DllExportReturnBool PEload(HWND hObject, HGLOBAL FAR* lphGlbl);
DllExportReturnBool PEstore(HWND hObject, HGLOBAL FAR* lphGlbl, DWORD FAR* lpdwSize);

DllExportReturnBool PEloadpartial(HWND hObject, HGLOBAL FAR* lphGlbl);
DllExportReturnBool PEstorepartial(HWND hObject, HGLOBAL FAR* lphGlbl, DWORD FAR* lpdwSize);

DllExportReturnHMeta PEgetmeta(HWND hObject);
DllExportReturnBool PEresetimage(HWND hObject, UINT nLength, UINT nHeight);

DllExportReturnInt PElaunchcustomize(HWND hObject);
DllExportReturnBool PElaunchexport(HWND hObject);
DllExportReturnBool PElaunchmaximize(HWND hObject);
DllExportReturnBool PElaunchtextexport(HWND hObject, BOOL bToFile, char FAR* lpszFilename);
DllExportReturnBool PElaunchprintdialog(HWND hObject, BOOL bFullPage, POINT FAR* pSize);
DllExportReturnInt PElaunchcolordialog(HWND hObject);
DllExportReturnInt PElaunchfontdialog(HWND hObject);
DllExportReturnBool PElaunchpopupmenu(HWND hObject, POINT FAR* pLocation);

DllExportReturnBool PEreinitialize(HWND hObject);
DllExportReturnBool PEreinitializecustoms(HWND hObject);
DllExportReturnBool PEreset(HWND hObject);

DllExportReturnDWord PEgethelpcontext(HWND hWnd);

DllExportReturnBool PEcopymetatoclipboard(HWND hObject, POINT FAR* lpPoint);
DllExportReturnBool PEcopymetatofile(HWND hObject, POINT FAR* lpPoint, char FAR* lpszFilename);
DllExportReturnBool PEcopybitmaptoclipboard(HWND hObject, POINT FAR* lpPoint);
DllExportReturnBool PEcopybitmaptofile(HWND hObject, POINT FAR* lpPoint, char FAR* lpszFilename);
DllExportReturnBool PEcopyoletoclipboard(HWND hObject, POINT FAR* lpPoint);

DllExportReturnBool PEallocateindmemory(HWND hObject);
DllExportReturnBool PEfilterdllmsg(LPMSG lpMsg);
DllExportReturnVoid PEprocessdllidle();
DllExportReturnVoid PEDebugOutput(UINT nId);
DllExportReturnBool PEValidateProperty(UINT nCntlType, UINT nProperty);

DllExportReturnVoid PEcreateserialdate(double* pfSerial, TM* dt, int nType);
DllExportReturnVoid PEdecipherserialdate(double* pfSerial, TM* dt, int nType);
DllExportReturnBool PEprintgraph(HWND hObject, int hDC, int nWidth, int nHeight, int nOrient);
DllExportReturnBool PEconvpixeltograph(HWND hObject, int* pnAxis, int* pnX, int* pnY, 
    double* pfX, double* pfY, BOOL bRightAxis, BOOL bTopAxis, BOOL bViceVersa);

#ifdef __cplusplus
}
#endif

#endif  // __PEGRPAPI_H__

