/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_PSSETUPDLG_H__759D0981_FC89_11D1_B00C_444553540000__INCLUDED_)
#define AFX_PSSETUPDLG_H__759D0981_FC89_11D1_B00C_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// PSSetupDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CPSSetupDlg dialog

class CPSSetupDlg : public CDialog
{
// Construction
public:
	//int VSIndex;
	CBudaDoc* pDoc;
	BOOL ListedChannel(int);
	BOOL IsUsedChannel(int);
	int Link2Event;
	int Linking;
	void SetListBoxFont();
	int EventIndices[MAX_PS_EVENTS];
	void InitEventInfo();
	void InitEventList();
	int NumChannelEvents;
	int CurrentEvent;
	int CurrentDP;
	int EventType;
	int MaxChannelIndex;
	int ChannelIndex[40];
	struct sys* sys;
	struct PS* PS;
	CFont m_font;
	BOOL OnInitDialog();
	CPSSetupDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CPSSetupDlg)
	enum { IDD = IDD_PSSETUP };
	CComboBox	EventTypeCMBO;
	CListBox	EventList;
	CListBox	DacPulseList;
	double	Duration;
	double	FinalValue;
	double	StartTime;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPSSetupDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CPSSetupDlg)
	afx_msg void OnClearEvents();
	afx_msg void OnDeleteEvent();
	afx_msg void OnNewEvent();
	afx_msg void OnSelchangeEventlist();
	afx_msg void OnSelchangeDacpulselist();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PSSETUPDLG_H__759D0981_FC89_11D1_B00C_444553540000__INCLUDED_)
