/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_PARMVIEW_H__72C77861_C3BF_11D1_9106_44455354616F__INCLUDED_)
#define AFX_PARMVIEW_H__72C77861_C3BF_11D1_9106_44455354616F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// ParmView.h : header file
//

#include "BudaDoc.h"

/////////////////////////////////////////////////////////////////////////////
// CParmView view

class CParmView : public CEditView
{
protected:
	CParmView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CParmView)

// Attributes
public:

// Operations
public:
	struct PS* PS;
	CBudaApp* pApp;
	LOGFONT m_lfDefFont;
	CFont m_font;
	CString m_ScreenBuffer;
	CBudaDoc* PDoc;
	void SetParmViewFont();
	void CreateParmViewBuffer();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CParmView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CParmView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(CParmView)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PARMVIEW_H__72C77861_C3BF_11D1_9106_44455354616F__INCLUDED_)
