// PeriodTable.cpp : implementation file
//

#include "stdafx.h"
#include "BudaMaster.h"
#include "Buda.h"
#include "Instrument.h"
#include "PeriodTable.h"
#include "ElemDlg.h"
#include <direct.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPeriodTable dialog


CPeriodTable::CPeriodTable(CWnd* pParent /*=NULL*/)
	: CDialog(CPeriodTable::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPeriodTable)
	m_ElementalComposition = _T("");
	//}}AFX_DATA_INIT
	pApp = (CBudaApp*) AfxGetApp();
	Instrument=GetInstrument();
	sys=GetSys();
	ReadInPeriodicTable();
}

void CPeriodTable::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPeriodTable)
	DDX_Text(pDX, IDC_ECOMPOSITION, m_ElementalComposition);
	//}}AFX_DATA_MAP		
}

BEGIN_MESSAGE_MAP(CPeriodTable, CDialog)
	//{{AFX_MSG_MAP(CPeriodTable)
	ON_BN_CLICKED(IDC_CARBON, OnCarbon)
	ON_BN_CLICKED(IDC_HYDROGEN, OnHydrogen)
	ON_BN_CLICKED(IDC_LITHIUM, OnLithium)
	ON_BN_CLICKED(IDC_ACTINIUM, OnActinium)
	ON_BN_CLICKED(IDC_ALUMINUM, OnAluminum)
	ON_BN_CLICKED(IDC_ANTIMONY, OnAntimony)
	ON_BN_CLICKED(IDC_ARGON, OnArgon)
	ON_BN_CLICKED(IDC_ARSENIC, OnArsenic)
	ON_BN_CLICKED(IDC_ASTATINE, OnAstatine)
	ON_BN_CLICKED(IDC_BARIUM, OnBarium)
	ON_BN_CLICKED(IDC_BERYLIUM, OnBerylium)
	ON_BN_CLICKED(IDC_BISMUTH, OnBismuth)
	ON_BN_CLICKED(IDC_BORON, OnBoron)
	ON_BN_CLICKED(IDC_BROMINE, OnBromine)
	ON_BN_CLICKED(IDC_CADMIUM, OnCadmium)
	ON_BN_CLICKED(IDC_CALCIUM, OnCalcium)
	ON_BN_CLICKED(IDC_CERIUM, OnCerium)
	ON_BN_CLICKED(IDC_CESIUM, OnCesium)
	ON_BN_CLICKED(IDC_CHLORINE, OnChlorine)
	ON_BN_CLICKED(IDC_CHROMIUM, OnChromium)
	ON_BN_CLICKED(IDC_COBALT, OnCobalt)
	ON_BN_CLICKED(IDC_COPPER, OnCopper)
	ON_BN_CLICKED(IDC_DYSPROSIUM, OnDysprosium)
	ON_BN_CLICKED(IDC_ERBIUM, OnErbium)
	ON_BN_CLICKED(IDC_EUROPIUM, OnEuropium)
	ON_BN_CLICKED(IDC_FLOURINE, OnFlourine)
	ON_BN_CLICKED(IDC_FRANCIUM, OnFrancium)
	ON_BN_CLICKED(IDC_GADOLINIUM, OnGadolinium)
	ON_BN_CLICKED(IDC_GERMANIUM, OnGermanium)
	ON_BN_CLICKED(IDC_GOLD, OnGold)
	ON_BN_CLICKED(IDC_HAFNIUM, OnHafnium)
	ON_BN_CLICKED(IDC_HELIUM, OnHelium)
	ON_BN_CLICKED(IDC_HOLMIUM, OnHolmium)
	ON_BN_CLICKED(IDC_INDIUM, OnIndium)
	ON_BN_CLICKED(IDC_IODINE, OnIodine)
	ON_BN_CLICKED(IDC_IRIDIUM, OnIridium)
	ON_BN_CLICKED(IDC_IRON, OnIron)
	ON_BN_CLICKED(IDC_KRYPTON, OnKrypton)
	ON_BN_CLICKED(IDC_LANTHANUM, OnLanthanum)
	ON_BN_CLICKED(IDC_LEAD, OnLead)
	ON_BN_CLICKED(IDC_LUTETIUM, OnLutetium)
	ON_BN_CLICKED(IDC_MAGNESIUM, OnMagnesium)
	ON_BN_CLICKED(IDC_MANGANESE, OnManganese)
	ON_BN_CLICKED(IDC_MERCURY, OnMercury)
	ON_BN_CLICKED(IDC_MOLYBDENUM, OnMolybdenum)
	ON_BN_CLICKED(IDC_NEODYMIUM, OnNeodymium)
	ON_BN_CLICKED(IDC_NEON, OnNeon)
	ON_BN_CLICKED(IDC_NICKEL, OnNickel)
	ON_BN_CLICKED(IDC_NIOBIUM, OnNiobium)
	ON_BN_CLICKED(IDC_NITROGEN, OnNitrogen)
	ON_BN_CLICKED(IDC_OSMIUM, OnOsmium)
	ON_BN_CLICKED(IDC_OXYGEN, OnOxygen)
	ON_BN_CLICKED(IDC_PALLADIUM, OnPalladium)
	ON_BN_CLICKED(IDC_PHOSPHORUS, OnPhosphorus)
	ON_BN_CLICKED(IDC_PLATINUM, OnPlatinum)
	ON_BN_CLICKED(IDC_POLONIUM, OnPolonium)
	ON_BN_CLICKED(IDC_POTASSIUM, OnPotassium)
	ON_BN_CLICKED(IDC_PRASEODYMIUM, OnPraseodymium)
	ON_BN_CLICKED(IDC_PROMETHIUM, OnPromethium)
	ON_BN_CLICKED(IDC_PROTACTINIUM, OnProtactinium)
	ON_BN_CLICKED(IDC_RADIUM, OnRadium)
	ON_BN_CLICKED(IDC_RADON, OnRadon)
	ON_BN_CLICKED(IDC_RHENIUM, OnRhenium)
	ON_BN_CLICKED(IDC_RHODIUM, OnRhodium)
	ON_BN_CLICKED(IDC_RUBIDIUM, OnRubidium)
	ON_BN_CLICKED(IDC_RUTHENIUM, OnRuthenium)
	ON_BN_CLICKED(IDC_SAMARIUM, OnSamarium)
	ON_BN_CLICKED(IDC_SCANDIUM, OnScandium)
	ON_BN_CLICKED(IDC_SELENIUM, OnSelenium)
	ON_BN_CLICKED(IDC_SILICON, OnSilicon)
	ON_BN_CLICKED(IDC_SILVER, OnSilver)
	ON_BN_CLICKED(IDC_SODIUM, OnSodium)
	ON_BN_CLICKED(IDC_STRONTIUM, OnStrontium)
	ON_BN_CLICKED(IDC_SULFUR, OnSulfur)
	ON_BN_CLICKED(IDC_TANTALUM, OnTantalum)
	ON_BN_CLICKED(IDC_TECHNETIUM, OnTechnetium)
	ON_BN_CLICKED(IDC_TELLURIUM, OnTellurium)
	ON_BN_CLICKED(IDC_TERBIUM, OnTerbium)
	ON_BN_CLICKED(IDC_THALLIUM, OnThallium)
	ON_BN_CLICKED(IDC_THORIUM, OnThorium)
	ON_BN_CLICKED(IDC_THULIUM, OnThulium)
	ON_BN_CLICKED(IDC_TIN, OnTin)
	ON_BN_CLICKED(IDC_TITANIUM, OnTitanium)
	ON_BN_CLICKED(IDC_TUNGSTEN, OnTungsten)
	ON_BN_CLICKED(IDC_URANIUM, OnUranium)
	ON_BN_CLICKED(IDC_VANADIUM, OnVanadium)
	ON_BN_CLICKED(IDC_XENON, OnXenon)
	ON_BN_CLICKED(IDC_YTTERBIUM, OnYtterbium)
	ON_BN_CLICKED(IDC_YTTRIUM, OnYttrium)
	ON_BN_CLICKED(IDC_ZINC, OnZinc)
	ON_BN_CLICKED(IDC_ZIRCONIUM, OnZirconium)
	ON_BN_CLICKED(IDC_GALLIUM, OnGallium)
	ON_BN_CLICKED(IDC_CALIFORNIUM, OnCalifornium)
	ON_BN_CLICKED(IDC_AMERICIUM, OnAmericium)
	ON_BN_CLICKED(IDC_BERKELIUM, OnBerkelium)
	ON_BN_CLICKED(IDC_EINSTEINIUM, OnEinsteinium)
	ON_BN_CLICKED(IDC_CURIUM, OnCurium)
	ON_BN_CLICKED(IDC_FERMIUM, OnFermium)
	ON_BN_CLICKED(IDC_LAWRENCIUM, OnLawrencium)
	ON_BN_CLICKED(IDC_MENDELEVIUM, OnMendelevium)
	ON_BN_CLICKED(IDC_NEPTUNIUM, OnNeptunium)
	ON_BN_CLICKED(IDC_NOBELIUM, OnNobelium)
	ON_BN_CLICKED(IDC_PLUTONIUM, OnPlutonium)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPeriodTable message handlers

void CPeriodTable::OnCarbon() 
{
	OnElement("Carbon");	
}

void CPeriodTable::OnHydrogen() 
{
	OnElement("Hydrogen");	
}

void CPeriodTable::OnLithium()
{
	OnElement("Lithium");	
}

void CPeriodTable::OnHelium()
{
	OnElement("Helium");
}

void CPeriodTable::OnBerylium()
{
	OnElement("Berylium");	
}

void CPeriodTable::OnBoron()
{
	OnElement("Boron");	
}

void CPeriodTable::OnNitrogen()
{
	OnElement("Nitrogen");	
}

void CPeriodTable::OnOxygen()
{
	OnElement("Oxygen");	
}

void CPeriodTable::OnFlourine()
{
	OnElement("Flourine");	
}

void CPeriodTable::OnNeon()
{
	OnElement("Neon");	
}

void CPeriodTable::OnSodium()
{
	OnElement("Sodium");	
}

void CPeriodTable::OnMagnesium()
{
	OnElement("Magnesium");	
}

void CPeriodTable::OnAluminum()
{
	OnElement("Aluminum");	
}

void CPeriodTable::OnSilicon()
{
	OnElement("Silicon");	
}

void CPeriodTable::OnPhosphorus()
{
	OnElement("Phosphorus");	
}

void CPeriodTable::OnSulfur()
{
	OnElement("Sulfur");	
}

void CPeriodTable::OnChlorine()
{
	OnElement("Chlorine");	
}

void CPeriodTable::OnArgon()
{
	OnElement("Argon");	
}

void CPeriodTable::OnPotassium()
{
	OnElement("Potassium");	
}

void CPeriodTable::OnCalcium()
{
	OnElement("Calcium");	
}

void CPeriodTable::OnScandium()
{
	OnElement("Scandium");	
}

void CPeriodTable::OnTitanium()
{
	OnElement("Titanium");	
}

void CPeriodTable::OnVanadium()
{
	OnElement("Vanadium");	
}

void CPeriodTable::OnChromium()
{
	OnElement("Chromium");	
}

void CPeriodTable::OnManganese()
{
	OnElement("Manganese");	
}

void CPeriodTable::OnIron()
{
	OnElement("Iron");	
}

void CPeriodTable::OnCobalt()
{
	OnElement("Cobalt");	
}

void CPeriodTable::OnNickel()
{
	OnElement("Nickel");	
}

void CPeriodTable::OnCopper()
{
	OnElement("Copper");	
}

void CPeriodTable::OnZinc()
{
	OnElement("Zinc");	
}

void CPeriodTable::OnGermanium()
{
	OnElement("Germanium");	
}

void CPeriodTable::OnArsenic()
{
	OnElement("Arsenic");	
}

void CPeriodTable::OnSelenium()
{
	OnElement("Selenium");	
}

void CPeriodTable::OnBromine()
{
	OnElement("Bromine");	
}

void CPeriodTable::OnKrypton()
{
	OnElement("Krypton");	
}

void CPeriodTable::OnRubidium()
{
	OnElement("Rubidium");	
}

void CPeriodTable::OnStrontium()
{
	OnElement("Strontium");	
}

void CPeriodTable::OnYttrium()
{
	OnElement("Yttrium");	
}

void CPeriodTable::OnZirconium()
{
	OnElement("Zirconium");	
}

void CPeriodTable::OnNiobium()
{
	OnElement("Niobium");	
}

void CPeriodTable::OnMolybdenum()
{
	OnElement("Molybdenum");	
}

void CPeriodTable::OnTechnetium()
{
	OnElement("Technetium");	
}

void CPeriodTable::OnRuthenium()
{
		OnElement("Ruthenium");	
}

void CPeriodTable::OnRhodium()
{
	OnElement("Rhodium");	
}

void CPeriodTable::OnPalladium()
{
	OnElement("Palladium");	
}

void CPeriodTable::OnSilver()
{
	OnElement("Silver");	
}

void CPeriodTable::OnCadmium()
{
	OnElement("Cadmium");	
}

void CPeriodTable::OnIndium()
{
	OnElement("Indium");	
}

void CPeriodTable::OnTin()
{
	OnElement("Tin");	
}

void CPeriodTable::OnAntimony()
{
	OnElement("Antimony");	
}

void CPeriodTable::OnTellurium()
{
	OnElement("Tellurium");	
}

void CPeriodTable::OnIodine()
{
	OnElement("Iodine");	
}

void CPeriodTable::OnXenon()
{
	OnElement("Xenon");	
}

void CPeriodTable::OnCesium()
{
	OnElement("Cesium");	
}

void CPeriodTable::OnBarium()
{
	OnElement("Barium");	
}

void CPeriodTable::OnLanthanum()
{
	OnElement("Lanthanum");	
}

void CPeriodTable::OnCerium()
{
	OnElement("Cerium");	
}

void CPeriodTable::OnPraseodymium()
{
	OnElement("Praseodymium");	
}

void CPeriodTable::OnNeodymium()
{
	OnElement("Neodymium");	
}

void CPeriodTable::OnPromethium()
{
	OnElement("Promethium");	
}

void CPeriodTable::OnSamarium()
{
	OnElement("Samarium");	
}

void CPeriodTable::OnEuropium()
{
	OnElement("Europium");	
}

void CPeriodTable::OnGadolinium()
{
	OnElement("Gadolinium");	
}

void CPeriodTable::OnTerbium()
{
	OnElement("Terbium");	
}

void CPeriodTable::OnDysprosium()
{
	OnElement("Dysprosium");	
}

void CPeriodTable::OnHolmium()
{
	OnElement("Holmium");	
}

void CPeriodTable::OnErbium()
{
	OnElement("Erbium");	
}

void CPeriodTable::OnThulium()
{
	OnElement("Thulium");	
}

void CPeriodTable::OnYtterbium()
{
	OnElement("Ytterbium");	
}

void CPeriodTable::OnLutetium()
{
	OnElement("Lutetium");	
}

void CPeriodTable::OnHafnium()
{
	OnElement("Hafnium");	
}

void CPeriodTable::OnTantalum()
{
	OnElement("Tantalum");	
}

void CPeriodTable::OnTungsten()
{
	OnElement("Tungsten");	
}

void CPeriodTable::OnRhenium()
{
	OnElement("Rhenium");	
}

void CPeriodTable::OnOsmium()
{
	OnElement("Osmium");	
}

void CPeriodTable::OnIridium()
{
	OnElement("Iridium");	
}

void CPeriodTable::OnPlatinum()
{
	OnElement("Platinum");	
}

void CPeriodTable::OnGold()
{
	OnElement("Gold");	
}

void CPeriodTable::OnMercury()
{
	OnElement("Mercury");	
}

void CPeriodTable::OnThallium()
{
	OnElement("Thallium");	
}

void CPeriodTable::OnLead()
{
	OnElement("Lead");	
}

void CPeriodTable::OnBismuth()
{
	OnElement("Bismuth");	
}

void CPeriodTable::OnPolonium()
{
	OnElement("Polonium");	
}

void CPeriodTable::OnAstatine()
{
	OnElement("Astatine");	
}

void CPeriodTable::OnRadon()
{
	OnElement("Radon");	
}

void CPeriodTable::OnFrancium()
{
	OnElement("Francium");	
}

void CPeriodTable::OnRadium()
{
	OnElement("Radium");	
}

void CPeriodTable::OnActinium()
{
	OnElement("Actinium");	
}

void CPeriodTable::OnThorium()
{
	OnElement("Thorium");	
}

void CPeriodTable::OnProtactinium()
{
	OnElement("Protactinium");	
}

void CPeriodTable::OnUranium()
{
	OnElement("Uranium");	
}

void CPeriodTable::OnGallium()
{
	OnElement("Gallium");
}

void CPeriodTable::OnCalifornium()
{
	OnElement("Californium");
}

void CPeriodTable::OnAmericium()
{
	OnElement("Americium");
}

void CPeriodTable::OnBerkelium()
{
	OnElement("Berkelium");
}

void CPeriodTable::OnEinsteinium()
{
	OnElement("Einsteinium");
}

void CPeriodTable::OnCurium()
{
	OnElement("Curium");
}

void CPeriodTable::OnFermium()
{
	OnElement("Fermium");
}

void CPeriodTable::OnLawrencium()
{
	OnElement("Lawrencium");
}

void CPeriodTable::OnMendelevium()
{
	OnElement("Mendelevium");
}

void CPeriodTable::OnNeptunium()
{
	OnElement("Neptunium");
}

void CPeriodTable::OnNobelium()
{
	OnElement("Nobelium");
}

void CPeriodTable::OnPlutonium()
{
	OnElement("Plutonium");
}

int CPeriodTable::CountNumTabs(CString str)
{
	int tabcount=0, i;
	char c;
	for (i=0;i<str.GetLength();i++)
	{
		c=str.GetAt(i);
		if (c=='\t')
			tabcount++;
	}
	return tabcount;
}

struct sys* CPeriodTable::GetSys()
{
	return Instrument->GetSys();
}

void CPeriodTable::ReadInPeriodicTable()
{
	CFile file;
	CString str, rightstr;

	if(_chdir(*(pApp->ProgramDirectory))==-1) 
	{
		str.Format("Error 22a\nCouldn't change to Buda directory\n%s", pApp->ProgramDirectory);
		MessageBox(str, "Directory Error!");
		return;
	}

	CString filename = "Elements.txt";
	if(!file.Open(filename,CFile::modeRead, NULL))
	{
		str.Format("Error 21\nCouldn't open document file:\n%s",filename);
		MessageBox(str,"File Error!");
		return;
	}
	CArchive ar(&file, CArchive::load, 4096, NULL);

	int numtabs = 0;
	int elemcount=-1;
	int isocount;
	int tabpos=0;
	int i;
	CString Rightstr,Leftstr,Midstr;
	struct Isotope  TempIsos[10];
	while(ar.ReadString(str))  // while not end of file, read a line
	{
		if (str.GetLength()==0) continue;  // ignore empty lines
		if (str.Left(1)=="#") continue;		// ignore comment lines starting with #

		numtabs = CountNumTabs(str);

		switch (numtabs) 
		{
		case 0:
			if(elemcount>=0) 
			{
				PeriodTable[elemcount].NumIsos=isocount;
				PeriodTable[elemcount].Isos=new struct Isotope[isocount];
				for (i=0; i<isocount; i++)
				{
					PeriodTable[elemcount].Isos[i]=TempIsos[i];
				}
			}
			elemcount++;
			PeriodTable[elemcount].ElementName=str;
			isocount=0;
			//TRACE(str+"\r\n");
			break;
		case 1:
			tabpos = GetTabPosition(str);
			Rightstr=str.Right(str.GetLength()-tabpos-1);
			Leftstr=str.Left(tabpos);
			PeriodTable[elemcount].ElementSymbol=Leftstr;
			//check for '-'
			if(Rightstr.Left(1)=="-") 
			{
				PeriodTable[elemcount].AverageMass=-1;
			} 
			else 
			{
				sscanf(Rightstr,"%lf",&(PeriodTable[elemcount].AverageMass));
			}
			//str.Format("Elementsymbol = %s, Averagemass = %lf\r\n",PeriodTable[elemcount].ElementSymbol,PeriodTable[elemcount].AverageMass);
			//TRACE(str);
			break;
		case 2:
			tabpos = GetTabPosition(str);
			Rightstr=str.Right(str.GetLength()-tabpos-1);
			Leftstr=str.Left(tabpos);
			tabpos = GetTabPosition(Rightstr);
			Midstr=Rightstr.Left(tabpos);
			Rightstr=Rightstr.Right(Rightstr.GetLength()-tabpos-1);
			TempIsos[isocount].Isoname=Leftstr;
			sscanf(Midstr,"%lf",&(TempIsos[isocount].Isomass));
			sscanf(Rightstr,"%lf",&(TempIsos[isocount].IsoAbund));
			//str.Format("Isoname = %s, Isomass = %lf, Isoabund = %lf\r\n",TempIsos[isocount].Isoname,TempIsos[isocount].Isomass,TempIsos[isocount].IsoAbund);
			//TRACE(str);
			TempIsos[isocount].IsoNum=0;
			isocount++;
			break;
		}
	}
	ElementCount=elemcount;
}

void CPeriodTable::OnElement(CString ElementName)
{
	CElemDlg dlg;
	// then set the dlg's variables according to that PeriodicTable entry	
	dlg.m_ElementName = ElementName;	
	dlg.m_PeriodTable = PeriodTable;
	//double AverageMass = AvgMass;

	dlg.DoModal();
		
	// then read back the IsoNum variable and store it

	// and append an entry to the m_ElementalComposition string
}

int CPeriodTable::GetTabPosition(CString str)
{
	int i;
	char c;
	for (i=0;i<str.GetLength();i++)
	{
		c=str.GetAt(i);
		if (c=='\t') return i;
	}
	return i;	
}

CInstrument* CPeriodTable::GetInstrument()
{
	return &(pApp->System);
}

BOOL CPeriodTable::DestroyWindow()
{
	int i;
	for (i=0; i<ElementCount; i++) 
	{
		delete [] PeriodTable[i].Isos;
	}
	return CDialog::DestroyWindow();
}