/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_PERIODTABLE_H__015B6EA2_E9A5_11D1_BD42_E5A9ABA6E905__INCLUDED_)
#define AFX_PERIODTABLE_H__015B6EA2_E9A5_11D1_BD42_E5A9ABA6E905__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// PeriodTable.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CPeriodicTable dialog

class CPeriodicTable : public CDialog
{
// Construction
public:

	BOOL DestroyWindow();
	CInstrument* GetInstrument();
	int GetTabPosition(CString str);
	void OnElement(CString ElementName);
	void ReadInPeriodicTable();
	struct sys* GetSys();
	int ElementCount;
	CBudaApp* pApp;
	CInstrument* Instrument;
	struct Element PeriodTable[120];
	struct sys* sys;
	int CountNumTabs(CString str);
	CPeriodicTable(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CPeriodicTable)
	enum { IDD = IDD_PERIODICTABLE };
	CString	m_ElementalComposition;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPeriodicTable)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	
	// Generated message map functions
	//{{AFX_MSG(CPeriodicTable)
	afx_msg void OnCarbon();
	afx_msg void OnHydrogen();
	afx_msg void OnLithium();
	afx_msg void OnActinium();
	afx_msg void OnAluminum();
	afx_msg void OnAntimony();
	afx_msg void OnArgon();
	afx_msg void OnArsenic();
	afx_msg void OnAstatine();
	afx_msg void OnBarium();
	afx_msg void OnBerylium();
	afx_msg void OnBismuth();
	afx_msg void OnBoron();
	afx_msg void OnBromine();
	afx_msg void OnCadmium();
	afx_msg void OnCalcium();
	afx_msg void OnCerium();
	afx_msg void OnCesium();
	afx_msg void OnChlorine();
	afx_msg void OnChromium();
	afx_msg void OnCobalt();
	afx_msg void OnCopper();
	afx_msg void OnDysprosium();
	afx_msg void OnErbium();
	afx_msg void OnEuropium();
	afx_msg void OnFlourine();
	afx_msg void OnFrancium();
	afx_msg void OnGadolinium();
	afx_msg void OnGermanium();
	afx_msg void OnGold();
	afx_msg void OnHafnium();
	afx_msg void OnHelium();
	afx_msg void OnHolmium();
	afx_msg void OnIndium();
	afx_msg void OnIodine();
	afx_msg void OnIridium();
	afx_msg void OnIron();
	afx_msg void OnKrypton();
	afx_msg void OnLanthanum();
	afx_msg void OnLead();
	afx_msg void OnLutetium();
	afx_msg void OnMagnesium();
	afx_msg void OnManganese();
	afx_msg void OnMercury();
	afx_msg void OnMolybdenum();
	afx_msg void OnNeodymium();
	afx_msg void OnNeon();
	afx_msg void OnNickel();
	afx_msg void OnNiobium();
	afx_msg void OnNitrogen();
	afx_msg void OnOsmium();
	afx_msg void OnOxygen();
	afx_msg void OnPalladium();
	afx_msg void OnPhosphorus();
	afx_msg void OnPlatinum();
	afx_msg void OnPolonium();
	afx_msg void OnPotassium();
	afx_msg void OnPraseodymium();
	afx_msg void OnPromethium();
	afx_msg void OnProtactinium();
	afx_msg void OnRadium();
	afx_msg void OnRadon();
	afx_msg void OnRhenium();
	afx_msg void OnRhodium();
	afx_msg void OnRubidium();
	afx_msg void OnRuthenium();
	afx_msg void OnSamarium();
	afx_msg void OnScandium();
	afx_msg void OnSelenium();
	afx_msg void OnSilicon();
	afx_msg void OnSilver();
	afx_msg void OnSodium();
	afx_msg void OnStrontium();
	afx_msg void OnSulfur();
	afx_msg void OnTantalum();
	afx_msg void OnTechnetium();
	afx_msg void OnTellurium();
	afx_msg void OnTerbium();
	afx_msg void OnThallium();
	afx_msg void OnThorium();
	afx_msg void OnThulium();
	afx_msg void OnTin();
	afx_msg void OnTitanium();
	afx_msg void OnTungsten();
	afx_msg void OnUranium();
	afx_msg void OnVanadium();
	afx_msg void OnXenon();
	afx_msg void OnYtterbium();
	afx_msg void OnYttrium();
	afx_msg void OnZinc();
	afx_msg void OnZirconium();
	afx_msg void OnGallium();
	afx_msg void OnCalifornium();
	afx_msg void OnAmericium();
	afx_msg void OnBerkelium();
	afx_msg void OnEinsteinium();
	afx_msg void OnCurium();
	afx_msg void OnFermium();
	afx_msg void OnLawrencium();
	afx_msg void OnMendelevium();
	afx_msg void OnNeptunium();
	afx_msg void OnNobelium();
	afx_msg void OnPlutonium();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PERIODTABLE_H__015B6EA2_E9A5_11D1_BD42_E5A9ABA6E905__INCLUDED_)
