/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_SAVEFILEOPSDLG_H__2026C1E5_B7F0_11D1_9106_44455354616F__INCLUDED_)
#define AFX_SAVEFILEOPSDLG_H__2026C1E5_B7F0_11D1_9106_44455354616F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// SaveFileOpsDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSaveFileOpsDlg dialog

class CSaveFileOpsDlg : public CPropertyPage
{
	DECLARE_DYNCREATE(CSaveFileOpsDlg)

// Construction
public:
	BOOL SaveFileOpsChanged;
	long m_DefFileNameType;
	long AutoSave;
	long SaveTruncated;
	BOOL SaveMITable;
	long SaveSpectrum;
	long SaveTransient;
	CSaveFileOpsDlg();
	~CSaveFileOpsDlg();

// Dialog Data
	//{{AFX_DATA(CSaveFileOpsDlg)
	enum { IDD = IDD_SAVE_OPTIONS };
	CButton	m_SaveTranBtn;
	CButton	m_SaveSpecBtn;
	CButton	m_SaveMIBtn;
	CButton	m_SaveTruncatedBtn;
	CComboBox	m_FileNameCombo;
	CButton	m_AutoSaveBtn;
	CString	m_DefaultDir;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CSaveFileOpsDlg)
	public:
	virtual BOOL OnKillActive();
	virtual BOOL OnSetActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CSaveFileOpsDlg)
	afx_msg void OnAutoSaveOnAcquire();
	afx_msg void OnSelchangeFileNameCombo();
	afx_msg void OnSaveTruncatedTransient();
	afx_msg void OnSaveMitableChk();
	afx_msg void OnSaveTransientChk();
	afx_msg void OnSaveSpectrumChk();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SAVEFILEOPSDLG_H__2026C1E5_B7F0_11D1_9106_44455354616F__INCLUDED_)
