// SelectSourceDlg.cpp : implementation file
//
/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "stdafx.h"
#include "Buda.h"
#include "SelectSourceDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSelectSourceDlg dialog


CSelectSourceDlg::CSelectSourceDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSelectSourceDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelectSourceDlg)
	m_UserID = _T("");
	//}}AFX_DATA_INIT
}


void CSelectSourceDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelectSourceDlg)
	DDX_Control(pDX, IDC_EDIT1, m_UserIDEdit);
	DDX_Text(pDX, IDC_EDIT1, m_UserID);
	DDX_Control(pDX, IDC_HIRESMALDI_BTN, m_HiResMALDIbtn);
	DDX_Control(pDX, IDC_HIRESESI_BTN, m_HiResESIbtn);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelectSourceDlg, CDialog)
	//{{AFX_MSG_MAP(CSelectSourceDlg)
	ON_EN_KILLFOCUS(IDC_EDIT1, OnKillfocusUserID)
	ON_BN_CLICKED(IDC_HIRESESI_BTN, OnHiresesiBtn)
	ON_BN_CLICKED(IDC_HIRESMALDI_BTN, OnHiresmaldiBtn)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelectSourceDlg message handlers

BOOL CSelectSourceDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	Source = 0;

	m_UserIDEdit.SetWindowText(m_UserID);
	// set the input focus to the edit control
	m_UserIDEdit.SetFocus();
	SetDefID(IDC_EDIT1);

	UpdateData(FALSE);
	return TRUE;
}

void CSelectSourceDlg::OnOK() 
{
	if(Source<=0 || Source >2) {
		MessageBox("Please select Instrument","Active system undefined!");
		return;
	}

	OnKillfocusUserID();
	if(m_UserID.GetLength() <= 0 || m_UserID.GetLength()>2) {
		MessageBox("Please Enter a 2 letter UserID","Error");
		return;
	}
	BOOL invalid = FALSE;
	int i; 
	char c;
	CString str;
	for(i=0; i<2; i++) {
		c = m_UserID.GetAt(i);
		if(c >= 'a' && c<='z') continue;
		if(c >= 'A' && c<='Z') continue;
		invalid = TRUE;
		if(invalid) {
			str.Format("Invalid character (%c) in UserID.\nPlease select a different UserID",c);
			MessageBox(str);
			return;
		}
	}

	CDialog::OnOK();
}


void CSelectSourceDlg::OnKillfocusUserID() 
{
	m_UserIDEdit.GetWindowText(m_UserID);	
}

void CSelectSourceDlg::OnHiresesiBtn() 
{
	Source = 2;	
	OnOK();
}

void CSelectSourceDlg::OnHiresmaldiBtn() 
{
	Source = 1;	
	OnOK();
}
