// SetDisplayRngDlg.cpp : implementation file
//
/*
SetDisplayRngDlg.cpp is the code that controls the CSetDisplayRng 
dialog box. This box allows the user to manually enter the x and y
extents to display in the current view.

*/
/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "BudaMaster.h"
#include "Buda.h"
#include "SetDisplayRngDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetDisplayRngDlg dialog


CSetDisplayRngDlg::CSetDisplayRngDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSetDisplayRngDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetDisplayRngDlg)
	m_Minx = 0.0;
	m_Maxx = 0.0;
	m_Miny = 0.0;
	m_Maxy = 0.0;
	m_Maxxstr = _T("");
	m_Maxystr = _T("");
	m_Minxstr = _T("");
	m_Minystr = _T("");
	//}}AFX_DATA_INIT
}

void CSetDisplayRngDlg::DoDataExchange(CDataExchange* pDX)
{
	switch (PlotType) {
	case TRANSIENT:
		m_Minxstr.Format("Minimum Time      :");
		m_Maxxstr.Format("Maximum Time      :");
		break;
	case FREQUENCY:
		m_Minxstr.Format("Minimum Frequency :");
		m_Maxxstr.Format("Maximum Frequency :");
		break;
	case MASSSPEC:
		m_Minxstr.Format("Minimum Mass      :");
		m_Maxxstr.Format("Maximum Mass      :");
		break;
	case TOTAL_ION_CHROMATOGRAM:
		m_Minxstr.Format("Minimum Time      :");
		m_Maxxstr.Format("Maximum Time      :");
		break;
	default:
		m_Minxstr.Format("Minimum Value     :");
		m_Maxxstr.Format("Maximum Value     :");
		break;
	}
	
	m_Minystr.Format("Minimum Intensity :");
	m_Maxystr.Format("Maximum Intensity :");

	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetDisplayRngDlg)
	DDX_Text(pDX, IDC_EDIT1, m_Minx);
	DDX_Text(pDX, IDC_EDIT2, m_Maxx);
	DDX_Text(pDX, IDC_EDIT3, m_Miny);
	DDX_Text(pDX, IDC_EDIT4, m_Maxy);
	DDX_Text(pDX, IDC_MAXX, m_Maxxstr);
	DDX_Text(pDX, IDC_MAXY, m_Maxystr);
	DDX_Text(pDX, IDC_MINX, m_Minxstr);
	DDX_Text(pDX, IDC_MINY, m_Minystr);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetDisplayRngDlg, CDialog)
	//{{AFX_MSG_MAP(CSetDisplayRngDlg)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetDisplayRngDlg message handlers
