// SetNewThreshold.cpp : implementation file
//
/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "stdafx.h"
#include "Buda.h"
#include "SetNewThreshold.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetNewThreshold dialog


CSetNewThreshold::CSetNewThreshold(CWnd* pParent /*=NULL*/)
	: CDialog(CSetNewThreshold::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetNewThreshold)
	m_NewThreshStr = _T("");
	m_ThreshStr = _T("");
	//}}AFX_DATA_INIT
}


void CSetNewThreshold::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetNewThreshold)
	DDX_Control(pDX, IDC_EDIT2, m_NewThreshEdit);
	DDX_Text(pDX, IDC_EDIT2, m_NewThreshStr);
	DDX_Text(pDX, IDC_THRESHOLDSTR, m_ThreshStr);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetNewThreshold, CDialog)
	//{{AFX_MSG_MAP(CSetNewThreshold)
	ON_EN_KILLFOCUS(IDC_EDIT2, OnKillfocusNewThresh)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetNewThreshold message handlers

void CSetNewThreshold::OnKillfocusNewThresh() 
{
	float data;
	UpdateData(TRUE);
	sscanf(m_NewThreshStr,"%f",&data);
	m_Thresh = data;
}

BOOL CSetNewThreshold::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_ThreshStr.Format("%1.2f",m_Thresh);
	m_NewThreshStr.Format("%1.2f",m_Thresh);
	m_NewThreshEdit.SetWindowText(m_NewThreshStr);
	UpdateData(FALSE);
	return TRUE;  
}
