// SetScaleFactorDlg.cpp : implementation file
//
/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "stdafx.h"
#include "Buda.h"
#include "SetScaleFactorDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetScaleFactorDlg dialog


CSetScaleFactorDlg::CSetScaleFactorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSetScaleFactorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetScaleFactorDlg)
	m_CurrScaleFactorStr = _T("");
	m_NewScaleFactorString = _T("");
	m_GlobScaleFactor = _T("");
	//}}AFX_DATA_INIT
}


void CSetScaleFactorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetScaleFactorDlg)
	DDX_Control(pDX, IDC_NEWSCALEFACTOR, m_NewScaleFactorEdit);
	DDX_Text(pDX, IDC_CURRENTSCALEFACTOR, m_CurrScaleFactorStr);
	DDX_Text(pDX, IDC_NEWSCALEFACTOR, m_NewScaleFactorString);
	DDX_Text(pDX, IDC_GLOBALSCALEFACTOR, m_GlobScaleFactor);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetScaleFactorDlg, CDialog)
	//{{AFX_MSG_MAP(CSetScaleFactorDlg)
	ON_EN_KILLFOCUS(IDC_NEWSCALEFACTOR, OnKillfocusNewscalefactor)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetScaleFactorDlg message handlers

BOOL CSetScaleFactorDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_GlobScaleFactor.Format("%1.2f",VScale);
	m_CurrScaleFactorStr.Format("%1.2f",ScaleFactor);
	OldScaleFactor = ScaleFactor;
	m_NewScaleFactorString.Format("%1.2f",ScaleFactor);

	UpdateData(FALSE);
	return TRUE;  
}

void CSetScaleFactorDlg::OnKillfocusNewscalefactor() 
{
	UpdateData(TRUE);
	sscanf(m_NewScaleFactorString,"%f",&ScaleFactor);
	if(ScaleFactor <= 0 || ScaleFactor >= 5000) {
		ScaleFactor = OldScaleFactor;
		MessageBox("Invalid Scalefactor","Invalid ScaleFactor");
	}
	m_NewScaleFactorString.Format("%1.2f",ScaleFactor);
	UpdateData(FALSE);
}
