/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_SETUPARBDLG_H__08326C20_7563_11D2_B907_9A0C6CABEF28__INCLUDED_)
#define AFX_SETUPARBDLG_H__08326C20_7563_11D2_B907_9A0C6CABEF28__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SetupARBDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSetupARBDlg dialog

class CSetupARBDlg : public CDialog
{
// Construction
public:
	int NewEvent;
	struct PSDesc GenPS[MAX_PS_EVENTS];
	struct ArbPacket Arb[MAX_ARB_TRIGGERS];
	BOOL CheckOverlappingEvents();
	void CleanupDialog();
	void InitEventData();
	int ListPtr;
	int Eventnum[MAX_PS_EVENTS];
	struct ArbPacket NullARB;
	struct PSDesc NullGenPS;
	int NumEvents;
	int Event;
	struct PS PS;
	CBudaDoc* pDoc;
	BOOL OnInitDialog();
	CSetupARBDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CSetupARBDlg)
	enum { IDD = IDD_SETUP_ARB_EVENTS };
	CButton	m_LinkChk;
	CListBox	m_EventListBox;
	double	m_Delay;
	double	m_Voltage;
	CString	m_TrapLinkStr;
	CString	m_StartTimeStr;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSetupARBDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CSetupARBDlg)
	afx_msg void OnEditArbwaveform();
	afx_msg void OnClearAllEvents();
	afx_msg void OnDeleteEvent();
	afx_msg void OnSelchangeEventlist();
	afx_msg void OnLinkExcite();
	afx_msg void OnAddEvent();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnKillfocusVoltage();
	afx_msg void OnKillfocusDelay();
	afx_msg void OnLinkChk();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SETUPARBDLG_H__08326C20_7563_11D2_B907_9A0C6CABEF28__INCLUDED_)
