/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_SETUPFFT_H__57000102_9D69_11D1_9106_44455354616F__INCLUDED_)
#define AFX_SETUPFFT_H__57000102_9D69_11D1_9106_44455354616F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// SetupFFT.h : header file
//
#include "BudaDoc.h"

/////////////////////////////////////////////////////////////////////////////
// CSetupFFT dialog

class CSetupFFT : public CPropertyPage
{
	DECLARE_DYNCREATE(CSetupFFT)

// Construction
public:
	BOOL CheckBigFFTs();
	void OnUpdate();
	void ValidateTruncateOffset();
	long TruncateTransient;
	void ValidateTruncatePoints();
	BOOL DataDirty;
	CBudaDoc* PDoc;
	CSetupFFT();
	~CSetupFFT();

// Dialog Data
	//{{AFX_DATA(CSetupFFT)
	enum { IDD = IDD_FFTOPTIONS };
	CEdit	m_NZFEdit;
	CButton	m_TruncBtn;
	CEdit	m_TruncPtsBox;
	CEdit	m_TruncOffBox;
	CComboBox	m_ApodComboBox;
	int		m_apodfunc;
	BOOL	m_IsPeakPicking;
	BOOL	m_AutoCalcCS;
	int		m_NumZeroFills;
	long	m_TruncatePoints;
	long	m_TruncateOffset;
	CString	m_FFTSize;
	CString	m_NDP;
	CString	m_SpecPts;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CSetupFFT)
	public:
	virtual BOOL OnKillActive();
	virtual BOOL OnSetActive();
	virtual void OnOK();
	virtual BOOL OnApply();
	virtual BOOL OnQueryCancel();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CSetupFFT)
	afx_msg void OnUpdateNumzerofills();
	afx_msg void OnSelchangeApodcombo();
	afx_msg void OnPeakpick();
	afx_msg void OnAutoCalcCS();
	afx_msg void OnTruncate();
	afx_msg void OnUpdateTruncateOffset();
	afx_msg void OnUpdateTruncatePoints();
	afx_msg void OnChangeNumzerofills();
	afx_msg void OnKillfocusNumzerofills();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SETUPFFT_H__57000102_9D69_11D1_9106_44455354616F__INCLUDED_)
