/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_SETUPQUADDLG_H__08326C22_7563_11D2_B907_9A0C6CABEF28__INCLUDED_)
#define AFX_SETUPQUADDLG_H__08326C22_7563_11D2_B907_9A0C6CABEF28__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SetupQuadDlg.h : header file
//

struct QuadEventData {
	int Channel;
	struct ChirpPacket* pcfp;
	int Eventnum;
};

/////////////////////////////////////////////////////////////////////////////
// CSetupQuadDlg dialog

class CSetupQuadDlg : public CDialog
{
// Construction
public:
	BOOL CheckOverlappingEvents();
	struct PSDesc NullGenPS;
	struct ChirpPacket NullCFP;
	int NumEvents;
	void CleanupDialog();
	void SelectEventData();
	int ListPtr;
	struct QuadEventData* EventData;
	int Event;
	int* EventList;
	void InitEventData();
	struct PS PS;
	CBudaDoc* pDoc;
	BOOL OnInitDialog();
	CSetupQuadDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CSetupQuadDlg)
	enum { IDD = IDD_SETUP_QUADRF_EVENTS };
	CButton	m_LinkChk;
	CListBox	m_EventListBox;
	double	m_Voltage;
	double	m_Duration;
	double	m_Delay;
	double	m_Frequency;
	CString	m_TrapLinkStr;
	CString	m_StartTimeStr;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSetupQuadDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CSetupQuadDlg)
	afx_msg void OnAddEvent();
	afx_msg void OnClearAllEvents();
	afx_msg void OnDeleteEvent();
	afx_msg void OnSelchangeEventlist();
	afx_msg void OnChangeVoltage();
	afx_msg void OnChangeFrequency();
	afx_msg void OnChangeDuration();
	afx_msg void OnChangeDelay();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnLinkChk();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SETUPQUADDLG_H__08326C22_7563_11D2_B907_9A0C6CABEF28__INCLUDED_)
