/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_SETUPSYNDLG_H__6C6C5300_5DE8_11D2_B907_9E81BA4C2427__INCLUDED_)
#define AFX_SETUPSYNDLG_H__6C6C5300_5DE8_11D2_B907_9E81BA4C2427__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SetupSYNDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSetupSYNDlg dialog

class CSetupSYNDlg : public CDialog
{
// Construction
public:
	int NewEvent;
	double m_Frequency;
	BOOL CheckOverlappingEvents();
	struct PSDesc NullGenPS;
	struct ChirpPacket NullCFP;
	void CleanupDialog();
	int NumEvents;
	int ListPtr;
	struct EventData* EventData;
	int Event;
	void InitEventData();
	void SelectEventData();
	struct PS PS;
	CBudaDoc* pDoc;
	BOOL OnInitDialog();
	CSetupSYNDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CSetupSYNDlg)
	enum { IDD = IDD_SETUP_SYNTHESIZER_DLG };
	CEdit	m_VoltageEdit;
	CEdit	m_DurationEdit;
	CEdit	m_DelayEdit;
	CButton	m_LinkChk;
	CEdit	m_HighMassEdit;
	CEdit	m_LowMassEdit;
	CButton	m_FreqBurstBtn;
	CButton	m_FreqSweepBtn;
	CListBox	m_EventListBox;
	float	m_Delay;
	float	m_Duration;
	double	m_HighMass;
	double	m_LowMass;
	float	m_Voltage;
	CString	m_StartTimeStr;
	CString	m_TrapLinkStr;
	CString	m_FreqStr;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSetupSYNDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CSetupSYNDlg)
	afx_msg void OnFrequencyburst();
	afx_msg void OnFrequencysweep();
	afx_msg void OnSelchangeEventlist();
	afx_msg void OnChangeLowmass();
	afx_msg void OnChangeVoltage();
	afx_msg void OnChangeHighmass();
	afx_msg void OnChangeDuration();
	afx_msg void OnChangeDelay();
	afx_msg void OnDeleteEvent();
	afx_msg void OnClearAllEvents();
	afx_msg void OnAddEvent();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnLinkChk();
	afx_msg void OnKillfocusDelay();
	afx_msg void OnKillfocusDuration();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SETUPSYNDLG_H__6C6C5300_5DE8_11D2_B907_9E81BA4C2427__INCLUDED_)
