/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_SETUPTTLDLG_H__6C6C5301_5DE8_11D2_B907_9E81BA4C2427__INCLUDED_)
#define AFX_SETUPTTLDLG_H__6C6C5301_5DE8_11D2_B907_9E81BA4C2427__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SetupTTLDlg.h : header file
//

//	StartFlags definitions
#define ADD_NEW_EVENT 1
#define STANDARD_STARTUP 0

/////////////////////////////////////////////////////////////////////////////
// CSetupTTLDlg dialog

class CSetupTTLDlg : public CDialog
{
// Construction
public:
	int StartFlags;
	struct PS PS;
	int eventnum;
	int EventList[MAX_PS_EVENTS];
	CBudaDoc* pDoc;
	struct PS* pPS;
	int Channel;
	void SetupEventListBox();
	void InitEventInfo();
	int CurrentEvent;
	void OnUpdate();
	BOOL OnInitDialog();
	CSetupTTLDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CSetupTTLDlg)
	enum { IDD = IDD_SETUP_TTL_DLG };
	CButton	m_LinkChk;
	CListBox	m_EventList;
	CString	m_TTLName;
	float	m_Duration;
	float	m_Delay;
	CEdit	m_DurationEdit;
	CEdit	m_DelayEdit;
	CString	m_StartTimeStr;
	CString	m_TrapLinkStr;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSetupTTLDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CSetupTTLDlg)
	afx_msg void OnChangeDelay();
	afx_msg void OnChangeDuration();
	afx_msg void OnSelchangeEventlist();
	virtual void OnOK();
	afx_msg void OnAddEvent();
	afx_msg void OnClearAllEvents();
	afx_msg void OnDeleteEvent();
	afx_msg void OnLinkChk();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SETUPTTLDLG_H__6C6C5301_5DE8_11D2_B907_9E81BA4C2427__INCLUDED_)
