/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#if !defined(AFX_SETUPVIEW_H__011A1580_5A17_11D2_B907_F10EC9428B73__INCLUDED_)
#define AFX_SETUPVIEW_H__011A1580_5A17_11D2_B907_F10EC9428B73__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SetupView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSetupView view
#define CENTER_JUSTIFIED 0
#define LEFT_JUSTIFIED 1
#define CENTER_JUSTIFIED2 2

class CSetupView : public CView
{
protected:
	CSetupView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CSetupView)

// Attributes
public:

// Operations
public:
	void OnEditImpulse();
	void OnEditArb();
	void OnEditQuad();
	CMenu SetupMenu;
	void UpdateMenu();
	void OnEditDetect();
	void OnEditExcite();
	void OnEditDAC(int);
	void OnEditTTL(int);
	void OnEditDAC();
	void OnEditTTL();
	void OnEditQuadRF();
	int* ChannelIndices;
	CRect* PlotChArea;
	int AxisLineYpos;
	void PlotTransient(CRect);
	void PlotSynthesizer(int*,int,CRect);
	void Box(CPoint,CPoint);
	struct sys* pSys;
	CInstrument* pInstrument;
	CRect PlotArea;
	struct PSDesc* pGenPS;
	void DrawChannel(int,CRect);
	int TimeToPos(double);
	BOOL PlotChannels[40];
	int NumPlotChannels;
	double TimeEnd;
	double TimeStart;
	void Text(CString,CPoint,int);
	CDC* pDC;
	void MoveTo(int, int);
	void MoveTo(CPoint);
	void LineTo(int, int);
	void LineTo(CPoint);
	void LabelChannels();
	void DrawChannels();
	void DrawTimeAxis();
	CPoint PTtoViewPT(CPoint);
	CPoint PTtoViewPT(int,int);
	CRect ViewSize;
	CBudaDoc* pDoc;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSetupView)
	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CSetupView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(CSetupView)
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnAdddac();
	afx_msg void OnAddttl();
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SETUPVIEW_H__011A1580_5A17_11D2_B907_F10EC9428B73__INCLUDED_)
