// SplashWnd.cpp : implementation file
//
/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#include "BudaMaster.h"
#include "Buda.h"
#include "SplashWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSplashWnd dialog


CSplashWnd::CSplashWnd(CWnd* pParent /*=NULL*/)
	: CDialog(CSplashWnd::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSplashWnd)
	m_VersionString = _T("");
	//}}AFX_DATA_INIT
}


void CSplashWnd::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSplashWnd)
	DDX_Control(pDX, IDC_ACCEPT_BTN, m_AcceptBtn);
	DDX_Text(pDX, IDS_SPLASH_VERSION_STRING, m_VersionString);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSplashWnd, CDialog)
	//{{AFX_MSG_MAP(CSplashWnd)
	ON_BN_CLICKED(IDC_ACCEPT_BTN, OnAcceptBtn)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_DECLINE_BTN, OnDeclineBtn)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSplashWnd message handlers

BOOL CSplashWnd::OnInitDialog()
{
	CDialog::OnInitDialog();
	//pInst->ThreadInfo.m_hwndNotifyDiagDataUpdated = this->m_hWnd;
	CenterWindow();
	Accept = FALSE;
	//m_DiagReportText = "";
	//m_DiagReport.SetWindowText(m_DiagReportText);

	// open and load current CalibrantFileName
	//CString FileName,progdir;
	//progdir = *((CBudaApp*)AfxGetApp())->ProgramDirectory;

	//FileName = "License.txt";
	//CString line,errorstr;
	//BOOL test;
	//CFile f;

	//test = TRUE;
	// load "C:\\Buda\\License.txt"
	//test = f.Open(FileName,  CFile::modeRead, NULL);
	//if (!test) {
	//	errorstr.Format("Couldn't open License Agreement file: \n %s",FileName);
	//	MessageBox(errorstr,"File Error");
	//	return FALSE;
	//}

	//CArchive ar(&f,CArchive::load,4096,NULL);

	//LicenseString = "";
	//while(ar.ReadString(line)) {
	//	LicenseString = LicenseString + "\r\n" + line;
	//}

	//m_LicenseBox.SetWindowText(LicenseString);
	
	/*m_AcceptBtn.EnableWindow(FALSE);

	m_DiagReportText = "Initializing Instrument and running startup diagnostics.\r\n";
	m_DiagReport.SetWindowText(m_DiagReportText);
	PSG = TRUE;
	VSP = FALSE;
	FSP = FALSE;
	ARB = FALSE;
	TD = FALSE;
	Concl = FALSE;*/

	return TRUE;
}

void CSplashWnd::OnAcceptBtn() 
{
	Accept = TRUE;
	OnOK();
}

void CSplashWnd::OnClose() 
{
	if(!Accept) return;
	CDialog::OnClose();
}

/*void CSplashWnd::OnDiagDataUpdated()
{
	CString crlf = "\r\n";
	CHARFORMAT oldformat,redformat,greenformat;
	COLORREF red = 0x000000ff;
	COLORREF green = 0x0000ff00;

	m_DiagReport.GetDefaultCharFormat(oldformat);

	redformat = oldformat;
	redformat.dwMask = CFM_COLOR;
	redformat.dwEffects = 0;
	redformat.dwEffects |= CFE_BOLD;
	//redformat.dwEffects ^= CFE_AUTOCOLOR;
	redformat.crTextColor = red;

	greenformat = oldformat;
	greenformat.dwMask = CFM_COLOR;
	greenformat.dwEffects |= CFE_BOLD;
	greenformat.dwEffects ^= CFE_AUTOCOLOR;
	greenformat.crTextColor = green;
	//long selbegin, selend;
	//CString str;

	if(PSG) {
		m_DiagReportText += "Testing Pulse Sequence Generator (PSG) ... \t\t";
		m_DiagReport.SetWindowText(m_DiagReportText);
		//selbegin = m_DiagReportText.GetLength();
		if(pInst->PSG_Tested) {
			if(pInst->PSG_Passed) {
				//m_DiagReport.SetDefaultCharFormat(greenformat);
				m_DiagReportText += "Passed." + crlf;
				//selend = m_DiagReportText.GetLength();
				//m_DiagReport.SetSel(selbegin,selend);
				//str = m_DiagReport.GetSelText();
				m_DiagReport.SetSelectionCharFormat(greenformat);
			} else {
				//m_DiagReport.SetDefaultCharFormat(redformat);
				m_DiagReportText += "FAILED!" + crlf;
				//selend = m_DiagReportText.GetLength();
				//m_DiagReport.SetSel(selbegin,selend);
				//str = m_DiagReport.GetSelText();
				//m_DiagReport.GetSel(selbegin,selend);
				m_DiagReport.SetSelectionCharFormat(redformat);
			}
			m_DiagReport.SetDefaultCharFormat(redformat);
			m_DiagReport.SetWindowText(m_DiagReportText);
			PSG = FALSE;
			VSP = TRUE;
		}
		return;
	}

	if(VSP) {
		m_DiagReportText += "Testing Voltage Sequence Programmer (VSP) ... \t\t";
		m_DiagReport.SetWindowText(m_DiagReportText);
		if(pInst->VSP_Tested) {
			if(pInst->VSP_Passed) m_DiagReportText += "Passed." + crlf;
			else m_DiagReportText += "FAILED!" + crlf;
			m_DiagReport.SetWindowText(m_DiagReportText);
			VSP = FALSE;
			FSP = TRUE;
		}
		return;
	}

	if(FSP) {
		m_DiagReportText += "Testing Frequency Synthesizer Programmer (FSP) ... \t";
		m_DiagReport.SetWindowText(m_DiagReportText);
		if(pInst->FSP_Tested) {
			if(pInst->FSP_Passed) m_DiagReportText += "Passed." + crlf;
			else m_DiagReportText += "FAILED!" + crlf;
			m_DiagReport.SetWindowText(m_DiagReportText);
			FSP = FALSE;
			ARB = TRUE;
		}
		return;
	}

	if(ARB) {
		m_DiagReportText += "Testing Arbitrary Waveform Generator (ARB) ... \t\t";
		m_DiagReport.SetWindowText(m_DiagReportText);
		if(pInst->ARB_Tested) {
			if(pInst->ARB_Passed) m_DiagReportText += "Passed." + crlf;
			else m_DiagReportText += "FAILED!" + crlf;
			m_DiagReport.SetWindowText(m_DiagReportText);
			ARB = FALSE;
			TD = TRUE;
		}
		return;
	}

	if(TD) {
		m_DiagReportText += "Testing Transient Digitizer (TD) ... \t\t\t";
		m_DiagReport.SetWindowText(m_DiagReportText);
		if(pInst->TD_Tested) {
			if(pInst->TD_Passed) m_DiagReportText += "Passed." + crlf;
			else m_DiagReportText += "FAILED!" + crlf;
			m_DiagReport.SetWindowText(m_DiagReportText);
			TD = FALSE;
			Concl = TRUE;
		} else {
			return;
		}
	} 
	
	if(Concl) {
		if(!pInst->PSG_Passed && !pInst->VSP_Passed && !pInst->FSP_Passed && !pInst->ARB_Passed && !pInst->TD_Passed) {
			m_DiagReportText += crlf+"*** Instrument Diagnostics Failed *** " + crlf;
			m_DiagReportText += "Starting in Analysis-Only Mode" + crlf;
			m_DiagReport.SetWindowText(m_DiagReportText);
			m_DiagReport.SetBackgroundColor(FALSE,0x000000FF);
		} else {
			m_DiagReportText += "Diagnostics Passed - Instrument initialized" + crlf;
			m_DiagReport.SetWindowText(m_DiagReportText);
			m_DiagReport.SetBackgroundColor(FALSE,0x0000FF00);
		}
		Concl = FALSE;
	}

	m_AcceptBtn.EnableWindow(TRUE);
	m_AcceptBtn.SetFocus();
	SetDefID(IDC_ACCEPT_BTN);
}
*/

void CSplashWnd::OnDeclineBtn() 
{
	Accept = FALSE;
	OnOK();
}
