/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
// StatusControl.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CStatusControl window
#if !defined(STATUSCONTROL_H)
#define STATUSCONTROL_H

#include "stdafx.h"
#include <afxcview.h>
#include <afxext.h>
#include "StatusBar.h"

class CStatusControl : public CWnd
{
// Construction
public:
        friend class CStatusEdit;
	friend class CStatusProgress;
	friend class CStatusStatic;
	friend class CStatusCombo;
	CStatusControl();
	BOOL Create(LPCTSTR classname, CStatusBar * parent, UINT id, DWORD style);

// Attributes
public:

// Operations
public:
	void Reposition();
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CStatusIcon)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CStatusControl();

	// Generated message map functions
protected:
	static void reposition(CWnd * wnd);
	static BOOL setup(CStatusBar * parent, UINT id, CRect & r);
	//{{AFX_MSG(CStatusControl)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

#endif	//#if !defined(STATUSCONTROL_H)

/////////////////////////////////////////////////////////////////////////////
