// TimingDialog.cpp : implementation file
//
/****************************************************************

Boston University data analysis (BUDA) package 

Description: Buda is a data analysis program for Fourier 
Transform Mass Spectrometry data.  

by Peter B. O'Connor

    Copyright (C) 2000  Peter B. O'Connor

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#include "BudaMaster.h"
#include "Buda.h"
#include "BudaDoc.h"
#include "TimingDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTimingDialog dialog


CTimingDialog::CTimingDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CTimingDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTimingDialog)
	m_durationstring = _T("");
	m_PtsString = _T("");
	//}}AFX_DATA_INIT
}


void CTimingDialog::DoDataExchange(CDataExchange* pDX)
{
	m_durationstring.Format("FFT took %2.2f seconds",duration);
	m_PtsString.Format("Number of Data Points = %u",2*numpts);
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTimingDialog)
	DDX_Text(pDX, IDC_Text_FFTDuration, m_durationstring);
	DDV_MaxChars(pDX, m_durationstring, 200);
	DDX_Text(pDX, IDC_Text_NumberDataPts, m_PtsString);
	DDV_MaxChars(pDX, m_PtsString, 200);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTimingDialog, CDialog)
	//{{AFX_MSG_MAP(CTimingDialog)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTimingDialog message handlers
