void CBudaApp::OnExportToDataExplorer() 
{
	// first get the document associated with the current active view
	// then create a new frame and view associated with it using the
	// m_pTextViewTemplate document template;
	CDocument* curdoc;
	CFrameWnd* frame;
	CWnd* activewnd;

	activewnd=m_pMainWnd->GetFocus();
	m_pCurrentActiveView = (CBudaView *)activewnd;
	frame = activewnd->GetParentFrame();
	if(frame == NULL) return;
	curdoc = frame->GetActiveDocument();
	if(curdoc == NULL) return;
	
	// no "view-as-text" for setup views
	if (m_pCurrentActiveView->IsKindOf(RUNTIME_CLASS( CSetupView ) ) ) {
		m_pCurrentActiveView->MessageBox("Cannot view Setup as text","Error");
		return;
	}

	// no "view-as-text" for MI tables - they already are text
	if (m_pCurrentActiveView->IsKindOf(RUNTIME_CLASS( CMITableView ) ) ) {
		m_pCurrentActiveView->MessageBox("Operator Error : MITable is already a text view","Operator Error : Replace Operator");
		return;
	}

	// before creating the frame and view and all, check the number of 
	// data points that are to be displayed.  If it is > MAX_PTS_IN_TEXTVIEW,
	// ask before displaying them, and cancel if the user says no.
	CBudaView* vw = (CBudaView*)m_pCurrentActiveView;

	if (vw->PlotType == MASSSPEC) {
		float minx, maxx;
		minx=vw->zoomstack[vw->zoompointer].minx;
		maxx=vw->zoomstack[vw->zoompointer].maxx;

		long minxpt, maxxpt;
		minxpt = vw->pDoc->MassToPt(minx);
		maxxpt = vw->pDoc->MassToPt(maxx);

		double mass, intensity;


// ------------------------------------------------------
//		here starts the DataExporer export code
//-------------------------------------------------------

		FILE *fw;
		CString str;
//		max number of datapoints that DE can take is about 150000
		int increment = abs(maxxpt-minxpt)/150000;
		if (increment < 1 ) {
			increment = 1;
		}

//		simple C code that dumps data points directly to a file
//		works faster than using a buffer and much faster than using C++
//		that's why it's here

//		char *buffer;
//		buffer = (char*) malloc(1000*sizeof(char));
//		buffer[0] = '\0';
		
		if ((fw = fopen("c:\\Buda\\Buda2DE.txt", "w")) != NULL) {
			fprintf(fw, "TITLE \"FT MS spectrum\"\n");
			fprintf(fw, "TYPE MASSSPEC\n");

			for (long i=minxpt; i>maxxpt; i=i-increment) {
				mass = vw->pDoc->PtToMass(i);
				// multiply intensity by 100 to get reasonable values
				intensity = 100 * (vw->pDoc->FreqArray[i]);
				fprintf(fw,"%5.4f \t %2.2f\n", mass, intensity);
			}
			if (fclose(fw) != EOF){
				str = ("Data exported to c:\\Buda\\Buda2DE.txt");
				vw->MessageBox(str,"Export finished", MB_OK );
			}
		} else {
				str = ("Error in export");
				vw->MessageBox(str,"Export failed", MB_OK );
		}
//		free((void*)buffer);

	}

}
