// DACCtrlDlgDlg.h : header file
//

#if !defined(AFX_DACCTRLDLGDLG_H__C51EE193_F8D4_4775_99AF_B2C85BEC41CA__INCLUDED_)
#define AFX_DACCTRLDLGDLG_H__C51EE193_F8D4_4775_99AF_B2C85BEC41CA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "resource.h"
#include "BudaMaster.h"
#include "DAC_Master.h"
//#include "EventStruct.h"
//#include "DAC_Parameters_Struct.h"

/////////////////////////////////////////////////////////////////////////////
// CDACCtrlDlg dialog

class CDACCtrlDlg : public CDialog
{
// Construction
public:
	int ChannelEventIndex[MAX_NUM_DACS];
	double Wfm[MAX_NUM_DACS][1000];
	struct PB_Pattern* TrigPattern;
	void DumpWfms();
	void DumpTrigPattern();
	void CreateChannelWfms();
	void CreatePBTriggerPatterns();
	void ExpandEvents();
	void SortEvents();
	void ClearCheck(int channel);
	void SetCheck(int channel);
	void SetChecks();
	double GetDACValueAtTime(int Channel, double time);
	int IsDACChangingAtTime(int Channel, double time);
	void OnUpdate();
	void UpdateDACInfo();
	void SetupDAC(int Channel);
	void SetEventList();
	long NumEvents;
	void GetDefaultEventTableParms();
	long CurrentEvent;
	CString EventTableFile;
	void GetDefaultDACParms();
	int WriteIniFile();
	CString DACIniFileName;
	CString ProgramDirectory;
	EventStruct Events[MAX_NUM_EVENTS];
	DAC_Parameters_Struct DACParms[MAX_NUM_DACS];
	void CreateInitialDACEventTable();
	void SetDACValues();
	int LoadDACEventTable();
	int ReadDACIniFile();
	CString GetIniString(CFile *file, CString ValueStr, CString defaultvalue);
	CString GetRightString(CString str);
	CString CompressString(CString str);
	int FindEqualSign(CString str);
	void WriteIniInt(CArchive *ar, CString ValueStr, int value);
	void WriteIniString(CArchive *ar, CString ValueStr, CString value);
	int GetIniInt(CFile* file,CString str, int defaultvalue);
	double GetIniFloat(CFile *file, CString valuestr, double defaultvalue);
	void WriteIniFloat(CArchive *ar, CString ValueStr, double value);
	CDACCtrlDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CDACCtrlDlg)
	enum { IDD = IDD_DACCTRL_DIALOG };
	CComboBox	m_LoopList;
	CListBox	m_EventList;
	CButton	m_VoltageCheck9;
	CButton	m_VoltageCheck8;
	CButton	m_VoltageCheck7;
	CButton	m_VoltageCheck6;
	CButton	m_VoltageCheck5;
	CButton	m_VoltageCheck4;
	CButton	m_VoltageCheck3;
	CButton	m_VoltageCheck24;
	CButton	m_VoltageCheck23;
	CButton	m_VoltageCheck22;
	CButton	m_VoltageCheck21;
	CButton	m_VoltageCheck20;
	CButton	m_VoltageCheck2;
	CButton	m_VoltageCheck19;
	CButton	m_VoltageCheck18;
	CButton	m_VoltageCheck17;
	CButton	m_VoltageCheck16;
	CButton	m_VoltageCheck15;
	CButton	m_VoltageCheck14;
	CButton	m_VoltageCheck13;
	CButton	m_VoltageCheck12;
	CButton	m_VoltageCheck11;
	CButton	m_VoltageCheck10;
	CButton	m_VoltageCheck1;
	CString	m_VoltageValue1;
	CString	m_VoltageValue10;
	CString	m_VoltageValue11;
	CString	m_VoltageValue12;
	CString	m_VoltageValue13;
	CString	m_VoltageValue14;
	CString	m_VoltageValue15;
	CString	m_VoltageValue16;
	CString	m_VoltageValue17;
	CString	m_VoltageValue18;
	CString	m_VoltageValue19;
	CString	m_VoltageValue2;
	CString	m_VoltageValue20;
	CString	m_VoltageValue21;
	CString	m_VoltageValue22;
	CString	m_VoltageValue23;
	CString	m_VoltageValue24;
	CString	m_VoltageValue3;
	CString	m_VoltageValue4;
	CString	m_VoltageValue5;
	CString	m_VoltageValue6;
	CString	m_VoltageValue7;
	CString	m_VoltageValue8;
	CString	m_VoltageValue9;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDACCtrlDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CDACCtrlDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnVoltagecheck1();
	afx_msg void OnVoltagecheck10();
	afx_msg void OnVoltagecheck11();
	afx_msg void OnVoltagecheck12();
	afx_msg void OnVoltagecheck13();
	afx_msg void OnVoltagecheck14();
	afx_msg void OnVoltagecheck15();
	afx_msg void OnVoltagecheck16();
	afx_msg void OnVoltagecheck17();
	afx_msg void OnVoltagecheck18();
	afx_msg void OnVoltagecheck19();
	afx_msg void OnVoltagecheck2();
	afx_msg void OnVoltagecheck20();
	afx_msg void OnVoltagecheck21();
	afx_msg void OnVoltagecheck22();
	afx_msg void OnVoltagecheck23();
	afx_msg void OnVoltagecheck24();
	afx_msg void OnVoltagecheck3();
	afx_msg void OnVoltagecheck4();
	afx_msg void OnVoltagecheck5();
	afx_msg void OnVoltagecheck6();
	afx_msg void OnVoltagecheck7();
	afx_msg void OnVoltagecheck8();
	afx_msg void OnVoltagecheck9();
	afx_msg void OnSelchangeEventTableList();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DACCTRLDLGDLG_H__C51EE193_F8D4_4775_99AF_B2C85BEC41CA__INCLUDED_)
