// Export.cpp : implementation file
//

#include "stdafx.h"
#include "buda.h"
#include "MascotExportDialog.h"
#include "BudaView.h"
#include "BudaDoc.h"
#include "ExportDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExportDlg dialog


CExportDlg::CExportDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExportDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExportDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CExportDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExportDlg)
	DDX_Control(pDX, IDC_MITableText, m_MITableTextButton);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CExportDlg, CDialog)
	//{{AFX_MSG_MAP(CExportDlg)
	ON_BN_CLICKED(IDC_MITableText, OnMITableTextBtnClick)
	ON_BN_CLICKED(IDC_ExportMascotBtn, OnExportMascotBtn)
	ON_BN_CLICKED(IDC_ExportDataExplorer, OnExportDataExplorer)
	ON_BN_CLICKED(IDC_ExportTransientasText, OnExportTransientasText)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExportDlg message handlers

void CExportDlg::OnMITableTextBtnClick() 
{
	int i;
	BOOL test;
	CString errorstr;
	CString filestr = "File Open Error";
	int retval;
	CString str;
	CString crlf="\r\n";

	// use the CFileDialog to get the name of the file
	CFile MIfile;
	CFileDialog *dlg;
	dlg = new CFileDialog(TRUE,"*.*","BudaMIFile.txt",OFN_HIDEREADONLY | OFN_LONGNAMES,"*.cal",NULL);
	dlg->m_ofn.lpstrFilter = "All Files (*.*)\0*.*\0";

	retval = dlg->DoModal();
	CString pathname = dlg->GetPathName();
	delete dlg;
	if (retval == IDCANCEL) return;

	// ok, try open the file and then dump to it
	test = MIfile.Open(pathname,  CFile::modeWrite | CFile::modeCreate, NULL);
	if (!test) {
		errorstr.Format("Couldn't open Calibration file \n %s",pathname);
		MessageBox(errorstr,filestr);
	}

	CArchive ar(&MIfile,CArchive::store,4096,NULL);

	//pStr = LPCTSTR(str);

	// ok now lets make the text and export it.
	float mass,freq,amp,rel,res,mass2;
	int cs;
	CString massstr,freqstr,ampstr,relstr,resstr,csstr,mass2str;

	// first get the scale factor to set the highest peak = 100.00%
	double scale;
	scale = 0.0;
	for(i=0; i<pDoc->PS.Spec[pDoc->CurrentSpectrumFocus].NumPeaks;i++) {
		// find highest peak
		if(scale<pDoc->FITable[i].I) scale = pDoc->FITable[i].I;
	}

	// then create string
	str="Mass/Intensity Table for ";
	str+=pDoc->PS.DataFileName;
	str+=crlf;
	ar.Write(str,str.GetLength());

	str="Memo: ";
	str+=pDoc->PS.ExperimentMemo;
	str+=crlf;
	ar.Write(str,str.GetLength());

	str.Format("Spectrum %d of %d                     Accumulated Scans: %d ",1+pDoc->CurrentSpectrumFocus, pDoc->PS.SpectraAcquired,pDoc->PS.ScansPerSpectrum);
	//str=     "-----------    -----------    ----------     ----------    ----------";
	str+=crlf;
	ar.Write(str,str.GetLength());

	str.Format("Threshold = %1.2f = %1.2f%%         ",pDoc->PS.Spec[pDoc->CurrentSpectrumFocus].NoiseLevel, pDoc->PS.Spec[pDoc->CurrentSpectrumFocus].NoiseLevel*100.0/scale);
	//str=     "-----------    -----------    ----------     ----------    ----------";
	str+=pDoc->PS.TimeAcquired;
	str+=crlf;
	ar.Write(str,str.GetLength());

	str.Format("Corrected Total Ion Intensity = %1.3f",pDoc->PS.Spec[pDoc->CurrentSpectrumFocus].TotalIonInt);
	str += crlf;
	ar.Write(str,str.GetLength());

	str.Format("Number of peaks found = %d",pDoc->PS.Spec[pDoc->CurrentSpectrumFocus].NumPeaks);
	str += crlf;
	ar.Write(str,str.GetLength());

	str = crlf;
	ar.Write(str,str.GetLength());

	str="   M/z        Frequency     Abs.Int.   Rel.Int.    Res.";
	if(pDoc->sys->AutoLabelCharge) {
		str+="     Charge     Mass";
	}
	str+=crlf;
	ar.Write(str,str.GetLength());

	str="---------------------------------------------------------";
	if(pDoc->sys->AutoLabelCharge) {
		str+="--------------------";
	}
	str+=crlf;
	ar.Write(str,str.GetLength());

	//if(!pDoc->IsPeakPicked) {
	//	pDoc->EstimateNoiseLevel(pDoc->FreqArray,&(pDoc->NoiseLevel));
	//	pDoc->PeakPick();
	//}

	for(i=0;i<pDoc->PS.Spec[pDoc->CurrentSpectrumFocus].NumPeaks;i++) {
		freq=(float)pDoc->PS.Spec[pDoc->CurrentSpectrumFocus].FITable[i].F;
		mass=(float)pDoc->FreqToMass(freq, pDoc->PS.A, pDoc->PS.B);
		amp=(float)pDoc->PS.Spec[pDoc->CurrentSpectrumFocus].FITable[i].I;
		rel=(float)(double(amp)*100.0/scale);
		res=(float)pDoc->PS.Spec[pDoc->CurrentSpectrumFocus].FITable[i].RP;
		cs = (int)pDoc->PS.Spec[pDoc->CurrentSpectrumFocus].FITable[i].CS;
		// mass not mz assume protons as charge carriers
		mass2 = (mass*cs) - float(1.00728*cs);

		massstr.Format("%5.5f",mass);
		freqstr.Format("%6.3f",freq);
		ampstr.Format("%3.3f",amp);
		relstr.Format("%3.2f",rel);
		resstr.Format("%5.0f",res);
		csstr.Format("%d",cs);
		if(pDoc->TrapVoltsOnDetect>=0) csstr="+"+csstr;
		mass2str.Format("%5.3f",mass2);

		while(massstr.GetLength()<10) massstr = " "+massstr;
		while(freqstr.GetLength()<10) freqstr = " "+freqstr;
		while(ampstr.GetLength()<8) ampstr = " "+ampstr;
		while(relstr.GetLength()<6) relstr = " "+relstr;
		if (res>0) {
			while(resstr.GetLength()<7) resstr = " "+resstr;
		} else {
			resstr = "  ---  ";
		}

		str=massstr+"   "+freqstr+"   "+ampstr+"    "+relstr+"    "+resstr;
		if(pDoc->sys->AutoLabelCharge) {
			str+="       "+csstr+"      "+mass2str;
		}
		str+=crlf;
		ar.Write(str,str.GetLength());
	}
	ar.Close();
}

void CExportDlg::OnExportMascotBtn() 
{

/*	

function :CExportDlg::OnExportMascotBtn()
By: Peter B. O'Connor

This function exports the Mass-Intensity table in a 
format that is readable by the web-based MASCOT database
search engine.  	

This function has been added to allow automatic database
searching using ECD fragment ions as was first postulated
by Dr. Nancy Leymarie and worked out by her in collaboration
with Matrix Science

*/

	int i;
	BOOL test;
	CString errorstr;
	CString filestr = "File Open Error";
	int retval;
	CString str;
	CString crlf="\r\n";

	// use the CFileDialog to get the name of the file
	CFile MIfile;
	CFileDialog *dlg;
	dlg = new CFileDialog(TRUE,"*.*","BudaMascotFile.txt",OFN_HIDEREADONLY | OFN_LONGNAMES,"*.cal",NULL);
	dlg->m_ofn.lpstrFilter = "All Files (*.*)\0*.*\0";

	retval = dlg->DoModal();
	CString pathname = dlg->GetPathName();
	delete dlg;
	if (retval == IDCANCEL) return;

	// ok, try open the file and then dump to it
	test = MIfile.Open(pathname,  CFile::modeWrite | CFile::modeCreate, NULL);
	if (!test) {
		errorstr.Format("Couldn't open Calibration file \n %s",pathname);
		MessageBox(errorstr,filestr);
	}

	CArchive ar(&MIfile,CArchive::store,4096,NULL);

	// now pull up the mascot export dialog box and 
	// get the information to fill in the mascot header
	CMascotExportDialog MascotDlg;
	MascotDlg.m_ChargeState = 3;
	MascotDlg.m_Comment = "Pete's Most Excellent MASCOT Exporter!!!";
	MascotDlg.m_PrecursorIonName = "Ubiquitin";
	MascotDlg.m_PrecursorMass = 8565.64;
	MascotDlg.m_UserEmailAddress = "Picard@Enterprise.gov";
	MascotDlg.m_Username = "Jean-Luc Picard";
	if(MascotDlg.DoModal() == IDCANCEL) return;


	// ok now lets make the text and export it.
	float freq,mass,rel,amp;
	CString massstr,relstr;

	// first get the scale factor to set the highest peak = 100.00%
	double scale;
	scale = 0.0;
	for(i=0; i<pDoc->PS.Spec[pDoc->CurrentSpectrumFocus].NumPeaks;i++) {
		// find highest peak
		if(scale<pDoc->FITable[i].I) scale = pDoc->FITable[i].I;
	}

	// then create string
	str="COM=";
	str+=MascotDlg.m_Comment;
	str+=crlf;
	ar.Write(str,str.GetLength());

	str="ITOL=1";
	str+=crlf;
	ar.Write(str,str.GetLength());

	str="ITOLU=Da";
	str+=crlf;
	ar.Write(str,str.GetLength());

	str="MASS=Monoisotopic";
	str+=crlf;
	ar.Write(str,str.GetLength());

	str="USERNAME=";
	str+=MascotDlg.m_Username;
	str+=crlf;
	ar.Write(str,str.GetLength());

	str="USEREMAIL=";
	str+=MascotDlg.m_UserEmailAddress;
	str+=crlf;
	ar.Write(str,str.GetLength());

	str="CHARGE=";
	massstr.Format("%d",MascotDlg.m_ChargeState);
	str+=massstr;
	if(pDoc->TrapVoltsOnDetect>=0) str+="+";
	else str+="-";
	str+=crlf;
	str+=crlf;
	str+=crlf;
	ar.Write(str,str.GetLength());

	str="BEGIN IONS";
	str+=crlf;
	ar.Write(str,str.GetLength());

	str="TITLE=";
	str+=MascotDlg.m_PrecursorIonName;
	str+=crlf;
	ar.Write(str,str.GetLength());

	str="PEPMASS=";
	massstr.Format("%1.5f",MascotDlg.m_PrecursorMass);
	str+=massstr;
	str+=crlf;
	ar.Write(str,str.GetLength());

	for(i=0;i<pDoc->PS.Spec[pDoc->CurrentSpectrumFocus].NumPeaks;i++) {
		freq=(float)pDoc->PS.Spec[pDoc->CurrentSpectrumFocus].FITable[i].F;
		amp=(float)pDoc->PS.Spec[pDoc->CurrentSpectrumFocus].FITable[i].I;

		mass=(float)pDoc->FreqToMass(freq, pDoc->PS.A, pDoc->PS.B);
		rel=(float)(double(amp)*100.0/scale);

		massstr.Format("%5.5f",mass);
		relstr.Format("%3.2f",rel);

		while(massstr.GetLength()<10) massstr = " "+massstr;
		while(relstr.GetLength()<6) relstr = " "+relstr;

		str=massstr+"   "+relstr;
		str+=crlf;
		ar.Write(str,str.GetLength());
	}

	str="END IONS";
	str+=crlf;
	ar.Write(str,str.GetLength());

	ar.Close();
}

#define DEMAXPOINTS 150000

void CExportDlg::OnExportDataExplorer() 
{
	// first get the document associated with the current active view
	// then create a new frame and view associated with it using the
	// m_pTextViewTemplate document template;
	
	// before creating the frame and view and all, check the number of 
	// data points that are to be displayed.  If it is > MAX_PTS_IN_TEXTVIEW,
	// ask before displaying them, and cancel if the user says no.

	if (pView->PlotType == MASSSPEC) {
		float minx, maxx;
		minx=(float)pView->zoomstack[pView->zoompointer].minx;
		maxx=(float)pView->zoomstack[pView->zoompointer].maxx;

		long minxpt, maxxpt;
		minxpt = pDoc->MassToPt(minx);
		maxxpt = pDoc->MassToPt(maxx);

		double mass, intensity;
		long i,j;


// ------------------------------------------------------
//		here starts the DataExporer export code
//		Created by:  Tomas Rejtar
//					 Northeastern University
//				     Sept 22, 2002
//		
//		purpose:  This code exports BUDA data to a file format
//		readable by the Applied Biosystems Data Explorer code
//		for use of their data analysis routines
//-------------------------------------------------------

		FILE *fw;
		CString str;
		float avg;
		long numpos;
//		max number of datapoints that DE can take is about 150000

//		simple C code that dumps data points directly to a file
//		works faster than using a buffer and much faster than using C++
//		that's why it's here

	CFileDialog *dlg;
	dlg = new CFileDialog(TRUE,"*.txt","Buda2DE.txt",OFN_HIDEREADONLY | OFN_LONGNAMES,"*.txt",NULL);
	dlg->m_ofn.lpstrFilter = "Text Files (*.txt)\0*.txt\0All Files (*.*)\0*.*\0";
	dlg->m_ofn.lpstrInitialDir = "C:\\Buda";

	if(dlg->DoModal()!=IDOK) return;
	CString path = dlg->GetPathName();
	avg=0;
	delete dlg;

		if ((fw = fopen(path, "w")) != NULL) {
			fprintf(fw, "TITLE \"FTMS spectrum\"\n");
			fprintf(fw, "TYPE MASSSPEC\n");
			if((minxpt-maxxpt)>DEMAXPOINTS) 
			{
				// get average
				// average is supposed to be an intensity value where <DEMAXPOINTS
				// and more than DEMAXPOINTS*0.95 data points are >average
				// 
				// then we will just output the points>average, thus keeping all 
				// valid data points and only ignoring the lowest abundance noise
				// values
				//
				avg=0;
				for(i=minxpt; i>maxxpt; i--) avg += pDoc->FreqArray[i]/(minxpt-maxxpt);
				avg=avg/2;  // estimate mean at avg/2
				for(j=0; j<10; j++) // max 10 iterations
				{
					numpos = 0; // count number of points above avg
					for(i=minxpt; i>maxxpt; i--)
					{
						if(pDoc->FreqArray[i]>avg) numpos++;
					}
					if((numpos<DEMAXPOINTS)&& numpos>(DEMAXPOINTS*0.95))
						break;
					// if numpos too low increase avg by DEMAXPOINTS/numpos
					if(numpos<DEMAXPOINTS) 
						avg=avg*DEMAXPOINTS/numpos; 
					// if numpos too high decrease avg by numpos/DEMAXPOINTS
					else if(numpos>(DEMAXPOINTS*0.95)) 
						avg=avg*numpos/DEMAXPOINTS;
				}
			}

			// now do the export of all points > avg

			for (i=minxpt; i>maxxpt; i=i--) {
				if(pDoc->FreqArray[i] < avg) continue;

				mass = pDoc->PtToMass(i);
				// multiply intensity by 100 to get reasonable values
				intensity = 100 * pDoc->FreqArray[i];
				fprintf(fw,"%5.4f \t %2.2f\n", mass, intensity);

			}
			if (fclose(fw) != EOF){
				str = ("Data exported to c:\\Buda\\Buda2DE.txt");
				pView->MessageBox(str,"Export finished", MB_OK );
			}
		} else {
				str = ("Error in export");
				pView->MessageBox(str,"Export failed", MB_OK );
		}
	}
}

void CExportDlg::OnExportTransientasText() 
{
	long i;

// ------------------------------------------------------
//		here starts the Transient Export as Ascii export code
//		Created by:  Peter O'Connor
//					 Boston University
//				     Oct 2, 2002
//		
//		purpose:  This code exports BUDA raw transient data as
//		ascii text
//-------------------------------------------------------

		FILE *fw;
		CString str;
//		simple C code that dumps data points directly to a file
//		works faster than using a buffer and much faster than using C++
//		that's why it's here

	CFileDialog *dlg;
	dlg = new CFileDialog(TRUE,"*.txt","BudaTransient.txt",OFN_HIDEREADONLY | OFN_LONGNAMES,"*.txt",NULL);
	dlg->m_ofn.lpstrFilter = "Text Files (*.txt)\0*.txt\0All Files (*.*)\0*.*\0";
	dlg->m_ofn.lpstrInitialDir = "C:\\Buda";

	if(dlg->DoModal()!=IDOK) return;
	CString path = dlg->GetPathName();
	delete dlg;

	if ((fw = fopen(path, "w")) != NULL) 
	{
		for(i=0; i<pDoc->PS.TransientPoints; i++) {
			fprintf(fw,"%ld\n", pDoc->TimeArray[i]);
		}
		if (fclose(fw) != EOF){
			str = ("Data exported to ")+path;
			pView->MessageBox(str,"Export finished", MB_OK );
		}
	} else {
			str = ("Error in export");
			pView->MessageBox(str,"Export failed", MB_OK );
	}

}
