/*M*
//
//               INTEL CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or
//  nondisclosure agreement with Intel Corporation and may not be copied
//  or disclosed except in accordance with the terms of that agreement.
//        Copyright (c) 1995 Intel Corporation. All Rights Reserved.
//
//  RCS:
//      $Source: $
//      $Revision: $
//      $Date: $
//
//  Purpose: 
*M*/

/*=== Definitions =========================================================*/

#if !defined (_NSPNORM_H) || defined (_OWN_BLDPCS)
# define _NSPNORM_H

#define NSP_C         0x01
#define NSP_L1        0x02
#define NSP_L2        0x04
#define NSP_RELATIVE  0x08

NSPAPI(float,  nspsNorm,(const float *srcA,  const float *srcB,  int n, int flag))
NSPAPI(float,  nspcNorm,(const SCplx *srcA,  const SCplx *srcB,  int n, int flag))
NSPAPI(double, nspdNorm,(const double *srcA, const double *srcB, int n, int flag))
NSPAPI(double, nspzNorm,(const DCplx  *srcA, const DCplx  *srcB, int n, int flag))
NSPAPI(float,  nspwNorm,(const short *srcA,  const short *srcB,  int n, int flag)) 
NSPAPI(float,  nspvNorm,(const WCplx *srcA,  const WCplx *srcB,  int n, int flag)) 

NSPAPI(void, nspsbNormalize,(const float *src,  float *dst,  int n,
                             float  offset, float factor))
NSPAPI(void, nspcbNormalize,(const SCplx *src,  SCplx *dst,  int n,
                             SCplx  offset, float factor))
NSPAPI(void, nspdbNormalize,(const double *src, double *dst, int n,
                             double offset, double factor))
NSPAPI(void, nspzbNormalize,(const DCplx  *src, DCplx  *dst, int n,
                             DCplx  offset, double factor))
NSPAPI(void, nspwbNormalize,(const short *src,  short *dst,  int n, 
                             short  offset, float factor))
NSPAPI(void, nspvbNormalize,(const WCplx *src,  WCplx *dst,  int n, 
                             WCplx  offset, float factor))

#endif
